<?php
/**
 * @package		PaidSystem
 * @copyright	Copyright (C) 2010-2013 JoomPROD.com. All rights reserved.
 *  @license GNU General Public License version 3, or later
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

require_once(JPATH_ROOT."/components/com_adsmanager/lib/core.php");

// no direct access
defined('_JEXEC') or die('Restricted access');

class AdsManagerImagePlugin {

	var $_db;
	
	function getListDisplay($content,$field)
	{
		return AdsManagerImagePlugin::getDetailsDisplay($content,$field);
	}

	function getDetailsDisplay($content,$field)
	{
		$fieldid = $field->fieldid;
		
		$fieldname = $field->name;
		$value = @$content->$fieldname;
		
		$return ="";
		
		if ($value != "")
		{
            $path = JURI::root().'images/com_adsmanager/images/'.$field->name.'/';
			$this->_db->setQuery("SELECT * FROM #__adsmanager_fields WHERE fieldid = $field->fieldid");
			$conf =$this->_db->loadObject();
            $confOptions = json_decode($conf->options);
			$return .= '<img src="'.$path.$value.'" width="'.$confOptions->width.'" height="'.$confOptions->height.'" />';
			$return .=	'<br/>';
		}
		return $return;
	}

	function getFormDisplay($content,$field,$default=null)
	{
		$fieldid = $field->fieldid;
		
		$fieldname = $field->name;
		$value = @$content->$fieldname;
        
        $imagePath = JURI::root().'images/com_adsmanager/images/'.$field->name.'/'.$value;
		$return =  'Image :';
       	$return .= '<div id="'.$field->name.'"><input type="file" size="30" mosReq="'.$field->required.'" mosLabel="'.htmlspecialchars($field->title).'" name="image'.$fieldid.'" value="" /></div><br/>';
		if($value != ''){
            $return .= 'image existante :<br/>';
            $return .= '<img src="'.$imagePath.'" width="200" height="200" />';
        }
        $return .= '<br/>';
		return $return;
	}

	function onFormSave(&$content,$field)
	{
		$files = JRequest::get( 'files' );
        $extensions = array("jpg","png","gif");
        
        if(isset( $files['image'.$field->fieldid])){
            $fileName = $files['image'.$field->fieldid]['name'];
            $fileExtension = strtolower(JFile::getExt($files['image'.$field->fieldid]['name']));
        }
        
        if (isset( $files['image'.$field->fieldid]) && !$files['image'.$field->fieldid]['error'] ) {
			$pict = JPATH_ROOT.'/images/com_adsmanager/images/'.$field->name.'/'.$fileName;
            if ( file_exists( $pict)) {
                JFile::delete( $pict);
            }
		}
        
        if (isset( $files['image'.$field->fieldid]) and !$files['image'.$field->fieldid]['error'] ) {
			
			if ($fileExtension == "jpeg")
				$fileExtension = "jpg";
            
            $this->_db->setQuery("SELECT * FROM #__adsmanager_fields WHERE fieldid = $field->fieldid");
			$conf =$this->_db->loadObject();
            $confOptions = json_decode($conf->options);
			
			switch($fileExtension) {
				case "jpg":
				case "png":
				case "gif":
					$path= JPATH_ROOT.'/images/com_adsmanager/images/'.$field->name.'/';
					$this->createImageAndThumb($files['image'.$field->fieldid]['tmp_name'],
										$fileName,
										$confOptions->width,
										$confOptions->height,
										"",
										$path,
										$files['image'.$field->fieldid]['name']);
					break;
				default:
					//Not supported
			}
			
			return $fileName;
		}
		return ;
	}
	
    function createImageAndThumb($src_file,$image_name,
                                $max_width,
                                $max_height,
                                $tag,
                                $path,
                                $orig_name)
    {
        if (intval(ini_get('memory_limit')) < 64)
            ini_set('memory_limit', '64M');
       
        $src_file = urldecode($src_file);
       
        $orig_name = strtolower($orig_name);

        jimport('joomla.filesystem.file');

        $ext = strtolower(JFile::getExt($orig_name));
        switch($ext) {
            case "jpg":
            case "jpeg":   
                $type = "jpeg";break;
            case "png":
                $type = "png";break;
            case "gif":
                $type = "gif";break;
            default:
                return;
        }
       
        $dst_ext = strtolower(JFile::getExt($image_name));
        switch($dst_ext) {
            case "jpg":
            case "jpeg":
                $dst_ext = "jpeg";break;
            case "png":
                $dst_ext = "png";break;
            case "gif":
                $dst_ext = "gif";break;
        }
       
        $max_h = $max_height;
        $max_w = $max_width;
       
        if ( file_exists( "$path/$image_name")) {
            JFile::delete( "$path/$image_name");
        }
       
        $read = 'imagecreatefrom' . $type;
        $write = 'image' . $type;
       
        $src_img = $read($src_file);
       
        // height/width
        $imginfo = getimagesize($src_file);
        $src_w = $imginfo[0];
        $src_h = $imginfo[1];
       
        //----------------------------------------------
       
        $zoom_h = $max_h / $src_h;
            $zoom_w = $max_w / $src_w;
            $zoom   = min($zoom_h, $zoom_w);
            $dst_h  = $zoom<1 ? round($src_h*$zoom) : $src_h;
            $dst_w  = $zoom<1 ? round($src_w*$zoom) : $src_w;
       
        $dst_img = imagecreatetruecolor($dst_w,$dst_h);
        if ($dst_ext == "jpeg") {
            $white = imagecolorallocate($dst_img,255,255,255);
            imagefill($dst_img,0,0,$white);
        } else {
            imagealphablending( $dst_img, false );
            imagesavealpha( $dst_img, true );
        }   
        imagecopyresampled($dst_img,$src_img, 0,0,0,0, $dst_w,$dst_h,$src_w,$src_h);
       
       
            if($type == 'jpeg'){
                    $desc_img = $this->createimage($write,$dst_img,"$path/$image_name", 75);
        }else{
                $desc_img = $this->createimage($write,$dst_img,"$path/$image_name", 2);
        }
       
        imagedestroy($dst_img);
       
       
    }
    
    function createimage($writefunction,$img,$destFile, $quality)
	{
		ob_start();
		$writefunction($img, null, $quality);
		$output = ob_get_contents();
		ob_end_clean();
		JFile::write($destFile, $output);
	}
    
	function onDelete($directory,$contentid = -1)
	{
	}
	
	function getEditFieldJavaScriptDisable()
	{
		$return = "elem=getObject('divImageOptions');";
        $return .= "elem.style.visibility = 'hidden';";
		$return .= "elem.style.display = 'none';";
		$return .= "elem=getObject('image_width');";
		$return .= "elem.setAttribute('mosReq',0);";
		$return .= "elem=getObject('image_height');";
		$return .= "elem.setAttribute('mosReq',0);";
		return $return;
	}
	
	function getEditFieldJavaScriptActive()
	{
        $return = "disableAll();";
		$return .= "elem=getObject('divImageOptions');";
        $return .= "elem.style.visibility = 'visible';";
        $return .= "elem.style.display = 'block';";
		$return .= "elem=getObject('image_width');";
		$return .= "elem.setAttribute('mosReq',1);";
		$return .= "elem=getObject('image_height');";
		$return .= "elem.setAttribute('mosReq',1);";
		return $return;
	}

	function getEditFieldOptions($fieldid)
	{
		$this->install();
		$this->_db->setQuery("SELECT * FROM #__adsmanager_fields WHERE fieldid = '$fieldid'");
		$row = $this->_db->loadObject();
        if($row != null)
            $rowOptions = json_decode($row->options);
        
		$return = "<div id='divImageOptions'>";
		$return .= "<table class='adminform'>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Image Width</td>";
		$return .= "<td width='20%' align=left><input type='text' id='image_width' name='options_image_width' mosReq=1 mosLabel='Image Width' class='inputbox' value='".@$rowOptions->width."' /></td>";
		$return .= "<td>&nbsp;</td>";
		$return .= "</tr>";
		$return .= "<tr>";
		$return .= "<td width='20%'>Image Height</td>";
		$return .= "<td width='20%' align=left><input type='text' id='image_height' name='options_image_height' mosReq=1 mosLabel='Image Height' class='inputbox' value='".@$rowOptions->height."' /></td>";
		$return .= "<td>&nbsp;</td>";
		$return .= "</tr>";
		$return .= "</table>";
		$return .= "</div>";
		return $return;
	}

	function saveFieldOptions($field)
	{
		
		return;
	}
	
	function getFieldName()
	{
		return "Image";
	}
	
    function install(){}
    
	function uninstall(){}
	
	function __construct()
	{
		$db	= JFactory::getDBO();
		$this->_db = $db;
	}
}

$plugins["image"] = new AdsManagerImagePlugin();
?>