<?php
/**
 * @package		PaidSystem
 * @copyright	Copyright (C) 2010-2013 JoomPROD.com. All rights reserved.
 *  @license GNU General Public License version 3, or later
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.controller');
JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_paidsystem'.DS.'tables');


/**
 * Content Component Controller
 *
 * @package		Joomla
 * @subpackage	Content
 * @since 1.5
 */
class PaidsystemControllerConfiguration extends TController
{
	function init()
	{
		// Set the default view name from the Request
		$this->_view = $this->getView("admin",'html');

		// Push a model into the view
		$this->_model = $this->getModel( "configuration");
		if (!JError::isError( $this->_model )) {
			$this->_view->setModel( $this->_model, true );
		}
	}
	
	function display($cachable = false, $urlparams = false)
	{
		$this->init();
		$this->_view->setLayout("configuration");
		$this->_view->display();
	}
	
	function save()
	{
		$app = JFactory::getApplication();
		
		$conf = JTable::getInstance('paidconfiguration', 'PaidsystemTable');

		// bind it to the table
		if (!$conf -> bind(JRequest::get('post'))) {
			return JError::raiseWarning( 500, $conf->getError() );
		}
		// store it in the db
		if (!$conf -> store()) {
			return JError::raiseWarning( 500, $conf->getError() );
		}	
	
		$app->redirect( 'index.php?option=com_paidsystem&c=configuration', JText::_('PAIDSYSTEM_CONFIGURATION_SAVED'),"message" );
	}
	
	function export_virtualmoney($redirect = true)
	{
		$app = JFactory::getApplication();
		$db = JFactory::getDbo();
		
		$query ="SELECT * FROM #__paidsystem_credits";
		$db->setQuery($query);
		$credits = $db->loadObjectList();
		
        $query ="SELECT * FROM #__virtualmoney_credits";
		$db->setQuery($query);
		$creditss = $db->loadObjectList();
        
		foreach($credits as $credit) {
			
			$query ="DELETE FROM #__virtualmoney_credits WHERE user_id = ".(int)$credit->userid;
			$db->setQuery($query);
			$db->query();
            
			$data = new stdClass();
			$data->user_id = $credit->userid;
			$data->credits = $credit->credit;
            
			$db->insertObject('#__virtualmoney_credits', $data);	
		}
		
		$query = "RENAME TABLE #__paidsystem_credits TO #__paidsystem_credits_old";
		$db->setQuery($query);
		$db->query();
		
		$query ="SELECT * FROM #__paidsystem_pack";
		$db->setQuery($query);
		$packs = $db->loadObjectList();
		
		$query ="SELECT MAX(virtualmoney_pack_id) as max_pack_id FROM #__virtualmoney_packs";
		$db->setQuery($query);
		$maxPackId = $db->loadResult();
        if($maxPackId == null) {
            $maxPackId = 0;
        }
		
		foreach($packs as $pack) {
			$maxPackId += 1;
			$query ="DELETE FROM #__paidsystem_pack WHERE id = ".(int)$pack->id;
			$db->setQuery($query);
			$db->query();
			
			$data = new stdClass();
			$data->virtualmoney_pack_id = $maxPackId;
			$data->title = $pack->title;
			$data->price = $pack->price;
			$data->credits = $pack->credits;
			$data->currency_id = 0;
			$data->ordering = $pack->ordering;
			$data->enabled = $pack->published;
			$db->insertObject('#__virtualmoney_packs', $data);	
		}
		
		$query = "RENAME TABLE #__paidsystem_pack TO #__paidsystem_pack_old";
		$db->setQuery($query);
		$db->query();
		
		if($redirect)
			$app->redirect( 'index.php?option=com_paidsystem&c=configuration', JText::_('PAIDSYSTEM_EXPORT_VIRTUALMONEY_DONE'),"message" );
	}
	
	function export_invoicing($redirect = true)
	{
		require_once(JPATH_ROOT.'/components/com_invoicing/lib/core.php');
		
		$app = JFactory::getApplication();
		$db = JFactory::getDbo();
		
		$query ="SELECT * FROM #__paidsystem_coupons";
		$db->setQuery($query);
		$coupons = $db->loadObjectList();
		$i = 1;
		$listcoupons = array();
		foreach($coupons as $coupon) {
			$data=array();
			//$data['invoicing_coupon_id']=$i;
			$data['title']= $coupon->code;
			$data['code']= $coupon->code;
			$list = explode(',',$coupon->itemtype);
			$newlist = array();
			foreach($list as $itemtype) {
				$newlist[] = "adsmanager-".$itemtype;
			}
			$apply_on = implode(',',$newlist);
			$data['apply_on'] = $apply_on;
			$data['valuetype']= $coupon->coupontype;
			$data['value']= $coupon->amount;
			$data['enabled']=$coupon->published;
			$data['ordering']=$i;
			$listcoupons[$coupon->code] = $i;
			$data=(object)$data;
			$db->insertObject('#__invoicing_coupons', $data);
			$i++;
		}
		
		$query = "RENAME TABLE #__paidsystem_coupons to #__paidsystem_coupons_old";
		$db->setQuery($query);
		$db->query();
	
        $query ="SELECT * FROM #__paidsystem_config";
		$db->setQuery($query);
		$config = $db->loadObject();
        
        if($config->tax != ''){
            $query ="SELECT * FROM #__invoicing_taxes";
            $db->setQuery($query);
            $taxes = $db->loadObjectList();
            
            $tagTax = true;
            
            foreach($taxes as $tax) {
                if($tax->taxrate == $config->tax)
                    $tagTax = false;
            }
            
            if($tagTax) {
                $data = array();
                $data['taxrate'] = $config->tax;
                $data['ordering'] = 0;
                $data['created_on'] = date('Y-m-d H:i:s');
                $data=(object)$data;
                $db->insertObject('#__invoicing_taxes', $data);
            }
            $tax = $config->tax;
        } else {
            $tax = 0;
        }
        
        $query ="SELECT * FROM #__paidsystem_orders";
		$db->setQuery($query);
		$orders = $db->loadObjectList();
        
		$query ="SELECT MAX(order_number) as order_number FROM #__invoicing_invoices";
		$db->setQuery($query);
		$maxOrderNumber = $db->loadResult();
        if($maxOrderNumber == null) {
            $maxOrderNumber = 0;
        }
        
        $query ="SELECT MAX(invoice_number) as invoice_number FROM #__invoicing_invoices";
		$db->setQuery($query);
		$maxInvoiceNumber = $db->loadResult();
        if($maxInvoiceNumber == null) {
            $maxInvoiceNumber = 0;
        }
        
		foreach($orders as $p ) {
			$p = (array) $p;
			
			$sql = "SELECT invoicing_user_id FROM #__invoicing_users WHERE user_id = ".(int)$p['userid'];
			$db->setQuery($sql);
			$invoicing_user_id = $db->loadResult();
			if($invoicing_user_id == null) {
				FOFModel::getTmpInstance('Users','InvoicingModel')->createUser($p['userid']);
				$sql = "SELECT invoicing_user_id FROM #__invoicing_users WHERE user_id = ".(int)$p['userid'];
				$db->setQuery($sql);
				$invoicing_user_id = $db->loadResult();
			}
	
			$items = json_decode($p['items'],true);
			$couponfound = false;
			$coupontotal = 0;
			$couponcode = -1;
			foreach($items as $key => $i) {
				if ($i['type'] == "coupon") {
					$name = str_replace("Code Promo : ","",$i['name']);
					if (isset($listcoupons[$name])) {
						$couponcode = $listcoupons[$name];
					}
					$couponfound = true;
					$coupontotal = -1 * $i['value'];
					unset($items[$key]);
				}
			}
	
			$data = array();
			//$data['invoicing_invoice_id'] = $p['id'];
			$data['order_number'] = $p['num'];
			$data['invoice_number'] = $p['num'];
			$data['user_id'] = $invoicing_user_id;
			$data['vendor_id'] = 1;
			switch($p['state']) {
				case "confirmed":
					$data['status'] = "PAID";break;
				case "pending":
					$data['status'] = "PENDING";break;
				case "new":
					$data['status'] = "NEW";break;
	
			}
			$data['created_on'] = $p['date'];
			$data['created_by'] = $p['userid'];
			$data['due_date'] = $p['date'];
			$data['notes'] = "";
			$data['processor'] = strtolower($p['gateway']);
			$data['processor_key'] = "";
	
			$data['net_subamount'] = $p['total_incl'];
			$data['tax_subamount'] = $p['total_incl']-$p['total'];
			$data['gross_subamount'] = $p['total'];
	
			$data['custom_discount'] = 0;
			$data['net_discount_amount'] = $coupontotal;
			$data['gross_discount_amount'] = number_format($coupontotal/1.196,2);
			$data['tax_discount_amount'] = $coupontotal - number_format($coupontotal/1.196,2);
	
			$data['net_amount'] = $p['total_incl'];
			$data['gross_amount'] = $p['total'];
			$data['tax_amount'] = $p['total_incl']-$p['total'];
			$data['coupon_id'] = $couponcode;
			$data['currency_id'] = 1;
			//$data['language'] = $p['fr-FR'];
			$data['ip_address'] = "";
			$data['generator'] = "adsmanager";
			$data['generator_key'] = $p['pending_id'];
			$data['params'] = "";
			$data['coupon_type'] = "";
			$data['discount_type'] = "percent";
			$data['discount_value'] = 0;
	
			$data=(object)$data;
			$db->insertObject('#__invoicing_invoices',$data);
			$invoice_id = $db->insertid();
			$next = 1;
			foreach($items as $i) {
				$item = array();
				$item['invoice_id'] = $invoice_id;
				$item['description'] = $i['name'];
				$item['quantity'] = 1;
                if($tax != 0){
                    $item['gross_unit_price'] = number_format($i['value'] / (1+$config->tax/100),2);
                    $item['tax'] = number_format($config->tax,2);
                }else{
                    $item['gross_unit_price'] = $i['value'];
                    $item['tax'] = 0;
                }
				$item['net_unit_price'] = $i['value'];
				$item['net_amount'] = $i['value'];
				//$item['gross_amount'] = $i[''];
				$item['source'] = "adsmanager-".$i['type'];
				$item['source_key'] = "";
				$item['ordering'] = $next++;
				$item['params'] = "";
				$item=(object)$item;
				$db->insertObject('#__invoicing_invoice_items',$item);
			}
		}
	
		$db->setQuery("SELECT MAX(order_number) as order_number,MAX(invoice_number) as invoice_number FROM #__invoicing_invoices");
		$result = $db->loadObject();
		$order_number_counter  = $result->order_number +1;
		$invoice_number_counter  = $result->invoice_number +1;
	
		InvoicingHelperCparams::setParam($order_number_counter,'order_number_counter');
		InvoicingHelperCparams::setParam($invoice_number_counter,'invoice_number_counter');
		
		$query = "RENAME TABLE #__paidsystem_orders TO #__paidsystem_orders_old";
		$db->setQuery($query);
		$db->query();
		
		if($redirect)
			$app->redirect( 'index.php?option=com_paidsystem&c=configuration', JText::_('PAIDSYSTEM_EXPORT_INVOICING_DONE'),"message" );
	}
	
	function export_all(){
		$this->export_virtualmoney(false);
		$this->export_invoicing(false);
		
		$app = JFactory::getApplication();
		$app->redirect( 'index.php?option=com_paidsystem&c=configuration', JText::_('PAIDSYSTEM_EXPORT_ALL_DONE'),"message" );
	}
}
