<?php
/**
 *  @package Virtualmoney
 *  @copyright Copyright (c)2013 JoomPROD
 *  @license GNU General Public License version 3, or later
 */

defined('_JEXEC') or die();

include_once(JPATH_ADMINISTRATOR.'/components/com_virtualmoney/helpers/cparams.php');
 
include_once(JPATH_ADMINISTRATOR.'/components/com_virtualmoney/helpers/format.php');

jimport( 'joomla.filesystem.file' );
define("VIRTUALMONEY_OFFER_CREDIT",1);
define("VIRTUALMONEY_RECEIVE_CREDIT",2);
	
/* 	1   vous avez envoyé des crédits
	2 	votre avez reçu des crédits */
	
	
class VirtualmoneyHelperMail {
   
    /**
     * Mail function (uses phpMailer)
     *
     * @param   string   $from         From email address
     * @param   string   $fromname     From name
     * @param   mixed    $recipient    Recipient email address(es)
     * @param   string   $subject      Email subject
     * @param   string   $body         Message body
     * @param   boolean  $mode         False = plain text, true = HTML
     * @param   mixed    $cc           CC email address(es)
     * @param   mixed    $bcc          BCC email address(es)
     * @param   mixed    $attachment   Attachment file name(s)
     * @param   mixed    $replyto      Reply to email address(es)
     * @param   mixed    $replytoname  Reply to name(s)
     *
     * @return  boolean  True on success
     *
     * @see     JMail::sendMail()
     * @since   11.1
     */
    protected static function sendMail($from, $fromname, $recipient, $subject, $body, $mode = 0, $cc = null, $bcc = null, $attachment = null,
                $replyto = null, $replytoname = null)
    {	
        if (version_compare(JVERSION,'2.5.0','>=')) {
            // Get a JMail instance
			$mail = JFactory::getMailer();
            $send = $mail->sendMail($from, $fromname, $recipient, $subject, $body, $mode, $cc, $bcc, $attachment,$replyto,$replytoname);

        } else {
            $send = JUtility::sendMail($from, $fromname, $recipient, $subject, $body, $mode, $cc, $bcc, $attachment,$replyto,$replytoname);
        }
		$type = gettype($send);
		if(is_object($send)) {
			$send = $send->getMessage() ;
		}
		return $send;
    }

    /**
     * 
     * @param object $item
     * @return boolean
     */
	public static function sendMailByStatus($item) {
        
        $user1 = JFactory::getUser($item->user1_id);
        $user2 = JFactory::getUser($item->user2_id);

		$body = "undefined";
		$status = $item->status;

		switch($status) {
			case 'offer_credit': $emailid = VIRTUALMONEY_OFFER_CREDIT;break;
			case 'receive_credit': $emailid = VIRTUALMONEY_RECEIVE_CREDIT;break;
			default: $emailid = null;
		}	 
		if ($emailid == null)
			return;

		$emails = FOFModel::getTmpInstance('Emails','VirtualmoneyModel');
		$email = $emails->getItem($emailid);

		$admin = JFactory::getUser();
		$from = $admin->email;
		$fromname = $admin->name;
		
		if(!isset($from) || $from == '' ){
			if (version_compare(JVERSION,'3.0.0','>=')) {
				$versionJoomla = 1;
			} else {
				$versionJoomla = 0;
			}
			$config	= JFactory::getConfig();
			$from = $versionJoomla ? $config->get('mailfrom') : $config->getValue('config.mailfrom');
			$fromname = $versionJoomla ? $config->get('fromname') : $config->getValue('config.fromname');
		}
		
		if ($from == "") {
			echo "You need to set email in invoicing configuration";
			return;
		}
		
		$recipient1 = $user1->email;
		$recipient2 = $user2->email;

		$email->content = VirtualmoneyHelperFormat::replaceTags($email->content,$user1,$user2);
		$email->subject = VirtualmoneyHelperFormat::replaceTags($email->subject,$user1,$user2);

		switch($status) {
			case 'offer_credit': $emailidNotice = VIRTUALMONEY_OFFER_CREDIT;break;
			case 'receive_credit': $emailidNotice = VIRTUALMONEY_RECEIVE_CREDIT;break;
			default: $emailidNotice = null;
		}	 
			
		if ($emailidNotice == null)
			return;

		$emailNotice = FOFModel::getTmpInstance('Emails','VirtualmoneyModel')
						->savestate(0)
						->getItem($emailidNotice);
			

		$emailNotice->content = VirtualmoneyHelperFormat::replaceTags($emailNotice->content,$user1,$user2);
		$emailNotice->subject = VirtualmoneyHelperFormat::replaceTags($emailNotice->subject,$user1,$user2);

		if ($email->enabled) {	
			 $resultUser = self::sendMail($from, $fromname,$recipient1, $email->subject, $email->content, 1, null, null, null);
		}		

 		if ($emailNotice->enabled ) {
		 	$resultAdmin = self::sendMail($from, $fromname, $recipient2, $emailNotice->subject, $emailNotice->content, 1, null,null, null); 
		} 
		require_once(JPATH_ROOT.'/components/com_uddeim/uddeim.api.php');
		$class = new uddeIMAPI();
		$class->sendNewMessage($user1->id, $user2->id, $emailNotice->content);

 		if (!is_bool($resultUser) && !is_bool($resultAdmin))
			return false;  	
		
		return $resultUser;
	}
	
}