<?php

/**
 *  @package Virtualmoney
 *  @copyright Copyright (c)2013 JoomPROD
 *  @license GNU General Public License version 3, or later
 */

defined('_JEXEC') or die();

include_once('cparams.php');

class VirtualmoneyHelperUser {
    static public function getList() {
        $db = JFactory::getDbo();
        $sql = "SELECT u.id, u.name, u.username, u.email FROM #__users u ORDER BY username";
		$db->setQuery($sql);
		$results = $db->loadObjectList();
		return $results;
    }
    
    static public function getUsername($user) {
        $userDisplayType = VirtualmoneyHelperCparams::getParam('username_display_format');
        
        if($userDisplayType == 'name')
            return $user->name;
        else
            return $user->username;
    }
	
	protected static function genericlist($list, $name, $attribs, $selected, $idTag)
	{
		if(empty($attribs))
		{
			$attribs = null;
		}
		else
		{
			$temp = '';
			foreach($attribs as $key=>$value)
			{
				$temp .= $key.' = "'.$value.'"';
			}
			$attribs = $temp;
		}

		return JHTML::_('select.genericlist', $list, $name, $attribs, 'value', 'text', $selected, $idTag);
	}
	
	public static function joomlausers($name = 'user_id', $selected = 0, $attribs = array())
	{
        $db = JFactory::getDBO();
        
        $userDisplayType = VirtualmoneyHelperCparams::getParam('username_display_format','u.name');
        
        if(!$selected){
            $query = FOFQueryAbstract::getNew($db)
                ->select('vc.user_id')
                ->from("#__virtualmoney_credits as vc");
            $db->setQuery($query);
            $usersCredit = $db->loadResultArray();

            if(empty($usersCredit)){
                $listUsersCredit = '';
            } else {
                $listUsersCredit = ' WHERE u.id NOT IN ('.implode(',', $usersCredit).') ';
            }

            $sql = "SELECT u.id, u.name, u.username, u.email 
                    FROM #__users u 
                    ".$listUsersCredit."
                    ORDER BY ".$userDisplayType." ASC";
            $db->setQuery($sql);
            $users = $db->loadObjectList();
            $options = array();
            $options[] = JHTML::_('select.option','','- '.JText::_('COM_VIRTUALMONEY_COMMON_SELECT_USER').' -');
            foreach($users as $user) {
                if($userDisplayType == 'name')
                    $userDisplay = $user->name;
                else
                    $userDisplay = $user->username;
                $options[] = JHTML::_('select.option',$user->id,$userDisplay);
            }

            $html = self::genericlist($options, $name, $attribs, $selected, $name);
        } else {
            $query = FOFQueryAbstract::getNew($db)
                ->select('*')
                ->from("#__users as u")
                ->where("u.id = ".$db->Quote($selected));
            $db->setQuery($query);
            $user = $db->loadObject();
            
            if($userDisplayType == 'name')
                $userDisplay = $user->name;
            else
                $userDisplay = $user->username;
            $html = htmlspecialchars($userDisplay);
            $html .= '<input type="hidden" name="'.htmlspecialchars($name).'" value="'.$user->id.'" id="'.htmlspecialchars($name).'" />';
        }
		return $html;
	}
}