<?php
/**
 *  @package	PaidSystem
 *  @copyright	Copyright (c)2010-2012 Thomas Papin / JoomPROD.com
 *  @license	GNU GPLv3 <http://www.gnu.org/licenses/gpl.html> or later
 *  @version 	$Id$
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// no direct access
defined('_JEXEC') or die();

jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');

class Com_PaidsystemInstallerScript
{
	/** @var string The component's name */
	protected $_paidsystem_extension = 'com_paidsystem';
	
	/** @var array The list of extra modules and plugins to install */
	private $installation_queue = array(
		// modules => { (folder) => { (module) => { (position), (published) } }* }*
		'modules' => array(
			'admin' => array(
			//	'adsmanager_quickicons' => array('icon', 1) //GOLD_TAG
			),
			'site' => array(
				//'paidsystem_feat' => array('left', 0)
			)
		),
		'plugins' => array(
            'invoicinggenerator' => array(
				'adsmanager'				=> 1
               // 'buybutton'                 => 1
			),	
		),
		'adsmanagerfields' => array(
		)
	);
	
	private $paidsystemRemovePlugins = array(
		'paidsystemsubs' => array(
		)
	);
	
	/** @var array Obsolete files and folders to remove */
	private $paidsystemRemoveFiles = array(
		'files'	=> array(
			'administrator/components/com_paidsystem/admin.paidsystem.php',
			'administrator/components/com_paidsystem/admin.paidsystem.html.php'
		),
		'folders' => array(
			/*'administrator/components/com_paidsystemsubs/commands',*/
		)
	);
	
	private $paidsystemCliScripts = array();
	
	/**
	 * Joomla! pre-flight event
	 * 
	 * @param string $type Installation type (install, update, discover_install)
	 * @param JInstaller $parent Parent object
	 */
	public function preflight($type, $parent)
	{
		// Bugfix for "Can not build admin menus"
		if(in_array($type, array('install','discover_install'))) {
			$this->_bugfixDBFunctionReturnedNoError();
		} else {
			$this->_bugfixCantBuildAdminMenus();
		}
		
		// Only allow to install on Joomla! 2.5.1 or later
		if(!version_compare(JVERSION, '2.5.1', 'ge')) {
			echo "<h1>Unsupported Joomla! version</h1>";
			echo "<p>This component can only be installed on Joomla! 2.5.1 or later</p>";
			return false;
		}
		return true;
	}
	
	function install($parent) {
        
		$this->_updateDatabase(); }
	function update($parent) { 
		/*$db = JFactory::getDbo();
		$db->setQuery(" ALTER IGNORE TABLE `#__paidsystem_config` ADD `currency_id` INTEGER DEFAULT NULL;");
		try {
			$result = $db->query();
		} catch(Exception $e) {
		
		}
		$db->setQuery(" ALTER IGNORE TABLE `#__paidsystem_config` ADD `params` TEXT DEFAULT NULL;");
		try {
			$result = $db->query();
		} catch(Exception $e) {
		
		}*/
	
        $this->_updateDatabase(); }
	
	/**
	 * Runs after install, update or discover_update
	 * @param string $type install, update or discover_update
	 * @param JInstaller $parent 
	 */
	function postflight( $type, $parent )
	{
		// Install subextensions
		$status = $this->_installSubextensions($parent);
		
		// Remove obsolete files and folders
		$paidsystemRemoveFiles = $this->paidsystemRemoveFiles;
		$this->_removeObsoleteFilesAndFolders($paidsystemRemoveFiles);
		
		$this->_copyCliFiles($parent);
		
		// Remove Professional version plugins from Akeeba Backup Core
		$this->_removeObsoletePlugins($parent);
		
		$straperStatus = 0;
		$fofStatus = 0;
		
		// Show the post-installation page
		$this->_renderPostInstallation($status, $fofStatus, $straperStatus, $parent);
		
		// Kill update site
		//$this->_killUpdateSite();
	}
	
	/**
	 * Runs on uninstallation
	 * 
	 * @param JInstaller $parent 
	 */
	function uninstall($parent)
	{
		// Uninstall subextensions
		$status = $this->_uninstallSubextensions($parent);
		
		// Show the post-uninstallation page
		$this->_renderPostUninstallation($status, $parent);
	}
	
	/**
	 * Removes the plugins which have been discontinued
	 * 
	 * @param JInstaller $parent 
	 */
	private function _removeObsoletePlugins($parent)
	{
		if( version_compare( JVERSION, '1.6.0', 'ge' ) ) {
			$src = $parent->getParent()->getPath('source');
		} else {
			$src = $parent->getPath('source');
		}
		$db = JFactory::getDbo();
		
		foreach($this->paidsystemRemovePlugins as $folder => $plugins) {
			foreach($plugins as $plugin) {
				$sql = $db->getQuery(true)
					->select($db->qn('extension_id'))
					->from($db->qn('#__extensions'))
					->where($db->qn('type').' = '.$db->q('plugin'))
					->where($db->qn('element').' = '.$db->q($plugin))
					->where($db->qn('folder').' = '.$db->q($folder));
				$db->setQuery($sql);
				$id = $db->loadResult();
				if($id)
				{
					$installer = new JInstaller;
					$result = $installer->uninstall('plugin',$id,1);
				}
			}
		}
	}
	
	/**
	 * Copies the CLI scripts into Joomla!'s cli directory
	 * 
	 * @param JInstaller $parent 
	 */
	private function _copyCliFiles($parent)
	{
		if( version_compare( JVERSION, '1.6.0', 'ge' ) ) {
			$src = $parent->getParent()->getPath('source');
		} else {
			$src = $parent->getPath('source');
		}
		
		jimport("joomla.filesystem.file");
		jimport("joomla.filesystem.folder");
		
		if(empty($this->paidsystemCliScripts)) {
			return;
		}
		
		foreach($this->paidsystemCliScripts as $script) {
			if(JFile::exists(JPATH_ROOT.'/cli/'.$script)) {
				JFile::delete(JPATH_ROOT.'/cli/'.$script);
			}
			if(JFile::exists($src.'/cli/'.$script)) {
				JFile::move($src.'/cli/'.$script, JPATH_ROOT.'/cli/'.$script);
			}
		}
	}
	
	/**
	 * Renders the post-installation message 
	 */
	private function _renderPostInstallation($status, $fofStatus, $straperStatus, $parent)
	{
?>
<?php if (!version_compare(PHP_VERSION, '5.3.0', 'ge')): ?>
	<div style="margin: 1em; padding: 1em; background: #ffff00; border: thick solid red; color: black; font-size: 14pt;" id="notfixedperms">
		<h1 style="margin: 1em 0; color: red; font-size: 22pt;">OUTDATED PHP VERSION</h1>
		<p>You are using an outdated version of PHP which is not properly supported by JoomPROD.com. Please upgrade to PHP 5.3 or later as soon as possible. Future versions of our software will not work at all on PHP 5.2.</p>
	</div>
<?php endif; ?>
<h1>PaidSystem</h1>

<?php $rows = 1;?>
<img src="../components/com_paidsystem/images/logo.png" width="48" height="48" alt="PaidSystem" align="left" />
<h2 style="font-size: 14pt; font-weight: black; padding: 0; margin: 0 0 0.5em;">Welcome to PaidSystem!</h2>
<span>Add Payment Feature to Adsmanager</span>

<table class="adminlist table table-striped" width="100%">
	<thead>
		<tr>
			<th class="title" colspan="2">Extension</th>
			<th width="30%">Status</th>
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td colspan="3"></td>
		</tr>
	</tfoot>
	<tbody>
		<tr class="row0">
			<td class="key" colspan="2">
				<img src="../components/com_paidsystem/images/logo.png" width="16" height="16" alt="PaidSystem" align="left" />
				&nbsp;
				PaidSystem component
			</td>
			<td><strong style="color: green">Installed</strong></td>
		</tr>
		<?php if (count($status->modules)) : ?>
		<tr>
			<th>Module</th>
			<th>Client</th>
			<th></th>
		</tr>
		<?php foreach ($status->modules as $module) : ?>
		<tr class="row<?php echo ($rows++ % 2); ?>">
			<td class="key"><?php echo $module['name']; ?></td>
			<td class="key"><?php echo ucfirst($module['client']); ?></td>
			<td><strong style="color: <?php echo ($module['result'])? "green" : "red"?>"><?php echo ($module['result'])?'Installed':'Not installed'; ?></strong></td>
		</tr>
		<?php endforeach;?>
		<?php endif;?>
		<?php if (count($status->plugins)) : ?>
		<tr>
			<th>Plugin</th>
			<th>Group</th>
			<th></th>
		</tr>
		<?php foreach ($status->plugins as $plugin) : ?>
		<tr class="row<?php echo ($rows++ % 2); ?>">
			<td class="key"><?php echo ucfirst($plugin['name']); ?></td>
			<td class="key"><?php echo ucfirst($plugin['group']); ?></td>
			<td><strong style="color: <?php echo ($plugin['result'])? "green" : "red"?>"><?php echo ($plugin['result'])?'Installed':'Not installed'; ?></strong></td>
		</tr>
		<?php endforeach; ?>
		<?php endif; ?>
	</tbody>
</table>
<?php
	}
	
	private function _renderPostUninstallation($status, $parent) {
?>
<?php $rows = 0;?>
<h2 style="font-size: 14pt; font-weight: black; padding: 0; margin: 0 0 0.5em;">&nbsp;PaidSystem Uninstallation</h2>
<p>We are sorry that you decided to uninstall PaidSystem. Please let us know why by using the Contact Us form on our site. We appreciate your feedback; it helps us develop better software!</p>

<table class="adminlist">
	<thead>
		<tr>
			<th class="title" colspan="2"><?php echo JText::_('Extension'); ?></th>
			<th width="30%"><?php echo JText::_('Status'); ?></th>
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td colspan="3"></td>
		</tr>
	</tfoot>
	<tbody>
		<tr class="row0">
			<td class="key" colspan="2"><?php echo 'PaidSystem '.JText::_('Component'); ?></td>
			<td><strong style="color: green"><?php echo JText::_('Removed'); ?></strong></td>
		</tr>
		<?php if (count($status->modules)) : ?>
		<tr>
			<th><?php echo JText::_('Module'); ?></th>
			<th><?php echo JText::_('Client'); ?></th>
			<th></th>
		</tr>
		<?php foreach ($status->modules as $module) : ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo $module['name']; ?></td>
			<td class="key"><?php echo ucfirst($module['client']); ?></td>
			<td><strong style="color: <?php echo ($module['result'])? "green" : "red"?>"><?php echo ($module['result'])?JText::_('Removed'):JText::_('Not removed'); ?></strong></td>
		</tr>
		<?php endforeach;?>
		<?php endif;?>
		<?php if (count($status->plugins)) : ?>
		<tr>
			<th><?php echo JText::_('Plugin'); ?></th>
			<th><?php echo JText::_('Group'); ?></th>
			<th></th>
		</tr>
		<?php foreach ($status->plugins as $plugin) : ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
			<td class="key"><?php echo ucfirst($plugin['name']); ?></td>
			<td class="key"><?php echo ucfirst($plugin['group']); ?></td>
			<td><strong style="color: <?php echo ($plugin['result'])? "green" : "red"?>"><?php echo ($plugin['result'])?JText::_('Removed'):JText::_('Not removed'); ?></strong></td>
		</tr>
		<?php endforeach; ?>
		<?php endif; ?>
	</tbody>
</table>
<?php
	}
	
	/**
	 * Joomla! 1.6+ bugfix for "DB function returned no error"
	 */
	private function _bugfixDBFunctionReturnedNoError()
	{
		$db = JFactory::getDbo();
			
		// Fix broken #__assets records
		$query = $db->getQuery(true);
		$query->select('id')
			->from('#__assets')
			->where($db->qn('name').' = '.$db->q($this->_paidsystem_extension));
		$db->setQuery($query);
		$ids = $db->loadColumn();
		if(!empty($ids)) foreach($ids as $id) {
			$query = $db->getQuery(true);
			$query->delete('#__assets')
				->where($db->qn('id').' = '.$db->q($id));
			$db->setQuery($query);
			$db->query();
		}

		// Fix broken #__extensions records
		$query = $db->getQuery(true);
		$query->select('extension_id')
			->from('#__extensions')
			->where($db->qn('element').' = '.$db->q($this->_paidsystem_extension));
		$db->setQuery($query);
		$ids = $db->loadColumn();
		if(!empty($ids)) foreach($ids as $id) {
			$query = $db->getQuery(true);
			$query->delete('#__extensions')
				->where($db->qn('extension_id').' = '.$db->q($id));
			$db->setQuery($query);
			$db->query();
		}

		// Fix broken #__menu records
		$query = $db->getQuery(true);
		$query->select('id')
			->from('#__menu')
			->where($db->qn('type').' = '.$db->q('component'))
			->where($db->qn('menutype').' = '.$db->q('main'))
			->where($db->qn('link').' LIKE '.$db->q('index.php?option='.$this->_paidsystem_extension));
		$db->setQuery($query);
		$ids = $db->loadColumn();
		if(!empty($ids)) foreach($ids as $id) {
			$query = $db->getQuery(true);
			$query->delete('#__menu')
				->where($db->qn('id').' = '.$db->q($id));
			$db->setQuery($query);
			$db->query();
		}
	}
	
	/**
	 * Joomla! 1.6+ bugfix for "Can not build admin menus"
	 */
	private function _bugfixCantBuildAdminMenus()
	{
		$db = JFactory::getDbo();
		
		// If there are multiple #__extensions record, keep one of them
		$query = $db->getQuery(true);
		$query->select('extension_id')
			->from('#__extensions')
			->where($db->qn('element').' = '.$db->q($this->_paidsystem_extension));
		$db->setQuery($query);
		$ids = $db->loadColumn();
		if(count($ids) > 1) {
			asort($ids);
			$extension_id = array_shift($ids); // Keep the oldest id
			
			foreach($ids as $id) {
				$query = $db->getQuery(true);
				$query->delete('#__extensions')
					->where($db->qn('extension_id').' = '.$db->q($id));
				$db->setQuery($query);
				$db->query();
			}
		}
		
		// @todo
		
		// If there are multiple assets records, delete all except the oldest one
		$query = $db->getQuery(true);
		$query->select('id')
			->from('#__assets')
			->where($db->qn('name').' = '.$db->q($this->_paidsystem_extension));
		$db->setQuery($query);
		$ids = $db->loadObjectList();
		if(count($ids) > 1) {
			asort($ids);
			$asset_id = array_shift($ids); // Keep the oldest id
			
			foreach($ids as $id) {
				$query = $db->getQuery(true);
				$query->delete('#__assets')
					->where($db->qn('id').' = '.$db->q($id));
				$db->setQuery($query);
				$db->query();
			}
		}

		// Remove #__menu records for good measure!
		$query = $db->getQuery(true);
		$query->select('id')
			->from('#__menu')
			->where($db->qn('type').' = '.$db->q('component'))
			->where($db->qn('menutype').' = '.$db->q('main'))
			->where($db->qn('link').' LIKE '.$db->q('index.php?option='.$this->_paidsystem_extension));
		$db->setQuery($query);
		$ids1 = $db->loadColumn();
		if(empty($ids1)) $ids1 = array();
		$query = $db->getQuery(true);
		$query->select('id')
			->from('#__menu')
			->where($db->qn('type').' = '.$db->q('component'))
			->where($db->qn('menutype').' = '.$db->q('main'))
			->where($db->qn('link').' LIKE '.$db->q('index.php?option='.$this->_paidsystem_extension.'&%'));
		$db->setQuery($query);
		$ids2 = $db->loadColumn();
		if(empty($ids2)) $ids2 = array();
		$ids = array_merge($ids1, $ids2);
		if(!empty($ids)) foreach($ids as $id) {
			$query = $db->getQuery(true);
			$query->delete('#__menu')
				->where($db->qn('id').' = '.$db->q($id));
			$db->setQuery($query);
			$db->query();
		}
	}
	
	function _updateDatabase() {
		// Schema modification -- BEGIN
		
		if(version_compare(JVERSION, '2.5', '>=') && version_compare(JVERSION, '3.0', '<') ) {
			if (JError::$legacy)
				$tmp_legacy = true;
			else
				$tmp_legacy = false;
		
			JError::$legacy = false;
		}
	
		$db = JFactory::getDBO();
	
		try {
			if(version_compare(JVERSION,'1.6.0','>=')){
				$db->setQuery("INSERT IGNORE INTO #__paidsystem_credits VALUES ( '1', '42', '100' )");
				$result = $db->query();
			} else {
				$db->setQuery("INSERT IGNORE INTO #__paidsystem_credits VALUES ( '1', '62', '100' )");
				$result = $db->query();
			}
		} catch(Exception $e) {
	
		}
	
		$queries = array();
		$queries[] = "ALTER IGNORE TABLE `#__paidsystem_config` MODIFY `credits` float;";
		$queries[] = "ALTER IGNORE TABLE `#__paidsystem_config` MODIFY `featured_price` float;";
		$queries[] = "ALTER IGNORE TABLE `#__paidsystem_config` MODIFY `highlight_price` float;";
		$queries[] = "ALTER IGNORE TABLE `#__paidsystem_config` MODIFY `image_price` float;";
		$queries[] = "ALTER IGNORE TABLE `#__paidsystem_config` MODIFY `cat_price` float;";
        
		$queries[] = "ALTER IGNORE TABLE `#__paidsystem_duration` MODIFY `credits` float;";
	
		$queries[] = "ALTER IGNORE TABLE `#__paidsystem_categories` MODIFY `price` float;";
		$queries[] = "ALTER IGNORE TABLE `#__paidsystem_categories` MODIFY `featured_price` float;";
		$queries[] = "ALTER IGNORE TABLE `#__paidsystem_categories` MODIFY `highlight_price` float;";
		$queries[] = "ALTER IGNORE TABLE `#__paidsystem_categories` MODIFY `image_price` float;";
	
		$queries[] = "ALTER IGNORE TABLE `#__paidsystem_fields` MODIFY `price` float;";
	
		$queries[] = "ALTER IGNORE TABLE `#__paidsystem_config` ADD `top_active` tinyint(1) NOT NULL default '1'";
		$queries[] = "ALTER IGNORE TABLE `#__paidsystem_config` ADD `top_type` tinyint(1) NOT NULL default '1'";
        $queries[] = "ALTER IGNORE TABLE `#__paidsystem_config` ADD `currency_id` INTEGER DEFAULT NULL";
	        
		$queries[] = "ALTER IGNORE TABLE `#__paidsystem_ads` ADD `highlight_date` datetime default NULL";
		$queries[] = "ALTER IGNORE TABLE `#__paidsystem_ads` ADD `featured_date` datetime default NULL";
		$queries[] = "ALTER IGNORE TABLE `#__paidsystem_ads` ADD `top_date` datetime default NULL";
		$queries[] = "ALTER IGNORE TABLE `#__paidsystem_ads` ADD `top` int(1) NOT NULL default '0'";
	
		$queries[] = "ALTER IGNORE TABLE `#__paidsystem_config` ADD `mode` varchar(255) NOT NULL default 'payperad'";
        
		$queries[] = "CREATE TABLE IF NOT EXISTS `#__paidsystem_highlight` (
	  `id` int(11) NOT NULL auto_increment,
	  `title` varchar(255) NOT NULL default '',
	  `duration` int(11) NOT NULL default '0',
	  `credits` float NOT NULL default '0',
	  `catsid` varchar(255) NOT NULL default '',
	  `ordering` int(11) NOT NULL default '0',
	  `published` tinyint(1) NOT NULL default '1',
	  PRIMARY KEY  (`id`)
	);";
	
		$queries[] = "CREATE TABLE IF NOT EXISTS `#__paidsystem_featured` (
	  `id` int(11) NOT NULL auto_increment,
	  `title` varchar(255) NOT NULL default '',
	  `duration` int(11) NOT NULL default '0',
	  `credits` float NOT NULL default '0',
	  `catsid` varchar(255) NOT NULL default '',
	  `ordering` int(11) NOT NULL default '0',
	  `published` tinyint(1) NOT NULL default '1',
	  PRIMARY KEY  (`id`)
	);";
	
		$queries[] = "CREATE TABLE IF NOT EXISTS `#__paidsystem_top` (
	  `id` int(11) NOT NULL auto_increment,
	  `title` varchar(255) NOT NULL default '',
	  `duration` int(11) NOT NULL default '0',
	  `credits` float NOT NULL default '0',
	  `catsid` varchar(255) NOT NULL default '',
	  `ordering` int(11) NOT NULL default '0',
	  `published` tinyint(1) NOT NULL default '1',
	  PRIMARY KEY  (`id`)
	);";
		
		//$queries[] = "ALTER IGNORE TABLE `#__paidsystem_config` ADD `invoice_number` int(10) unsigned NOT NULL default '0'";
		//$queries[] = "ALTER IGNORE TABLE `#__paidsystem_config` ADD `invoice_number_format` varchar(255) default '{invoice_number}'";
		
		$queries[] = "ALTER IGNORE TABLE `#__paidsystem_duration` ADD COLUMN `type` varchar(255) NOT NULL default 'both';";
        
        foreach($queries as $query) {
			$db->setQuery($query);
			try {
				$result = $db->query();
			} catch(Exception $e) {
	
			}
		}
	
		$db->setQuery("SELECT * FROM #__adsmanager_ads");
		$results = $db->loadObjectList();
		foreach($results as $result) {
			$db->setQuery("INSERT IGNORE INTO #__paidsystem_ads VALUES (".(int)$result->id.",0,0,0)");
			try {
				$db->query();
			} catch(Exception $e) {
	
			}
		}
	
		$db->setQuery("UPDATE #__paidsystem_ads SET highlight = 0 WHERE highlight IS NULL");
		$db->query();
		$db->setQuery("UPDATE #__paidsystem_ads SET top = 0 WHERE top IS NULL");
		$db->query();
		$db->setQuery("UPDATE #__paidsystem_ads SET featured = 0 WHERE featured IS NULL");
		$db->query();
	
		$db->setQuery(" ALTER IGNORE TABLE `#__paidsystem_config` ADD `params` TEXT DEFAULT NULL;");
		try {
			$result = $db->query();
		} catch(Exception $e) {
	
		}
		
		$db->setQuery("DELETE FROM `#__modules` WHERE module = 'mod_paidsystem_box'");
		try {
			$result = $db->query();
		} catch(Exception $e) {
		
		}
		
		$oldLogFile = JPATH_ROOT."/components/com_paidsystem/log.txt";
		if(JFile::exists($oldLogFile)) {
			$config = JFactory::getConfig();
			if(version_compare(JVERSION, '3.0', 'ge')) {
				$logpath = $config->get('log_path');
			} else {
				$logpath = $config->getValue('log_path');
			}
			$logFilenameBase = $logpath.'/paidsystem';
			$logFile = $logFilenameBase.'.php';
			jimport('joomla.filesystem.file');
			if(JFile::exists($logFile)) {
				JFile::delete($logFile);
			}
			$dummy = "<?php die(); ?>\n";
			$logData = $dummy.JFile::read($oldLogFile);
			JFile::write($logFile,$logData);
			JFile::delete($oldLogFile);
		}
		
		if(version_compare(JVERSION, '2.5', '>=') && version_compare(JVERSION, '3.0', '<') ) {
			JError::$legacy = $tmp_legacy;
		}
	}

	/**
	 * Installs subextensions (modules, plugins) bundled with the main extension
	 * 
	 * @param JInstaller $parent 
	 * @return JObject The subextension installation status
	 */
	private function _installSubextensions($parent)
	{
		if( version_compare( JVERSION, '1.6.0', 'ge' ) ) {
			$src = $parent->getParent()->getPath('source');
		} else {
			$src = $parent->getPath('source');
		}
		
		$db = JFactory::getDbo();
        
		$status = new JObject();
		$status->modules = array();
		$status->plugins = array();
		$status->adsmanagerfields = array();
		
		$src = str_replace('backend','',$src);
		
		// Modules installation
		if(count($this->installation_queue['modules'])) {
			foreach($this->installation_queue['modules'] as $folder => $modules) {
				if(count($modules)) foreach($modules as $module => $modulePreferences) {
					// Install the module
					if(empty($folder)) $folder = 'site';
					$path = "$src/modules/$folder/$module";
					if(!is_dir($path)) {
						$path = "$src/modules/$folder/mod_$module";
					}
					if(!is_dir($path)) {
						$path = "$src/modules/$module";
					}
					if(!is_dir($path)) {
						$path = "$src/modules/mod_$module";
					}
					if(!is_dir($path)) continue;
					
					// Was the module already installed?
                    if( version_compare( JVERSION, '1.6.0', 'ge' ) ) {
						$sql = $db->getQuery(true)
						->select('COUNT(*)')
						->from('#__modules')
						->where($db->qn('module').' = '.$db->q('mod_'.$module));
						$db->setQuery($sql);
						$count = $db->loadResult();
					} else {
						$count = 1;
					}
					$installer = new JInstaller;

					$result = $installer->install($path);
					$status->modules[] = array(
						'name'=>'mod_'.$module,
						'client'=>$folder,
						'result'=>$result
					);

					// Modify where it's published and its published state
					if(!$count) {
						// A. Position and state
						list($modulePosition, $modulePublished) = $modulePreferences;
						if($modulePosition == 'cpanel') {
							$modulePosition = 'icon';
						}
						if(version_compare(JVERSION, '3.0.0', 'ge')) {
							if ($modulePosition == "left") {
								$modulePosition = 'position-7';			
							}
						}
						$sql = $db->getQuery(true)
							->update($db->qn('#__modules'))
							->set($db->qn('position').' = '.$db->q($modulePosition))
							->where($db->qn('module').' = '.$db->q('mod_'.$module));
						
						
						if($modulePublished) {
							$sql->set($db->qn('published').' = '.$db->q('1'));
						}
						
						if($modulePosition == 'icon') {
							$sql->set($db->qn('ordering').' = '.$db->q('0'));
							//echo $sql;exit();
						}
						

						$db->setQuery($sql);
						$db->query();
						
						// B. Change the ordering of back-end modules to 1 + max ordering
						if($folder == 'admin') {
							if($modulePosition != 'icon') {
								$query = $db->getQuery(true);
								$query->select('MAX('.$db->qn('ordering').')')
									->from($db->qn('#__modules'))
									->where($db->qn('position').'='.$db->q($modulePosition));
								$db->setQuery($query);
								$position = $db->loadResult();
								$position++;
	
								$query = $db->getQuery(true);
								$query->update($db->qn('#__modules'))
									->set($db->qn('ordering').' = '.$db->q($position))
									->where($db->qn('module').' = '.$db->q('mod_'.$module));
								$db->setQuery($query);
								$db->query();
							}
						}
						
						// C. Link to all pages
						$query = $db->getQuery(true);
						$query->select('id')->from($db->qn('#__modules'))
							->where($db->qn('module').' = '.$db->q('mod_'.$module));
						$db->setQuery($query);
						$moduleid = $db->loadResult();

						$query = $db->getQuery(true);
						$query->select('*')->from($db->qn('#__modules_menu'))
							->where($db->qn('moduleid').' = '.$db->q($moduleid));
						$db->setQuery($query);
						$assignments = $db->loadObjectList();
						$isAssigned = !empty($assignments);
						if(!$isAssigned) {
							$o = (object)array(
								'moduleid'	=> $moduleid,
								'menuid'	=> 0
							);
							$db->insertObject('#__modules_menu', $o);
						}
					}
				}
			}
		}
		
        if( version_compare( JVERSION, '1.6.0', 'ge' ) ) {
			$this->installation_queue['plugins']['sh404sefextplugins'] = array(
                                                                        'sh404sefextplugincom_adsmanager' => 1
                                                                    );
		} else {
			$this->installation_queue['plugins']['sh404sefextplugins'] = array(
                                                                        'com_adsmanager' => 1
                                                                    );
            unset($this->installation_queue['plugins']['xmap']);
		}
        
		// Plugins installation
		if(count($this->installation_queue['plugins'])) {
			foreach($this->installation_queue['plugins'] as $folder => $plugins) {
				if(count($plugins)) foreach($plugins as $plugin => $published) {
					$path = "$src/plugins/$folder/$plugin";
					
					if(!is_dir($path)) {
						$path = "$src/plugins/$folder/plg_$plugin";
					}
					if(!is_dir($path)) {
						$path = "$src/plugins/$plugin";
					}
					if(!is_dir($path)) {
						$path = "$src/plugins/plg_$plugin";
					}
					if(!is_dir($path)) continue;

					// Was the plugin already installed?
                    if( version_compare( JVERSION, '1.6.0', 'ge' ) ) {
						$query = $db->getQuery(true)
							->select('COUNT(*)')
							->from($db->qn('#__extensions'))
							->where($db->qn('element').' = '.$db->q($plugin))
							->where($db->qn('folder').' = '.$db->q($folder));
						$db->setQuery($query);
						$count = $db->loadResult();
					} else {
						$count = 1;
					}
                    
					$installer = new JInstaller;
					$result = $installer->install($path);
					
					$status->plugins[] = array('name'=>'plg_'.$plugin,'group'=>$folder, 'result'=>$result);

					if($published && !$count) {
						$query = $db->getQuery(true)
							->update($db->qn('#__extensions'))
							->set($db->qn('enabled').' = '.$db->q('1'))
							->where($db->qn('element').' = '.$db->q($plugin))
							->where($db->qn('folder').' = '.$db->q($folder));
						$db->setQuery($query);
						$db->query();
					}
				}
			}
		}
    
		function recurse_copy($src,$dst) { 
			$dir = opendir($src); 
			@mkdir($dst); 
			while(false !== ( $file = readdir($dir)) ) { 
				if (( $file != '.' ) && ( $file != '..' )) { 
					if ( is_dir($src . '/' . $file) ) { 
						recurse_copy($src . '/' . $file,$dst . '/' . $file); 
					} 
					else { 
						copy($src . '/' . $file,$dst . '/' . $file); 
					} 
				} 
			} 
			closedir($dir); 
		} 

		// External Plugins installation
		if(count($this->installation_queue['adsmanagerfields'])) {
			
			$path = JPATH_SITE."/images/com_adsmanager/plugins";	
			if( file_exists ($path)) {		
                foreach($this->installation_queue['adsmanagerfields'] as $folder => $plugins) {
 					if(count($plugins)) foreach($plugins as $plugin) {
						$destPath = $path."/".$folder;
						$sourcePath = $src."/adsmanagerfields/".$folder;
						
						if (is_dir($destPath)){
							//echo "ok";
							$this->rmdir_recurse($destPath);
							//if (is_dir($destPath))
								//echo "ok";
						}
                        
						@mkdir($path);
                        
						recurse_copy($sourcePath,$destPath);
                        
                        if(file_exists($destPath.'/plug.php')) {
                            include_once($destPath.'/plug.php');
                            if(isset($plugins[$folder]))
                                   $plugins[$folder]->install();
                        }
					} 
					$status->adsmanagerfields[] = array('name'=>$folder,'group'=>'','result'=>'Installed');
				}
			}
		}
        
		return $status;
	}
	
	function rmdir_recurse($path,$onlycontent = false) {
		if (is_dir($path)){
			$path= rtrim($path, '/').'/';
			$handle = opendir($path);
			for (;false !== ($file = readdir($handle));)
				if($file != "." and $file != ".." ) {
				$fullpath= $path.$file;
				if( is_dir($fullpath) ) {
					self::rmdir_recurse($fullpath);
				} else {
					@unlink($fullpath);
				}
			}
			closedir($handle);
			if  ($onlycontent == false)
				rmdir($path);
		}
	}
	
    /**
	 * Update XML files only for Joomla1.5
	 */
	public function updateXmlJoomla15($parent) {
		$src = $parent->getPath('source');
        
		$db = JFactory::getDbo();
		
		$status = new JObject();
		$status->modules = array();
		$status->plugins = array();
		
		$src = str_replace('backend','',$src);

		if(count($this->installation_queue['modules'])) {
			foreach($this->installation_queue['modules'] as $folder => $modules) {
				if(count($modules)) foreach($modules as $module => $modulePreferences) {
					// Install the module
					if(empty($folder)) $folder = 'site';
					$path = "$src/modules/$folder/$module";
					if(!is_dir($path)) {
						$path = "$src/modules/$folder/mod_$module";
					}
					if(!is_dir($path)) {
						$path = "$src/modules/$module";
					}
					if(!is_dir($path)) {
						$path = "$src/modules/mod_$module";
					}
					if(!is_dir($path)) continue;
					if(file_exists("$path/mod_".$module."_15.xml")) {
                        JFile::copy("$path/mod_".$module."_15.xml","$path/mod_".$module.".xml");
					}
				}
			}
		}
		
		
		
		// Plugins installation
		if(count($this->installation_queue['plugins'])) {
			foreach($this->installation_queue['plugins'] as $folder => $plugins) {
                if(count($plugins)) foreach($plugins as $plugin => $published) {
					$path = "$src/plugins/$folder/$plugin";
					//echo $path;
					if(!is_dir($path)) {
						$path = "$src/plugins/$folder/plg_$plugin";
					}
					if(!is_dir($path)) {
						$path = "$src/plugins/$plugin";
					}
					if(!is_dir($path)) {
						$path = "$src/plugins/plg_$plugin";
					}
					if(!is_dir($path)) continue;
					if(file_exists("$path/".$plugin."_15.xml")) {
						JFile::copy("$path/".$plugin."_15.xml","$path/".$plugin.".xml");
					}
					
				}
			}
		}
	}
    
	/**
	 * Uninstalls subextensions (modules, plugins) bundled with the main extension
	 * 
	 * @param JInstaller $parent 
	 * @return JObject The subextension uninstallation status
	 */
	private function _uninstallSubextensions($parent)
	{
		jimport('joomla.installer.installer');
		
		$db = JFactory::getDBO();
		
		$status = new JObject();
		$status->modules = array();
		$status->plugins = array();
		
		if( version_compare( JVERSION, '1.6.0', 'ge' ) ) {
			$src = $parent->getParent()->getPath('source');
		} else {
			$src = $parent->getPath('source');
		}

		// Modules uninstallation
		if(count($this->installation_queue['modules'])) {
			foreach($this->installation_queue['modules'] as $folder => $modules) {
				if(count($modules)) foreach($modules as $module => $modulePreferences) {
					// Find the module ID
					$sql = $db->getQuery(true)
						->select($db->qn('extension_id'))
						->from($db->qn('#__extensions'))
						->where($db->qn('element').' = '.$db->q('mod_'.$module))
						->where($db->qn('type').' = '.$db->q('module'));
					$db->setQuery($sql);
					$id = $db->loadResult();
					// Uninstall the module
					if($id) {
						$installer = new JInstaller;
						$result = $installer->uninstall('module',$id,1);
						$status->modules[] = array(
							'name'=>'mod_'.$module,
							'client'=>$folder,
							'result'=>$result
						);
					}
				}
			}
		}

		// Plugins uninstallation
		if(count($this->installation_queue['plugins'])) {
			foreach($this->installation_queue['plugins'] as $folder => $plugins) {
				if(count($plugins)) foreach($plugins as $plugin => $published) {
					$sql = $db->getQuery(true)
						->select($db->qn('extension_id'))
						->from($db->qn('#__extensions'))
						->where($db->qn('type').' = '.$db->q('plugin'))
						->where($db->qn('element').' = '.$db->q($plugin))
						->where($db->qn('folder').' = '.$db->q($folder));
					$db->setQuery($sql);

					$id = $db->loadResult();
					if($id)
					{
						$installer = new JInstaller;
						$result = $installer->uninstall('plugin',$id,1);
						$status->plugins[] = array(
							'name'=>'plg_'.$plugin,
							'group'=>$folder,
							'result'=>$result
						);
					}			
				}
			}
		}
		
		return $status;
	}
	
	/**
	 * Removes obsolete files and folders
	 * 
	 * @param array $paidsystemRemoveFiles 
	 */
	private function _removeObsoleteFilesAndFolders($paidsystemRemoveFiles)
	{
		// Remove files
		jimport('joomla.filesystem.file');
		if(!empty($paidsystemRemoveFiles['files'])) foreach($paidsystemRemoveFiles['files'] as $file) {
			$f = JPATH_ROOT.'/'.$file;
			if(!JFile::exists($f)) continue;
			JFile::delete($f);
		}

		// Remove folders
		jimport('joomla.filesystem.file');
		if(!empty($paidsystemRemoveFiles['folders'])) foreach($paidsystemRemoveFiles['folders'] as $folder) {
			$f = JPATH_ROOT.'/'.$folder;
			if(!JFolder::exists($f)) continue;
			JFolder::delete($f);
		}
	}
	
	/**
	 * Remove the update site specification from Joomla! – we no longer support
	 * that misbehaving crap, thank you very much...
	 */
	private function _killUpdateSite()
	{
		// Get some info on all the stuff we've gotta delete
		$db = JFactory::getDbo();
		$query = $db->getQuery(true)
			->select(array(
				$db->qn('s').'.'.$db->qn('update_site_id'),
				$db->qn('e').'.'.$db->qn('extension_id'),
				$db->qn('e').'.'.$db->qn('element'),
				$db->qn('s').'.'.$db->qn('location'),
			))
			->from($db->qn('#__update_sites').' AS '.$db->qn('s'))
			->join('INNER',$db->qn('#__update_sites_extensions').' AS '.$db->qn('se').' ON('.
				$db->qn('se').'.'.$db->qn('update_site_id').' = '.
				$db->qn('s').'.'.$db->qn('update_site_id')
				.')')
			->join('INNER',$db->qn('#__extensions').' AS '.$db->qn('e').' ON('.
				$db->qn('e').'.'.$db->qn('extension_id').' = '.
				$db->qn('se').'.'.$db->qn('extension_id')
				.')')
			->where($db->qn('s').'.'.$db->qn('type').' = '.$db->q('extension'))
			->where($db->qn('e').'.'.$db->qn('type').' = '.$db->q('component'))
			->where($db->qn('e').'.'.$db->qn('element').' = '.$db->q($this->_paidsystem_extension))
		;
		$db->setQuery($query);
		$oResult = $db->loadObject();
		
		// If no record is found, do nothing. We've already killed the monster!
		if(is_null($oResult)) return;
		
		// Delete the #__update_sites record
		$query = $db->getQuery(true)
			->delete($db->qn('#__update_sites'))
			->where($db->qn('update_site_id').' = '.$db->q($oResult->update_site_id));
		$db->setQuery($query);
		try {
			$db->query();
		} catch (Exception $exc) {
			// If the query fails, don't sweat about it
		}

		// Delete the #__update_sites_extensions record
		$query = $db->getQuery(true)
			->delete($db->qn('#__update_sites_extensions'))
			->where($db->qn('update_site_id').' = '.$db->q($oResult->update_site_id));
		$db->setQuery($query);
		try {
			$db->query();
		} catch (Exception $exc) {
			// If the query fails, don't sweat about it
		}
		
		// Delete the #__updates records
		$query = $db->getQuery(true)
			->delete($db->qn('#__updates'))
			->where($db->qn('update_site_id').' = '.$db->q($oResult->update_site_id));
		$db->setQuery($query);
		try {
			$db->query();
		} catch (Exception $exc) {
			// If the query fails, don't sweat about it
		}
	}
}

// For Joomla 1.5
global $parentpaidsystem;
$parentpaidsystem = $this->parent;
// For Joomla 1.5
if(!function_exists('com_install')){
	function com_install(){
		global $parentpaidsystem;
		$class = new Com_PaidsystemInstallerScript();
        $class->updateXmlJoomla15($parentpaidsystem);
        $class->postflight("update",$parentpaidsystem);
		return $class->install(null);
	}
}