CREATE TABLE IF NOT EXISTS `#__paidsystem_config` (
`id` int(11) NOT NULL auto_increment,
`paypal_email` varchar(100) NOT NULL default 'yourpaypalemail@youremail.com',
`sandbox_email` varchar(100) NOT NULL default 'sandboxemail@youremail.com',
`sandbox` tinyint(1) NOT NULL default '0',
`currency_id` int(5) NULL DEFAULT NULL,
`vendor_txt` TEXT NOT NULL default '',
`vendor_img` varchar(255) NOT NULL default '',
`tax` float unsigned NOT NULL default '0',
`credits` float unsigned NOT NULL default '10',
`highlight_active` tinyint(1) NOT NULL default '1',
`featured_active` tinyint(1) NOT NULL default '1',
`top_active` tinyint(1) NOT NULL default '1',
`top_type` tinyint(1) NOT NULL default '1',
`num_images` int(10) unsigned NOT NULL default '0',
`image_price` float unsigned NOT NULL default '5',
`nbcats` int(10) unsigned NOT NULL default '0',
`cat_price` float unsigned NOT NULL default '5',
`type` varchar(255) default NULL,
`mode` varchar(255) NOT NULL default 'payperad',
`invoice_number` int(10) unsigned NOT NULL default '0',
`invoice_number_format` varchar(255) default '{invoice_number}',
`params` TEXT NOT NULL default '',
PRIMARY KEY  (`id`)
);
		
CREATE TABLE IF NOT EXISTS `#__paidsystem_ads` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `highlight` int(1) unsigned  NOT NULL default '0' ,
  `featured` int(1) unsigned  NOT NULL default '0',
  `top` int(1) unsigned  NOT NULL default '0',
  `highlight_date` datetime default NULL,
  `featured_date` datetime default NULL,
  `top_date` datetime default NULL,
  PRIMARY KEY  (id)
);

CREATE TABLE IF NOT EXISTS `#__paidsystem_fields` (
  `id` int(10) unsigned NOT NULL,
  `price` float unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
);

CREATE TABLE IF NOT EXISTS `#__paidsystem_categories` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `specific` TINYINT( 1 ) unsigned NOT NULL DEFAULT '0',
  `price` float unsigned NOT NULL DEFAULT '0',
  `num_images` int(10) unsigned NOT NULL default '0',
  `image_price` float unsigned NOT NULL default '5',
  PRIMARY KEY  (id)
);

CREATE TABLE IF NOT EXISTS `#__paidsystem_duration` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `duration` int(11) NOT NULL default '0',
  `credits` float NOT NULL default '0',
  `catsid` varchar(255) NOT NULL default '',
  `ordering` int(11) NOT NULL default '0',
  `type`    varchar(255) NOT NULL default 'both',
  `published` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
);

CREATE TABLE IF NOT EXISTS `#__paidsystem_highlight` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `duration` int(11) NOT NULL default '0',
  `credits` float NOT NULL default '0',
  `catsid` varchar(255) NOT NULL default '',
  `ordering` int(11) NOT NULL default '0',
  `published` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`)
);

CREATE TABLE IF NOT EXISTS `#__paidsystem_featured` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `duration` int(11) NOT NULL default '0',
  `credits` float NOT NULL default '0',
  `catsid` varchar(255) NOT NULL default '',
  `ordering` int(11) NOT NULL default '0',
  `published` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`)
);

CREATE TABLE IF NOT EXISTS `#__paidsystem_top` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `duration` int(11) NOT NULL default '0',
  `credits` float NOT NULL default '0',
  `catsid` varchar(255) NOT NULL default '',
  `ordering` int(11) NOT NULL default '0',
  `published` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`)
);

INSERT IGNORE INTO #__paidsystem_config ( `id`) VALUES ('1');
