<?php
/**
 * @package		Virtualmoney
 * @copyright	Copyright (C) 2010-2012 JoomPROD.com. All rights reserved.
 * @license		GNU/GPL
 */

defined('JPATH_BASE') or die;

JFormHelper::loadFieldClass('list');


/**
 * Supports a modal contact picker.
 *
 * @package		Joomla.Administrator
 * @subpackage	com_contact
 * @since		1.6
 */
class JFormFieldPackTax extends JFormFieldList
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'PackTax';

	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	protected function getOptions() 
	{
        $db = JFactory::getDbo();
        
        $sql = $db->setQuery("SELECT * FROM #__invoicing_taxes");
        
        try{
           $list = $db->loadObjectList();
        }catch(Exception $e){
           $list = array();
        }
	
		$options   = array();
	
		$options[] = JHTML::_('select.option','0',JText::_('INVOICING_NO_TAX'));
	
		foreach($list as $item) {
			$options[] = JHTML::_('select.option',$item->taxrate,$item->taxrate);
		}
        
        return $options;
	}
}
