<?php
/**
 *  @package	PaidSystem
 *  @copyright	Copyright (C) 2010-2013 JoomPROD.com. All rights reserved.
 *  @license    GNU General Public License version 3, or later
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.model');
JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_paidsystem'.DS.'tables');

/**
 * @package		Joomla
 * @subpackage	Contact
 */
class PaidsystemModelTop extends TModel
{    
	function changeState($table,$id,$field,$state,$cid)
	{
		$cids = implode( ',', $cid );
		$this->_db->setQuery("UPDATE $table SET $field = $state WHERE $id IN ($cids)");
		//echo "UPDATE $table SET $field = $state WHERE $id IN ($cids)";
		//exit();
		$this->_db->query();
	}
	
	function getTops($search= "",$limitstart=0,$limit=null) {

		$query = "SELECT * FROM #__paidsystem_top WHERE 1";
		if ($search != "") {
			$query .= " AND (title LIKE '%".$this->_db->getEscaped($search,true)."%')";
		}
		$query .=" ORDER BY ordering, id";
		
    	$this->_db->setQuery($query,$limitstart,$limit);
		$rows = $this->_db->loadObjectList();
		return $rows;
    }
    
	function getNbTops($search= "")
	{
		$query =  "SELECT count(*) FROM #__paidsystem_top WHERE 1";
		if ($search != "") {
			$query .= " AND (title LIKE '%".$this->_db->getEscaped($search,true)."%')";
		}
		$this->_db->setQuery($query);				 
		$nb = $this->_db->loadResult();
		return $nb;
	}
	
	function getCats($onlyPublished = true) {
		
		if ($onlyPublished == true)
			$published = " c.published = 1 ";
		else
			$published = " 1 ";
							
		$query =  "SELECT c.*, count(*) as num_ads,a.id as not_empty ".
						 "FROM #__adsmanager_ads as a ".
						 "LEFT JOIN #__adsmanager_adcat as adcat ON a.id = adcat.adid ".
						 "RIGHT JOIN #__adsmanager_categories as c ON adcat.catid = c.id ".
						 "WHERE $published ".
						 "GROUP BY c.id ".
						 "ORDER BY c.parent,c.ordering,c.id";
		//echo $query;
		$this->_db->setQuery($query);
						 
		$list = $this->_db->loadObjectList();
							 
		// establish the hierarchy of the menu
		$tree = array();
		// first pass - collect children
		if(isset($list))
		{
			foreach ($list as $v ) {
				$pt 	= $v->parent;
				$list_temp 	= @$tree[$pt] ? $tree[$pt] : array();
				array_push( $list_temp, $v );
				$tree[$pt] = $list_temp;
			}
		}
		
		return $tree;
	}
}