<?php
/**
 * @package Invoicing
 * @copyright Copyright (c)203 Juloa.com
 * @license GNU General Public License version 3, or later
 */

// Protect from unauthorized access
defined('_JEXEC') or die();

include_once(JPATH_ADMINISTRATOR.'/components/com_invoicing/helpers/cparams.php');

class InvoicingModelUsers extends FOFModel
{
    public function qn($name) {
        $db = $this->getDbo();        
       if(version_compare(JVERSION, '3.0', 'ge')) {
			return $db->qn($name);
		} elseif(version_compare(JVERSION, '1.6', 'ge')) {
			return  $db->quoteName($name);
		}else {
            return $db->nameQuote($name);
		}           
    }
    
    public function q($name) {
        $db = $this->getDbo();        
        if(version_compare(JVERSION, '1.6', 'ge')) {
			return  $db->q($name);
		}else {
            return $db->Quote($name);
		}           
    }
    
	public function buildQuery($overrideLimits = false) {
		$cb = InvoicingHelperCparams::getParam('cb',0);
		if ($cb == 1 && file_exists(JPATH_ADMINISTRATOR.'/components/com_comprofiler') ) {
			$db =JFactory::getDBO();
			$cb_name = InvoicingHelperCparams::getParam('cb_name','name');
			if ($cb_name == "name") {
				$cbname = "u.".$cb_name;
				$cb_name = "u.".$cb_name." as cb_businessname";
			} else {
				$cbname = "c.".$cb_name;
				$cb_name = "c.".$cb_name." as cb_businessname";
			}
			$cb_city = "c.".InvoicingHelperCparams::getParam('cb_city','cb_city')." as cb_city";
			$cb_address = "c.".InvoicingHelperCparams::getParam('cb_address','cb_address')." as cb_address1";
			$cb_address2 = "c.".InvoicingHelperCparams::getParam('cb_address2','cb_address2')." as cb_address2";
			$cb_zip = "c.".InvoicingHelperCparams::getParam('cb_zip','cb_zip')." as cb_zip";
			$cb_country = "c.".InvoicingHelperCparams::getParam('cb_country','cb_country')." as cb_country";
			
			$query = FOFQueryAbstract::getNew($db);
			$query->select("i.*,$cb_name,$cb_city,$cb_address,$cb_address2,$cb_zip,$cb_country,u.email,u.username")
			      ->from("#__invoicing_users as i")
			      ->join("LEFT","#__comprofiler as c ON c.user_id = i.user_id")
			      ->join("LEFT","#__users as u ON i.user_id = u.id");
			$search = $this->getState('search',null);
			if($search)
			{
				$search = '%'.$search.'%';
				$query->where('(('.$this->qn('i.invoicing_user_id').' LIKE '.$this->q($search).') OR'.
						'('.$this->qn($cbname).' LIKE '.$this->q($search).') OR '.
						'('.$this->qn('i.businessname').' LIKE '.$this->q($search).')'.
						')');
			}
			$order = $this->getState('filter_order', 'cb_businessname', 'cmd');
			if ($order == 'businessname') 
				$order = "cb_businessname";
			if ($order == 'id')
				$order = 'u.id';
			$dir = $this->getState('filter_order_Dir', 'DESC', 'cmd');
			$query->order("$order $dir");
			//echo (string) $query;
			//var_dump($query);
		} else {
			$db = $this->getDbo();
		
			$query = FOFQueryAbstract::getNew($db)
				->select('i.*,u.email,u.username,u.id')
				->from($this->qn('#__invoicing_users')." as i")
				->leftjoin($this->qn('#__users')." AS u on i.user_id = u.id");	
			
			$search = $this->getState('search',null);
			if($search)
			{
				$search = '%'.$search.'%';
				$query->where(
					'('.
					'('.$this->qn('invoicing_user_id').' LIKE '.$this->q($search).') OR'.
					'('.$this->qn('businessname').' LIKE '.$this->q($search).')'.
					')'
				);
			}
			
			$order = $this->getState('filter_order', 'businessname', 'cmd');
			if(!in_array($order, array_keys($this->getTable()->getData()))) $order = 'businessname';
			$dir = $this->getState('filter_order_Dir', 'DESC', 'cmd');
			$query->order($order.' '.$dir);
		}
		return $query;
	}

	public function onProcessList(&$list) {
		$cb = InvoicingHelperCparams::getParam('cb',0);
		if ($cb == 1 && file_exists(JPATH_ADMINISTRATOR.'/components/com_comprofiler')) {
			foreach($list as $key => $item) {
				if (($item->user_id != "0")&&($item->user_id != null)) {
					$list[$key]->businessname = $list[$key]->cb_businessname;
					$list[$key]->city = $list[$key]->cb_city;
					$list[$key]->address1 = $list[$key]->cb_address1;
					$list[$key]->address2 = $list[$key]->cb_address2;
					$list[$key]->zip = $list[$key]->cb_zip;
					$list[$key]->country = $list[$key]->cb_country;
				}
			}
		}
	}
	
	public function &getItem($id = null)
	{
		$db =JFactory::getDBO();
		$cb = InvoicingHelperCparams::getParam('cb',0);
		if(!is_null($id)) {
			$this->record = null;
			$this->setId($id);
		}
		
		if ($cb == 1) {	
			if(empty($this->record)) {
				
				$cb_name = InvoicingHelperCparams::getParam('cb_name','name');
				if ($cb_name == "name")
					$cb_name = "u.".$cb_name." as cb_businessname";
				else
					$cb_name = "c.".$cb_name." as cb_businessname";
				$cb_city = "c.".InvoicingHelperCparams::getParam('cb_city','cb_city')." as cb_city";
				$cb_address = "c.".InvoicingHelperCparams::getParam('cb_address','cb_address')." as cb_address1";
				$cb_address2 = "c.".InvoicingHelperCparams::getParam('cb_address2','cb_address2')." as cb_address2";
				$cb_zip = "c.".InvoicingHelperCparams::getParam('cb_zip','cb_zip')." as cb_zip";
				$cb_country = "c.".InvoicingHelperCparams::getParam('cb_country','cb_country')." as cb_country";
		
				$query = "SELECT i.*,$cb_name,$cb_city,$cb_address,$cb_address2,$cb_zip,$cb_country,u.username, u.email FROM #__invoicing_users as i  LEFT JOIN #__comprofiler as c ON c.user_id = i.user_id LEFT JOIN #__users as u ON u.id = i.user_id WHERE i.invoicing_user_id=".(int)$this->getId();
				$db->setQuery($query);
				$values = $db->loadObject();
				$this->record = @FOFTable::getAnInstance('Users', 'InvoicingTable');//var_dump($this->record);
                $this->record->invoicing_user_id = null;
                $this->record->businessname = null;
                $this->record->username = null;
                $this->record->email = null;
                $this->record->city = null;
                $this->record->address1 = null;
                $this->record->address2 = null; 
                $this->record->zip = null;
                $this->record->country = null;
                
				if ($values != null) {
					foreach($values as $key => $val) {
						$this->record->$key = $val;
					}
				}
				if ((isset($this->record->user_id)) && ($this->record->user_id != 0)) {
					$this->record->businessname = $this->record->cb_businessname;
					$this->record->city = $this->record->cb_city;
					$this->record->address1 = $this->record->cb_address1;
					$this->record->address2 = $this->record->cb_address2;
					$this->record->zip = $this->record->cb_zip;
					$this->record->country = $this->record->cb_country;
				}
				$this->onAfterGetItem($this->record);
			}
			return $this->record;
		} else {
			if ($this->getId() != 0) {
				$query = "SELECT i.*,u.username, u.email FROM #__invoicing_users as i LEFT JOIN #__users as u ON u.id = i.user_id WHERE i.invoicing_user_id=".(int)$this->getId();
				$db->setQuery($query);
				$values = $db->loadObject();
				$this->record = @FOFTable::getAnInstance('Users', 'InvoicingTable');//var_dump($this->record);
                $this->record->invoicing_user_id = null;
                $this->record->businessname = null;
                $this->record->username = null;
                $this->record->email = null;
                $this->record->city = null;
                $this->record->address1 = null;
                $this->record->address2 = null; 
                $this->record->zip = null;
                $this->record->country = null;
                
				if ($values != null) {
					foreach($values as $key => $val) {
						$this->record->$key = $val;
					}
				}
				$this->onAfterGetItem($this->record);
				return $this->record;
			} else {
				return parent::getItem($id);	
			}
		}		
	}

	public function createUser($user_id) {
		$db =JFactory::getDBO();
        $sql = "SELECT * FROM #__users WHERE id = ".(int)$user_id;
		$db->setQuery($sql);
        $user = $db->loadObject();
		$obj = new stdClass();
		$obj->user_id = $user_id;
        $obj->businessname = $user->username;
		$db->insertObject('#__invoicing_users', $obj);
	}

	public function getInvoicingUser($user_id) {
		$db =JFactory::getDBO();
		$sql = "SELECT invoicing_user_id FROM #__invoicing_users WHERE user_id = ".(int)$user_id;
		$db->setQuery($sql);
		$invoicing_user_id = $db->loadResult();
		return $invoicing_user_id;
	}
	
	public function save($data)
	{
		$db =JFactory::getDBO();
		$cb = InvoicingHelperCparams::getParam('cb',0);
		if ($cb == 1) {
			$data = JRequest::get('post');
			$table = null;
			if(!$this->onBeforeSave($data, $table)) {
				return false;
			}
			if ($data['user_id'] != null) {
				$obj = new stdClass();
				$cb_name = InvoicingHelperCparams::getParam('cb_name','name');
				if ($cb_name != "name") {
					$obj->$cb_name = $data['businessname'];
				}
				$cb_city = InvoicingHelperCparams::getParam('cb_city','cb_city');
				$cb_address = InvoicingHelperCparams::getParam('cb_address','cb_address');
				$cb_address2 = InvoicingHelperCparams::getParam('cb_address2','cb_address2');
				$cb_zip = InvoicingHelperCparams::getParam('cb_zip','cb_zip');
				$cb_country = InvoicingHelperCparams::getParam('cb_country','cb_country');
			
				$obj->$cb_city = $data['city'];
				$obj->$cb_address = $data['address1'];
				$obj->$cb_address2 = $data['address2'];
				$obj->$cb_zip = $data['zip'];
				$obj->$cb_country = $data['country'];
				$obj->user_id = $data['user_id'];
				$obj->id = $data['user_id'];
				$db->updateObject('#__comprofiler',$obj,'id');	
			}	
		}
		parent::save($data);
		return true;
	}
	
	public function onBeforeSave(&$data,&$table) {
		$db =JFactory::getDBO();
		if ((@$data['user_id'] == null)&&(@$data['create_user'] != null)) {	
			$params = JComponentHelper::getParams('com_users');
			// Save User using Joomla code
			if (version_compare(JVERSION,'1.6.0','<')) {
				$authorize	= JFactory::getACL();
			
				$user = clone(JFactory::getUser());
					
				// Initialize new usertype setting
				$newUsertype = $params->get( 'new_usertype' );
				if (!$newUsertype) {
					$newUsertype = 'Registered';
				}
					
				// Bind the post array to the user object
				$post = JRequest::get('post');
				$post['password2'] = $post['password'];
				if (!$user->bind($post, 'usertype' )) {
					JError::raiseError( 500, $user->getError());
				}
			
				// Set some initial user values
				$user->set('id', 0);
				$user->set('usertype', $newUsertype);
				$user->set('gid', $authorize->get_group_id( '', $newUsertype, 'ARO' ));
			
				$date = JFactory::getDate();
				$user->set('registerDate', $date->toMySQL());
			
				// If user activation is turned on, we need to set the activation information
				$useractivation = $params->get( 'useractivation' );
				if ($useractivation == '1')
				{
					jimport('joomla.user.helper');
					$user->set('activation', JUtility::getHash( JUserHelper::genRandomPassword()) );
					//$user->set('block', '1');
				}
			
				// If there was an error with registration, set the message and display form
				if ( !$user->save() )
				{
					JError::raiseWarning('', JText::_( $user->getError()));
					return false;
				}
			} else {
				// Initialise the table with JUser.
				$user = new JUser;
			
				// Prepare the data for the user object.
				$useractivation = $params->get('useractivation');
			
				// Check if the user needs to activate their account.
				if (($useractivation == 1) || ($useractivation == 2)) {
					jimport('joomla.user.helper');
					if (version_compare(JVERSION,'3.0.0','>=')) {
						$data['activation'] = JApplication::getHash(JUserHelper::genRandomPassword());
					} else {
						$data['activation'] = JUtility::getHash(JUserHelper::genRandomPassword());
					}
					//$data['block'] = 1;
				}
					
				// Get the groups the user should be added to after registration.
				$data['groups'] = array();
				// Get the default new user group, Registered if not specified.
				$system	= $params->get('new_usertype', 2);
				$data['groups'][] = $system;
				
				$data['name'] = $data['businessname'];
			
				//var_dump($data);exit();
				// Bind the data.
				if (!$user->bind($data)) {
					$this->setError(JText::sprintf('COM_USERS_REGISTRATION_BIND_FAILED', $user->getError()));
					return false;
				}
			
				// Load the users plugin group.
				JPluginHelper::importPlugin('user');
			
				// Store the data.
				if (!$user->save()) {
					$this->setError(JText::sprintf('COM_USERS_REGISTRATION_SAVE_FAILED', $user->getError()));
					return false;
				}
			}
			$query = "SELECT MAX(id) FROM #__users";
			$db->setQuery($query);
			$userid = $db->loadResult();
			$data['user_id'] = $userid;

			/*$obj = new stdClass();
			$obj->invoicing_user_id = $userid;
			$obj->user_id = $userid;
			$db->insertObject('#__invoicing_users', $obj);*/
			
			$cb = InvoicingHelperCparams::getParam('cb',0);
			if ($cb == 1)
			{	
				$obj = new stdClass();
				$obj->id = $userid;
				$obj->user_id = $userid;
				$db->insertObject('#__comprofiler', $obj);
			}
		} else if (@$data['user_id'] != null) {
			$obj = new stdClass();
			$obj->name = JRequest::getVar('businessname','');
			$obj->email = JRequest::getVar('email','');
			if (($obj->name != "")&&($obj->email != "")) {
				$obj->id = JRequest::getVar('user_id','');
				
				if (JRequest::getVar('password','')) {
					jimport('joomla.user.helper');
					$salt = JUserHelper::genRandomPassword(32);
					$crypt = JUserHelper::getCryptedPassword(JRequest::getVar('password',''), $salt);
					$obj->password = $crypt.':'.$salt;
				}
				$db->updateObject('#__users', $obj,'id');
			}
		}
		return true;
	}
}
