CREATE TABLE IF NOT EXISTS `#__virtualmoney_credits` (
  `virtualmoney_credit_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `credits` float NOT NULL default '0',
  PRIMARY KEY  (virtualmoney_credit_id)
)ENGINE=InnoDB DEFAULT CHARSET=utf8;


CREATE TABLE IF NOT EXISTS `#__virtualmoney_transactions` (
  `virtualmoney_transaction_id` bigint(11) NOT NULL AUTO_INCREMENT,
  `user_id` int(11) NOT NULL,
  `credits` float NOT NULL default '0',
  `balance` float NOT NULL,
  `description` text NOT NULL,
  `type` text NOT NULL,
  `type_id` int(11) NOT NULL,
  `created_on` datetime NOT NULL,
  PRIMARY KEY (`virtualmoney_transaction_id`)
)ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__virtualmoney_exchanges` (
  `virtualmoney_exchange_id` bigint(11) NOT NULL AUTO_INCREMENT,
  `user_id1` int(11) NOT NULL,
  `user_id2` int(11) NOT NULL,
  `credits` float NOT NULL default '0',
  `description` text NOT NULL,
  `created_on` datetime NOT NULL,
  PRIMARY KEY (`virtualmoney_exchange_id`)
)ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__virtualmoney_packs` (
  `virtualmoney_pack_id` int(11) unsigned NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `price` float unsigned NOT NULL,
  `credits` float unsigned NOT NULL,
  `currency_id` bigint(20) unsigned NOT NULL,
  `ordering` int(11) unsigned NOT NULL,
  `enabled` tinyint(4) unsigned NOT NULL,
  PRIMARY KEY  (virtualmoney_pack_id)
)ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__virtualmoney_orders` (
  `virtualmoney_order_id` bigint(11) unsigned NOT NULL auto_increment,
  `user_id` int(11) NOT NULL,
  `credits` float NOT NULL default '0',
  `description` text NOT NULL,
  `created_on` datetime NOT NULL,
  `state` varchar(20) NOT NULL,
  PRIMARY KEY  (virtualmoney_order_id)
)ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__virtualmoney_emails` (
  `virtualmoney_email_id` int(11) NOT NULL AUTO_INCREMENT,
  `subject` text NOT NULL,
  `content` text NOT NULL,
  `description` text NOT NULL,
  `enabled` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`virtualmoney_email_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;

INSERT IGNORE INTO `#__virtualmoney_packs` (`virtualmoney_pack_id`, `title`, `price`, `credits`, `ordering`, `enabled`) VALUES
(1, 'Default', 5, 30, 0, 1);

INSERT IGNORE INTO `#__virtualmoney_emails` (`virtualmoney_email_id`, `subject`, `content`, `description`, `enabled`) VALUES
(1, 'You gave credit to', 'You gave credit to', 'Mail sent when the user provides credits.', 1),
(2, 'You have received credits from', 'You have received credits from', 'Mail is sent when the user receives another user''s credits.', 1);