<?php
/**
 * @package		Invoicing
 * @copyright	Copyright (C) 2010-2011 JoomPROD.com. All rights reserved.
 * @license GNU General Public License version 3, or later
 */

// Protect from unauthorized access
defined('_JEXEC') or die();

class InvoicingToolbar extends FOFToolbar
{
	public function renderSubmenu()
	{
        if(version_compare(JVERSION, '3.0', 'ge')) {
            $views = array(
                    'cpanel',
                    'COM_INVOICING_MAINMENU_SETUP' => array(
                            'currencies',
                            'taxes',
                            'emails',
                            'templates',
                    ),
                    'references',
                    'vendors',
                    'users',
                    'coupons',
                    'quotes',
                    'invoices',
                    'log'
            );
        } else {
            $views = array(
                    'cpanel',
                    'currencies',
                    'taxes',
                    'emails',
                    'templates',
                    'references',
                    'vendors',
                    'users',
                    'coupons',
                    'quotes',
                    'invoices',
                    'log'
            );
        }
		
		foreach($views as $label => $view) {
			if(!is_array($view)) {
				$this->addSubmenuLink($view);
			} else {
				$label = JText::_($label);
				$this->appendLink($label, '', false);
				foreach($view as $v) {
					$this->addSubmenuLink($v, $label);
				}
			}
		}
		
		//parent::renderSubmenu();	
          if(version_compare(JVERSION, '1.6', 'ge')) {
               $this->appendLink(JText::_('COM_INVOICING_TITLE_PROCESSORS'), 'index.php?option=com_plugins&filter_folder=invoicingpayment', false);
            // $this->appendLink(JText::_('COM_INVOICING_TITLE_INTEGRATORS'), 'index.php?option=com_plugins&filter_folder=invoicinggenerator', false);
          } else {
          	   $this->appendLink(JText::_('COM_INVOICING_TITLE_PROCESSORS'), 'index.php?option=com_plugins&filter_type=invoicingpayment', false);
            // $this->appendLink(JText::_('COM_INVOICING_TITLE_INTEGRATORS'), 'index.php?option=com_plugins&filter_type=invoicinggenerator', false);
          }
	}
	
	private function addSubmenuLink($view, $parent = null)
	{
		static $activeView = null;
		if(empty($activeView)) {
			$activeView = JRequest::getCmd('view','cpanel');
		}
	
		if ($activeView == 'cpanels')
		{
			$activeView = 'cpanel';
		}
	
		$key = strtoupper($this->component).'_TITLE_'.strtoupper($view);
		if(strtoupper(JText::_($key)) == $key) {
			$altview = FOFInflector::isPlural($view) ? FOFInflector::singularize($view) : FOFInflector::pluralize($view);
			$key2 = strtoupper($this->component).'_TITLE_'.strtoupper($altview);
			if(strtoupper(JText::_($key2)) == $key2) {
				$name = ucfirst($view);
			} else {
				$name = JText::_($key2);
			}
		} else {
			$name = JText::_($key);
		}
	
		$link = 'index.php?option='.$this->component.'&view='.$view;
	
		$active = $view == $activeView;
	
		$this->appendLink($name, $link, $active, null, $parent);
	}
	
	public function onVendorsBrowse()
	{
		// Set toolbar title
		$option = JRequest::getCmd('option','com_invoicing');
		$subtitle_key = strtoupper($option.'_TITLE_'.JRequest::getCmd('view','cpanel'));
		$content = JText::_( strtoupper($option)).' &ndash; <small>'.JText::_($subtitle_key).'</small>';
		$content = strip_tags(preg_replace("/&#?[a-z0-9]{2,8};/i","",$content));
		//strip tags removes <small> preg_replace removes "&ndash;"
		JToolBarHelper::title($content, str_replace('com_', '', $option));

		
		// Add toolbar buttons
		if($this->perms->create) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				JToolBarHelper::addNew();
			} else {
				JToolBarHelper::addNewX();
			}
		}
		if($this->perms->edit) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				JToolBarHelper::editList();
			} else {
				JToolBarHelper::editListX();
			}
		}
		if($this->perms->create || $this->perms->edit) {
			JToolBarHelper::divider();
		}

		if($this->perms->delete) {
			$msg = JText::_(JRequest::getCmd('option','com_invoicing').'_CONFIRM_DELETE');
			JToolBarHelper::deleteList($msg);
		}
		JToolBarHelper::preferences('com_invoicing', 550, 875);
		$bar = JToolBar::getInstance('toolbar');
		$label = 'JTOOLBAR_HELP';
		$bar->appendButton( 'Popup', 'help', $label, 'http://www.joomprod.com/invoicing-documentation', 1000, 500 );
		$this->renderSubmenu();
	}
	
	public function onTemplatesBrowse()
	{
		// Set toolbar title
		$option = JRequest::getCmd('option','com_invoicing');
		$subtitle_key = strtoupper($option.'_TITLE_'.JRequest::getCmd('view','cpanel'));
		$content = JText::_( strtoupper($option)).' &ndash; <small>'.JText::_($subtitle_key).'</small>';
		$content = strip_tags(preg_replace("/&#?[a-z0-9]{2,8};/i","",$content));
		//strip tags removes <small> preg_replace removes "&ndash;"
		JToolBarHelper::title($content, str_replace('com_', '', $option));

	
		// Add toolbar buttons
		/* 		if($this->perms->create) {
		if(version_compare(JVERSION, '3.0', 'ge')) {
		JToolBarHelper::addNew();
		} else {
		JToolBarHelper::addNewX();
		}
		} */
	
		if($this->perms->edit) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				JToolBarHelper::editList();
			} else {
			JToolBarHelper::editListX();
			}
		}
		if($this->perms->create || $this->perms->edit) {
			JToolBarHelper::divider();
		}
	
		JToolBarHelper::preferences('com_invoicing', 550, 875);
		$bar = JToolBar::getInstance('toolbar');
		$label = 'JTOOLBAR_HELP';
		$bar->appendButton( 'Popup', 'help', $label, 'http://www.joomprod.com/invoicing-documentation', 1000, 500 );
		$this->renderSubmenu();
	}
	
	public function onTemplatesEdit()
	{
		// Set toolbar title
		$option = JRequest::getCmd('option','com_invoicing');
		$subtitle_key = strtoupper($option.'_TITLE_'.JRequest::getCmd('view','cpanel'));
		$content = JText::_( strtoupper($option)).' &ndash; <small>'.JText::_($subtitle_key).'</small>';
		$content = strip_tags(preg_replace("/&#?[a-z0-9]{2,8};/i","",$content));
		//strip tags removes <small> preg_replace removes "&ndash;"
		JToolBarHelper::title($content, str_replace('com_', '', $option));

	
		if($this->perms->edit) {
					JToolBarHelper::apply();
					JToolBarHelper::save();
					JToolBarHelper::cancel();
		}
		JToolBarHelper::preferences('com_invoicing', 550, 875);
		$bar = JToolBar::getInstance('toolbar');
		$label = 'JTOOLBAR_HELP';
		$bar->appendButton( 'Popup', 'help', $label, 'http://www.joomprod.com/invoicing-documentation', 1000, 500 );
	
				$this->renderSubmenu();
	}
	
	public function onEmailsBrowse()
	{
		// Set toolbar title
		$option = JRequest::getCmd('option','com_invoicing');
		$subtitle_key = strtoupper($option.'_TITLE_'.JRequest::getCmd('view','cpanel'));
		$content = JText::_( strtoupper($option)).' &ndash; <small>'.JText::_($subtitle_key).'</small>';
		$content = strip_tags(preg_replace("/&#?[a-z0-9]{2,8};/i","",$content));
		//strip tags removes <small> preg_replace removes "&ndash;"
		JToolBarHelper::title($content, str_replace('com_', '', $option));

		
		// Add toolbar buttons
/* 		if($this->perms->create) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				JToolBarHelper::addNew();
			} else {
				JToolBarHelper::addNewX();
			}
		} */
		
		if($this->perms->edit) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				JToolBarHelper::editList();
			} else {
				JToolBarHelper::editListX();
			}
		}
		if($this->perms->create || $this->perms->edit) {
			JToolBarHelper::divider();
		}

		JToolBarHelper::preferences('com_invoicing', 550, 875);
		$bar = JToolBar::getInstance('toolbar');
		$label = 'JTOOLBAR_HELP';
		$bar->appendButton( 'Popup', 'help', $label, 'http://www.joomprod.com/invoicing-documentation', 1000, 500 );
		$this->renderSubmenu();
	}
	
	public function onLogsEdit()
	{
		// Set toolbar title
		$option = JRequest::getCmd('option','com_invoicing');
		$subtitle_key = strtoupper($option.'_TITLE_'.JRequest::getCmd('view','cpanel'));
		$content = JText::_( strtoupper($option)).' &ndash; <small>'.JText::_($subtitle_key).'</small>';
		$content = strip_tags(preg_replace("/&#?[a-z0-9]{2,8};/i","",$content));
		//strip tags removes <small> preg_replace removes "&ndash;"
		JToolBarHelper::title($content, str_replace('com_', '', $option));
		
		JToolBarHelper::preferences('com_invoicing', 550, 875);
		$bar = JToolBar::getInstance('toolbar');
		$label = 'JTOOLBAR_HELP';
		$bar->appendButton( 'Popup', 'help', $label, 'http://www.joomprod.com/invoicing-documentation', 1000, 500 );
		
		$this->renderSubmenu();
	}

	public function onEmailsEdit()
	{
		// Set toolbar title
		$option = JRequest::getCmd('option','com_invoicing');
		$subtitle_key = strtoupper($option.'_TITLE_'.JRequest::getCmd('view','cpanel'));
		$content = JText::_( strtoupper($option)).' &ndash; <small>'.JText::_($subtitle_key).'</small>';
		$content = strip_tags(preg_replace("/&#?[a-z0-9]{2,8};/i","",$content));
		//strip tags removes <small> preg_replace removes "&ndash;"
		JToolBarHelper::title($content, str_replace('com_', '', $option));

		
		if($this->perms->edit) {
				JToolBarHelper::apply();
				JToolBarHelper::save();
				JToolBarHelper::cancel();
		}
		JToolBarHelper::preferences('com_invoicing', 550, 875);
		$bar = JToolBar::getInstance('toolbar');
		$label = 'JTOOLBAR_HELP';
		$bar->appendButton( 'Popup', 'help', $label, 'http://www.joomprod.com/invoicing-documentation', 1000, 500 );
		
		$this->renderSubmenu();
	}
	
	public function onInvoicesMail()
	{
		// Set toolbar title
		$option = JRequest::getCmd('option','com_invoicing');
		$subtitle_key = strtoupper($option.'_TITLE_'.JRequest::getCmd('view','cpanel'));
		$content = JText::_( strtoupper($option)).' &ndash; <small>'.JText::_($subtitle_key).'</small>';
		$content = strip_tags(preg_replace("/&#?[a-z0-9]{2,8};/i","",$content));
		//strip tags removes <small> preg_replace removes "&ndash;"
		JToolBarHelper::title($content, str_replace('com_', '', $option));

		JToolBarHelper::preferences('com_invoicing', 550, 875);
		$this->renderSubmenu();
	}
	
	
	
	public function onUsersBrowse()
	{
		// Set toolbar title
		$option = JRequest::getCmd('option','com_invoicing');
		$subtitle_key = strtoupper($option.'_TITLE_'.JRequest::getCmd('view','cpanel'));
		$content = JText::_( strtoupper($option)).' &ndash; <small>'.JText::_($subtitle_key).'</small>';
		$content = strip_tags(preg_replace("/&#?[a-z0-9]{2,8};/i","",$content));
		//strip tags removes <small> preg_replace removes "&ndash;"
		JToolBarHelper::title($content, str_replace('com_', '', $option));

		
		// Add toolbar buttons
		if($this->perms->create) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				JToolBarHelper::addNew();
			} else {
				JToolBarHelper::addNewX();
			}
		}
		if($this->perms->edit) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				JToolBarHelper::editList();
			} else {
				JToolBarHelper::editListX();
			}
		}
		if($this->perms->create || $this->perms->edit) {
			JToolBarHelper::divider();
		}

		if($this->perms->delete) {
			$msg = JText::_(JRequest::getCmd('option','com_invoicing').'_CONFIRM_DELETE');
			JToolBarHelper::deleteList($msg);
		}
		JToolBarHelper::preferences('com_invoicing', 550, 875);
		$bar = JToolBar::getInstance('toolbar');
		$label = 'JTOOLBAR_HELP';
		$bar->appendButton( 'Popup', 'help', $label, 'http://www.joomprod.com/invoicing-documentation', 1000, 500 );
		$this->renderSubmenu();
	}
	
		public function onInvoicesBrowse()
	{
		// Set toolbar title
		$option = JRequest::getCmd('option','com_invoicing');
		$subtitle_key = strtoupper($option.'_TITLE_'.JRequest::getCmd('view','cpanel'));
		$content = JText::_( strtoupper($option)).' &ndash; <small>'.JText::_($subtitle_key).'</small>';
		$content = strip_tags(preg_replace("/&#?[a-z0-9]{2,8};/i","",$content));
		//strip tags removes <small> preg_replace removes "&ndash;"
		JToolBarHelper::title($content, str_replace('com_', '', $option));

		// Add toolbar buttons
		if($this->perms->create) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				JToolBarHelper::addNew();
			} else {
				JToolBarHelper::addNewX();
			}
		}
		if($this->perms->edit) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				JToolBarHelper::editList();
			} else {
				JToolBarHelper::editListX();
			}
		}
		if($this->perms->create || $this->perms->edit) {
			JToolBarHelper::divider();
		}

		if($this->perms->delete) {
			$msg = JText::_(JRequest::getCmd('option','com_invoicing').'_CONFIRM_DELETE');
			JToolBarHelper::deleteList($msg);
		}
		JToolBarHelper::preferences('com_invoicing', 550, 875);
		$bar = JToolBar::getInstance('toolbar');
		$label = 'JTOOLBAR_HELP';
		$bar->appendButton( 'Popup', 'help', $label, 'http://www.joomprod.com/invoicing-documentation', 1000, 500 );
		$this->renderSubmenu();
	}
	
    public function onQuotesBrowse()
	{
		// Set toolbar title
		$option = JRequest::getCmd('option','com_invoicing');
		$subtitle_key = strtoupper($option.'_TITLE_'.JRequest::getCmd('view','cpanel'));
		$content = JText::_( strtoupper($option)).' &ndash; <small>'.JText::_($subtitle_key).'</small>';
		$content = strip_tags(preg_replace("/&#?[a-z0-9]{2,8};/i","",$content));
		//strip tags removes <small> preg_replace removes "&ndash;"
		JToolBarHelper::title($content, str_replace('com_', '', $option));

		
		// Add toolbar buttons
		if($this->perms->create) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				JToolBarHelper::addNew();
			} else {
				JToolBarHelper::addNewX();
			}
		}
		if($this->perms->edit) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				JToolBarHelper::editList();
			} else {
				JToolBarHelper::editListX();
			}
		}
		if($this->perms->create || $this->perms->edit) {
			JToolBarHelper::divider();
		}

		if($this->perms->delete) {
			$msg = JText::_(JRequest::getCmd('option','com_invoicing').'_CONFIRM_DELETE');
			JToolBarHelper::deleteList($msg);
		}
        
        JToolBarHelper::custom('toInvoice', 'stats','',JText::_('COM_INVOICING_TO_INVOICE'));
		
        JToolBarHelper::preferences('com_invoicing', 550, 875);
        $bar = JToolBar::getInstance('toolbar');
        $label = 'JTOOLBAR_HELP';
        $bar->appendButton( 'Popup', 'help', $label, 'http://www.joomprod.com/invoicing-documentation', 1000, 500 );
        
		$this->renderSubmenu();
	}
    
	public function onProcessorsBrowse()
	{
		// Set toolbar title
		$option = JRequest::getCmd('option','com_invoicing');
		$subtitle_key = strtoupper($option.'_TITLE_'.JRequest::getCmd('view','cpanel'));
		$content = JText::_( strtoupper($option)).' &ndash; <small>'.JText::_($subtitle_key).'</small>';
		$content = strip_tags(preg_replace("/&#?[a-z0-9]{2,8};/i","",$content));
		//strip tags removes <small> preg_replace removes "&ndash;"
		JToolBarHelper::title($content, str_replace('com_', '', $option));

	
		// Add toolbar buttons
		if($this->perms->edit) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				JToolBarHelper::editList();
			} else {
				JToolBarHelper::editListX();
			}
		}
		$this->renderSubmenu();
	}
	
	public function onPluginsBrowse($plugin_type) {
		
		// Set toolbar title
		$option = JRequest::getCmd('option','com_invoicing');
		if ($plugin_type == "invoicingpayment") {
			$subtitle_key = 'COM_INVOICING_TITLE_PROCESSORS';
		} else {
			$subtitle_key = 'COM_INVOICING_TITLE_INTEGRATORS';
		}
		$content = JText::_( strtoupper($option)).' &ndash; <small>'.JText::_($subtitle_key).'</small>';
		$content = strip_tags(preg_replace("/&#?[a-z0-9]{2,8};/i","",$content));
		//strip tags removes <small> preg_replace removes "&ndash;"
		JToolBarHelper::title($content, str_replace('com_', '', $option));

		JToolBarHelper::preferences('com_invoicing', 550, 875);
		$this->renderSubmenu();
	}
	
	public function onBrowse()
	{
		parent::onBrowse();
		JToolBarHelper::preferences('com_invoicing', 550, 875);
        $bar = JToolBar::getInstance('toolbar');
		$label = 'JTOOLBAR_HELP';
		$bar->appendButton( 'Popup', 'help', $label, 'http://www.joomprod.com/invoicing-documentation', 1000, 500 );
	}
	
	public function onCpanelsBrowse(){
		$option = FOFInput::getCmd('option','com_invoicing',$this->input);
		$content = JText::_( strtoupper($option));
		$content = strip_tags(preg_replace("/&#?[a-z0-9]{2,8};/i","",$content));
		//strip tags removes <small> preg_replace removes "&ndash;"
		JToolBarHelper::title($content, str_replace('com_', '', $option));

		
		JToolBarHelper::preferences('com_invoicing', 550, 875);
        $bar = JToolBar::getInstance('toolbar');
		$label = 'JTOOLBAR_HELP';
		$bar->appendButton( 'Popup', 'help', $label, 'http://www.joomprod.com/invoicing-documentation', 1000, 500 );
		
		$this->renderSubmenu();
	}
	
	public function onCouponsBrowse()
	{
		// Set toolbar title
		$option = JRequest::getCmd('option','com_invoicing');
		$subtitle_key = strtoupper($option.'_TITLE_'.JRequest::getCmd('view','cpanel'));
		$content = JText::_( strtoupper($option)).' &ndash; <small>'.JText::_($subtitle_key).'</small>';
		$content = strip_tags(preg_replace("/&#?[a-z0-9]{2,8};/i","",$content));
		//strip tags removes <small> preg_replace removes "&ndash;"
		JToolBarHelper::title($content, str_replace('com_', '', $option));

		// Add toolbar buttons
		if($this->perms->create) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				JToolBarHelper::addNew();
			} else {
				JToolBarHelper::addNewX();
			}
		}
		if($this->perms->edit) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				JToolBarHelper::editList();
			} else {
				JToolBarHelper::editListX();
			}
			JToolBarHelper::publish();
			JToolBarHelper::unpublish();
		}
		if($this->perms->create || $this->perms->edit) {
			JToolBarHelper::divider();
		}

		if($this->perms->delete) {
			$msg = JText::_(JRequest::getCmd('option','com_invoicing').'_CONFIRM_DELETE');
			JToolBarHelper::deleteList($msg);
		}
		
		JToolBarHelper::preferences('com_invoicing', 550, 875);
		$bar = JToolBar::getInstance('toolbar');
		$label = 'JTOOLBAR_HELP';
		$bar->appendButton( 'Popup', 'help', $label, 'http://www.joomprod.com/invoicing-documentation', 1000, 500 );
		$this->renderSubmenu();
	}
	
	public function onCurrenciesBrowse()
	{
		// Set toolbar title
		$option = JRequest::getCmd('option','com_invoicing');
		$subtitle_key = strtoupper($option.'_TITLE_'.JRequest::getCmd('view','cpanel'));
		$content = JText::_( strtoupper($option)).' &ndash; <small>'.JText::_($subtitle_key).'</small>';
		$content = strip_tags(preg_replace("/&#?[a-z0-9]{2,8};/i","",$content));
		//strip tags removes <small> preg_replace removes "&ndash;"
		JToolBarHelper::title($content, str_replace('com_', '', $option));

		// Add toolbar buttons
		if($this->perms->create) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				JToolBarHelper::addNew();
			} else {
				JToolBarHelper::addNewX();
			}
		}
		if($this->perms->edit) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				JToolBarHelper::editList();
			} else {
				JToolBarHelper::editListX();
			}
			JToolBarHelper::publish();
			JToolBarHelper::unpublish();
		}
		if($this->perms->create || $this->perms->edit) {
			JToolBarHelper::divider();
		}

		if($this->perms->delete) {
			$msg = JText::_(JRequest::getCmd('option','com_invoicing').'_CONFIRM_DELETE');
			JToolBarHelper::deleteList($msg);
		}
		
		JToolBarHelper::preferences('com_invoicing', 550, 875);
		$bar = JToolBar::getInstance('toolbar');
		$label = 'JTOOLBAR_HELP';
		$bar->appendButton( 'Popup', 'help', $label, 'http://www.joomprod.com/invoicing-documentation', 1000, 500 );
		$this->renderSubmenu();
	}
	
	public function onReferencesBrowse()
	{
		// Set toolbar title
		$option = JRequest::getCmd('option','com_invoicing');
		$subtitle_key = strtoupper($option.'_TITLE_'.JRequest::getCmd('view','cpanel'));
		$content = JText::_( strtoupper($option)).' &ndash; <small>'.JText::_($subtitle_key).'</small>';
		$content = strip_tags(preg_replace("/&#?[a-z0-9]{2,8};/i","",$content));
		//strip tags removes <small> preg_replace removes "&ndash;"
		JToolBarHelper::title($content, str_replace('com_', '', $option));

		// Add toolbar buttons
		if($this->perms->create) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				JToolBarHelper::addNew();
			} else {
				JToolBarHelper::addNewX();
			}
		}
		if($this->perms->edit) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				JToolBarHelper::editList();
			} else {
				JToolBarHelper::editListX();
			}
			JToolBarHelper::publish();
			JToolBarHelper::unpublish();
		}
		if($this->perms->create || $this->perms->edit) {
			JToolBarHelper::divider();
		}

		if($this->perms->delete) {
			$msg = JText::_(JRequest::getCmd('option','com_invoicing').'_CONFIRM_DELETE');
			JToolBarHelper::deleteList($msg);
		}
		
		JToolBarHelper::preferences('com_invoicing', 550, 875);
		$bar = JToolBar::getInstance('toolbar');
		$label = 'JTOOLBAR_HELP';
		$bar->appendButton( 'Popup', 'help', $label, 'http://www.joomprod.com/invoicing-documentation', 1000, 500 );
		$this->renderSubmenu();
	}
	
	public function onTaxesBrowse()
	{
		// Set toolbar title
		$option = JRequest::getCmd('option','com_invoicing');
		$subtitle_key = strtoupper($option.'_TITLE_'.JRequest::getCmd('view','cpanel'));
		$content = JText::_( strtoupper($option)).' &ndash; <small>'.JText::_($subtitle_key).'</small>';
		$content = strip_tags(preg_replace("/&#?[a-z0-9]{2,8};/i","",$content));
		//strip tags removes <small> preg_replace removes "&ndash;"
		JToolBarHelper::title($content, str_replace('com_', '', $option));

		// Add toolbar buttons
		if($this->perms->create) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				JToolBarHelper::addNew();
			} else {
				JToolBarHelper::addNewX();
			}
		}
		if($this->perms->edit) {
			if(version_compare(JVERSION, '3.0', 'ge')) {
				JToolBarHelper::editList();
			} else {
				JToolBarHelper::editListX();
			}
			JToolBarHelper::publish();
			JToolBarHelper::unpublish();
		}
		if($this->perms->create || $this->perms->edit) {
			JToolBarHelper::divider();
		}

		if($this->perms->delete) {
			$msg = JText::_(JRequest::getCmd('option','com_invoicing').'_CONFIRM_DELETE');
			JToolBarHelper::deleteList($msg);
		}
		
		JToolBarHelper::preferences('com_invoicing', 550, 875);
		$bar = JToolBar::getInstance('toolbar');
		$label = 'JTOOLBAR_HELP';
		$bar->appendButton( 'Popup', 'help', $label, 'http://www.joomprod.com/invoicing-documentation', 1000, 500 );
		$this->renderSubmenu();
	}
    
	// Do not add Help in Edit because onedit call onAdd    
    public function onAdd()
	{
		parent::onAdd();
        $bar = JToolBar::getInstance('toolbar');
		$label = 'JTOOLBAR_HELP';
		$bar->appendButton( 'Popup', 'help', $label, 'http://www.joomprod.com/invoicing-documentation', 1000, 500 );
	}
}