<?php
/**
 *  @package Virtualmoney
 *  @copyright Copyright (c)2013 JoomPROD
 *  @license GNU General Public License version 3, or later
 */

defined('_JEXEC') or die();

JHtml::_('behavior.tooltip');
if(version_compare(JVERSION, '3.0', 'ge')) {
	JHTML::_('behavior.framework');
} else {
	JHTML::_('behavior.mootools');
}

$this->loadHelper('select');
$this->loadHelper('cparams');
$this->loadHelper('format');
$this->loadHelper('user');

$hasAjaxOrderingSupport = $this->hasAjaxOrderingSupport();
?>

<form action="index.php" method="post" name="adminForm" id="adminForm">
<input type="hidden" name="option" value="com_virtualmoney" />
<input type="hidden" name="view" value="exchanges" />
<input type="hidden" id="task" name="task" value="browse" />
<input type="hidden" name="hidemainmenu" id="hidemainmenu" value="0" />
<input type="hidden" name="boxchecked" id="boxchecked" value="0" />
<input type="hidden" name="filter_order" id="filter_order" value="<?php echo $this->lists->order ?>" />
<input type="hidden" name="filter_order_Dir" id="filter_order_Dir" value="<?php echo $this->lists->order_Dir ?>" />
<?php echo JHTML::_( 'form.token' ); ?>

<?php if(VirtualmoneyHelperCparams::getParam('exchange_module_enabled',0) == 0){ ?>
<div class="alert">
    <strong><?php echo JText::_('COM_VIRTUALMONEY_WARNING'); ?></strong> <?php echo JText::_('COM_VIRTUALMONEY_MODULE_EXCHANGE_NEEDED'); ?>
</div>
<?php } ?>
<input type="text" name="search" id="search"
	value="<?php echo $this->escape($this->getModel()->getState('search',''));?>"
	class="input-medium" onchange="document.adminForm.submit();"
	placeholder="<?php echo JText::_('COM_VIRTUALMONEY_COMMON_SEARCH')?>"
	/>
	
<nobr>
	
<button class="btn btn-mini" onclick="this.form.submit();">
	<?php echo JText::_('JSEARCH_FILTER'); ?>
</button>
<button class="btn btn-mini" onclick="document.adminForm.search.value='';this.form.submit();">
	<?php echo JText::_('JSEARCH_RESET'); ?>
</button>

</nobr>

<div class="filter-select fltrt">
<?php echo JHTML::_('calendar',$this->escape($this->getModel()->getState('dateFilterFrom','')), "dateFilterFrom", "dateFilterFrom", "%Y-%m-%d");?>
<?php echo JHTML::_('calendar',$this->escape($this->getModel()->getState('dateFilterTo','')), "dateFilterTo", "dateFilterTo", "%Y-%m-%d");?>
</div>
</nobr>
<table class="adminlist table table-striped" id="itemsList">
	<thead>
		<tr>
			<th>
				<?php echo JHTML::_('grid.sort', 'Num', 'virtualmoney_exchange_id', $this->lists->order_Dir, $this->lists->order, 'browse') ?>
			</th>
			<th>
				<?php echo JHTML::_('grid.sort', 'COM_VIRTUALMONEY_EXCHANGE_USER_ID1', 'user_id1', $this->lists->order_Dir, $this->lists->order, 'browse') ?>
			</th>
			<th>
				<?php echo JHTML::_('grid.sort', 'COM_VIRTUALMONEY_EXCHANGE_USER_ID2', 'user_id2', $this->lists->order_Dir, $this->lists->order, 'browse') ?>
			</th>
            <th>
				<?php echo JHTML::_('grid.sort', VirtualmoneyHelperFormat::getConfigFormatCurrency()->codePlural, 'credits', $this->lists->order_Dir, $this->lists->order, 'browse') ?>
			</th>
            <th>
				<?php echo JHTML::_('grid.sort', 'COM_VIRTUALMONEY_EXCHANGE_CREATED_ON', 'created_on', $this->lists->order_Dir, $this->lists->order, 'browse') ?>
			</th>
			<th width="40%">
				<?php echo JHTML::_('grid.sort', 'COM_VIRTUALMONEY_EXCHANGE_DESCRIPTION', 'description', $this->lists->order_Dir, $this->lists->order, 'browse') ?>
			</th>
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td colspan="20">
				<?php if($this->pagination->total > 0) echo $this->pagination->getListFooter() ?>
			</td>
		</tr>
	</tfoot>
	<tbody>
		<?php if($count = count($this->items)): ?>
		<?php $i = -1; $m = 0; ?>
		<?php foreach ($this->items as $exchange) : ?>
		<?php
			$i++; $m = 1-$m;
			$checkedOut = false;
			$ordering = $this->lists->order == 'ordering';
            $user1 = JFactory::getUser($exchange->user_id1);
            $user2 = JFactory::getUser($exchange->user_id2);
		?>
		<tr class="<?php echo  'row'.$m; ?>">
			<td align="center">
				<?php echo $exchange->virtualmoney_exchange_id; ?>
			</td>
			<td align="center">
                <?php echo  $this->escape(VirtualmoneyHelperUser::getUsername($user1)) ?>
			</td>
			<td align="center">
                <?php echo  $this->escape(VirtualmoneyHelperUser::getUsername($user2)) ?>
			</td>
			<td align="center">
				<?php echo VirtualmoneyHelperFormat::formatPrice($this->escape($exchange->credits)); ?>
			</td>
            <td align="center">
				<?php echo $this->escape($exchange->created_on) ?>
			</td>
            <td align="center">
					<strong><?php echo JText::_($this->escape($exchange->description)) ?></strong>
			</td>
		</tr>
		<?php endforeach; ?>	
		<?php else: ?>
		<tr>
			<td colspan="20">
				<?php echo  JText::_('COM_VIRTUALMONEY_COMMON_NORECORDS') ?>
			</td>
		</tr>
		<?php endif; ?>
	</tbody>
</table>

</form>