<?php
/**
 * @package		Invoicing
 * @copyright	Copyright (C) 2010-2011 JoomPROD.com. All rights reserved.
 * @license GNU General Public License version 3, or later
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

/**
 * 
 * @package		Joomla
 * @subpackage	Contacts
 */
class InvoicingViewInvoice extends InvoicingViewDefault
{
	public function onRead($tpl = NULL) {
		parent::onRead($tpl);
		$invoice  = $this->getModel()->getItem();
		$this->loadHelper('format');

		if ($invoice->invoice_number != null)
			$content = InvoicingHelperFormat::formatInvoiceHTML($invoice);
		else
			$content = InvoicingHelperFormat::formatOrderHTML($invoice);
	
		$this->assign('content',$content);
	}
	
	public function onAdd($tpl = null) {
        parent::onAdd($tpl);
        
        $quoteId = JRequest::getInt('quote', 0);
        
        /**
         * If quoteId is set we want to create a invoice from a quote.
         * We need to fill the invoice params with quote
         */
        if($quoteId){
            $quote = FOFModel::getTmpInstance('Quotes', 'InvoicingModel')
                     ->getItem($quoteId);
            
            $quote->invoicing_invoice_id = null;
            $quote->order_number = null;
            $quote->invoice_number = null;
            $quote->status = null;
            
            // Need to remove the item id to recreate them in the invoice
            foreach($quote->items as $key => $item) {
            	$quote->items[$key]->invoicing_invoice_item_id = "";
            }
            
            $this->assign('item',$quote);
        }
	}
}