<?php
/**
 * @package		Invoicing
 * @copyright	Copyright (C) 2010-2011 JoomPROD.com. All rights reserved.
 * @license GNU General Public License version 3, or later
 */

defined('_JEXEC') or die();

JHtml::_('behavior.tooltip');
if(version_compare(JVERSION, '3.0', 'ge')) {
	JHTML::_('behavior.framework');
} else {
	JHTML::_('behavior.mootools');
}
JHtml::_('behavior.modal');
JHtml::_('behavior.calendar');
jimport('joomla.language.helper');

FOFTemplateUtils::addJS('media://com_invoicing/js/jquery.validate.js');

$this->loadHelper('cparams');
$this->loadHelper('select');
$this->loadHelper('format');
$this->loadHelper('params');
$this->loadHelper('mail');

?>

<form action="index.php" method="post" name="adminForm" id="adminForm" class="adminForm form formValidation">
<input type="hidden" name="option" value="com_invoicing" />
<input type="hidden" name="view" value="reference" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="invoicing_reference_id" value="<?php echo $this->item->invoicing_reference_id ?>" />
<?php echo JHTML::_( 'form.token' ); ?>
	<div id="invoice-container">
			<div id="products">
				<table id="table">
					<tr>
						<td>
							<?php echo JText::_('INVOICING_COMMON_DESCRIPTION');?>
                        </td>
                        <td>
							<textarea id="description" cols="50" rows="3" style="width: 340px;" name="description"><?php echo $this->escape($this->item->description);?></textarea>
						</td>
					</tr>
					<tr>
						<td>
							<?php echo JText::_('INVOICING_COMMON_QUANTITY');?>
                        </td>
                        <td>
							<input id="quantity" type="text" style="width: 37px;" name="quantity" class="quantity" value="<?php echo $this->escape($this->item->quantity);?>" />
						</td>
					</tr>
					<tr>
						<td>
							<?php echo JText::_('INVOICING_COMMON_UNIT_PRICE');?>
                        </td>
                        <td>
							<input id="net_unit" type="text" name="net_unit_price" style="width: 105px;" class="net_unit" value="<?php echo $this->escape($this->item->net_unit_price);?>" />
						</td>
					</tr>
					<tr>
						<td>
							<?php echo JText::_('INVOICING_COMMON_TAX');?>
                        </td>
                        <td>
							<?php echo InvoicingHelperSelect::taxes("tax",$this->escape($this->item->tax),array('class'=>'tax_unit')) ?>
						</td>
					</tr>
					<tr>
						<td>
							<?php echo JText::_('INVOICING_COMMON_UNIT_PRICE_WITH_TAX');?>
                        </td>
                        <td>
							<input id="gross_unit_price" type="text" name="gross_unit_price" style="width: 105px;" class="gross_unit" value="<?php echo $this->escape($this->item->gross_unit_price);?>" />
						</td>
					</tr>
					<tr>
						<td>
							<?php echo JText::_('INVOICING_COMMON_TOTAL_PRICE_WITH_TAX');?>
                        </td>
                        <td>
							<input id="item_amount" type="text" readonly="readonly" name="gross_amount" class="item_amount" style="width: 105px;" value="<?php echo $this->escape($this->item->gross_amount);?>" />
						</td>
					</tr>
                </table>
			</div>
	</div> <!-- end invoice-container -->	
</form>
				<script type="text/javascript">				
				function formatPrice(num) {
					result = Math.round(num*100)/100;
					return result.toFixed(2);
				}
				function formatQuantity(num) {
					result = Math.round(num*100)/100;
					return result;
				}

				function computeItemPrice(element) 
				{
					switch(element) {
						case "tax":	
						case "gross":
						case "quantity":
							//var selector = '#'+item2+' .quantity';
							quantity = parseFloat(jQ('.quantity').val());
							tax = 100 + parseFloat(jQ('.tax_unit').val());
							gross = parseFloat(jQ('.net_unit').val());
							net = gross*tax/100;
							//alert(quantity+ " "+tax+" "+gross+ " "+net);
							jQ('.gross_unit').val(formatPrice(net));
							jQ('.net_unit').val(formatPrice(gross));
							break;
						case "net":
							quantity = parseFloat(jQ('.quantity').val());
							tax = 100 + parseFloat(jQ('.tax_unit').val());
							net = parseFloat(jQ('.gross_unit').val());
							gross = net*100/tax;
							jQ('.net_unit').val(formatPrice(gross));
					}
					
					jQ('.item_amount').val(formatPrice(quantity*net));

					computeTotalPrice();
				}
			
				var fixHelper = function(e, ui) {
					ui.children().each(function() {
						jQ(this).width(jQ(this).width());
					});
					return ui;
				};
				
				jQ(function() {
					jQ( "#table").on("change", ".quantity",function() {
						quantity = parseFloat(jQ(this).val());
						if ((isNaN(quantity))||(quantity == 0))
							quantity = 1;
						jQ(this).val(formatQuantity(quantity));
						computeItemPrice("quantity");
						return true;
					});

					jQ( "#table").on("change", ".net_unit",function() {
						gross = parseFloat(jQ(this).val());
						if (isNaN(gross))
							gross = 0;
						jQ(this).val(formatPrice(gross));
						computeItemPrice("gross");
						return true;
					});

					jQ( "#table").on("change", ".tax_unit",function() {
						computeItemPrice("tax");
						return true;
					});


					jQ( "#table").on("change", ".gross_unit",function() {
						net = parseFloat(jQ(this).val());
						if (isNaN(net))
							net = 0;
						jQ(this).val(formatPrice(net));
						computeItemPrice("net");
						return true;
					});

				});
				

		</script>
<script type="text/javascript">


window.addEvent("domready", function() {
	$$("button.modal").each(function(el) {
		el.addEvent("click", function(e) {
			try {
				new Event(e).stop();
			} catch(anotherMTUpgradeIssue) {
				try {
					e.stop();
				} catch(WhateverIsWrongWithYouIDontCare) {
					try {
						DOMEvent(e).stop();
					} catch(NoBleepinWay) {
						alert('If you see this message, your copy of Joomla! is FUBAR');
					}
				}
			}
			SqueezeBox.fromElement($('userselect'), {
				parse: 'rel'
			});
		});
	});
});
<?php if(version_compare(JVERSION,'1.6.0','>=')){ ?>
Joomla.submitbutton = function(pressbutton) {
<?php } else { ?>
function submitbutton(pressbutton) {
<?php } ?>
	if (pressbutton == 'cancel') {
		   submitform(pressbutton);	
		   return;
	}
    if(jQ("#adminForm").valid()){
    	submitform(pressbutton);	
    }else{
        return false;
    }
}

jQ().ready(function() { 
    // validate signup form on keyup and submit 
     var validator =jQ("#adminForm").validate({ 
         rules: { 
        	 description: { 
                 required: true
               }
			},
         messages: { 
			 description: { 
                 required: "<?php echo JText::_('INVOICING_VALIDATION_FIELD_REQUIRED');?>"
               }
         }         
     });
});
</script>
