<?php
/**
 *  @package	PaidSystem
 *  @copyright	Copyright (C) 2010-2013 JoomPROD.com. All rights reserved.
 *  @license    GNU General Public License version 3, or later
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

$lang = JFactory::getLanguage();
$lang->load("com_paidsystem",JPATH_ROOT);


function getBalance($userId) {
	include_once(JPATH_ROOT.'/components/com_virtualmoney/lib/core.php');
				
    return Virtualmoney::getCredits($userId);
}

function checkCredits($total, $userId) {
    include_once(JPATH_ROOT.'/components/com_virtualmoney/lib/core.php');
				
    return Virtualmoney::checkCredits($total,$userId);
}

function removeCredits($userId, $newCredits, $items, $source = '') {
    include_once(JPATH_ROOT.'/components/com_virtualmoney/lib/core.php');
    include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/cparams.php');
    include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/format.php');
    
    $description = JText::_('VIRTUALMONEY_BUY_AD')."\n";
    foreach($items as $item) {
        $description .= " - ".$item['description']." (".VirtualmoneyHelperFormat::formatPrice($item['gross_unit_price']).")\n";
    }
    
    Virtualmoney::removeCredits($userId,$newCredits,$description,$source);
}

function getPrice($price,$prefix="") {
	if ($price == 0)
		return "";
	
    $conf = getPaidSystemConfig();
    $mode = $conf->mode;
    
    if($mode == "payperad"){
        include_once(JPATH_ROOT.'/components/com_invoicing/lib/core.php');
        
        $currency = Invoicing::getCurrencies($conf->currency_id);
        
        return $prefix.Invoicing::formatPrice($price, $currency);
    } else {
        include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/cparams.php');
        include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/format.php');
        
        return $prefix.VirtualmoneyHelperFormat::formatPrice($price);
    }
}

function getCurrencySymbol() {
	static $mode = null;
	static $currency = null;
	
	if ($mode == null) {
		$conf = getPaidSystemConfig();
		$mode = $conf->mode;
	}

	if ($mode == "payperad") {
		include_once(JPATH_ROOT.'/components/com_invoicing/lib/core.php');
        
        $currency = Invoicing::getCurrencies($conf->currency_id);
        
        return $currency->code;
    } else {
        include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/format.php');
        include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/cparams.php');
		return VirtualmoneyHelperFormat::getConfigFormatCurrency()->codePlural;
    }
}

function getCurrencyPosition() {
	static $mode = null;
	static $currency = null;
	
	if ($mode == null) {
		$conf = getPaidSystemConfig();
		$mode = $conf->mode;
	}

	if ($mode == "payperad") {
		include_once(JPATH_ROOT.'/components/com_invoicing/lib/core.php');
        
        $currency = Invoicing::getCurrencies($conf->currency_id);
        
        return $currency->symbol_position;
    } else {
        include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/format.php');
        include_once(JPATH_ROOT.'/administrator/components/com_virtualmoney/helpers/cparams.php');
		return VirtualmoneyHelperFormat::getConfigFormatCurrency()->position;
    }
}

function savePaidAd($content,$contentid) {
	$db = JFactory::getDbo();
	
	if ($contentid != 0) {
		$db->setQuery("SELECT * FROM #__paidsystem_ads WHERE id = ".(int)$contentid);
		$row = $db->loadObject();
		if ($row == null) {
			$row = new JObject();
			$row->id = $contentid;
		}
	} else {
		$row = new JObject();
		$row->id = $contentid;
		$row->highlight = 0;
		$row->featured = 0;
		$row->top = 0;
	}
	
	$app = JFactory::getApplication();
	if ($app->isAdmin() == true) {
		$row->highlight = $content->data['paid']['highlight'];
		$row->highlight_date = $content->data['paid']['highlight_date'];
		$row->featured = $content->data['paid']['featured'];
		$row->featured_date = $content->data['paid']['featured_date'];
		$row->top = $content->data['paid']['top'];
		$row->top_date = $content->data['paid']['top_date'];
	} else {
		$highlight = $content->data['paid']['highlight'];
		if ($content->data['paid']['highlight'] != 0) {
			$db->setQuery( "SELECT * FROM #__paidsystem_highlight WHERE id=".(int)$highlight );
			$highlightduration = $db->loadObject();
			if ($highlightduration->duration == 0)
				$date = null;
			else
				$date = date("Y-m-d H:i:s",time()+$highlightduration->duration*3600*24);
			$row->highlight = 1;
			$row->highlight_date = $date;
		}
		
		$featured = $content->data['paid']['featured'];
		if ($content->data['paid']['featured'] != 0) {
			$db->setQuery( "SELECT * FROM #__paidsystem_featured WHERE id=".(int)$featured );
			$featuredduration = $db->loadObject();
			if ($featuredduration->duration == 0)
				$date = null;
			else
				$date = date("Y-m-d H:i:s",time()+$featuredduration->duration*3600*24);
			$row->featured = 1;
			$row->featured_date = $date;
		}
		
		$top = $content->data['paid']['top'];
		if ($content->data['paid']['top'] != 0) {
			$db->setQuery( "SELECT * FROM #__paidsystem_top WHERE id=".(int)$top );
			$topduration = $db->loadObject();
			if ($topduration->duration == 0)
				$date = null;
			else
				$date = date("Y-m-d H:i:s",time()+$topduration->duration*3600*24);
			$row->top = 1;
			$row->top_date = $date;
		}
	}
		
    if ($contentid != 0) {
    	$db->setQuery("DELETE FROM #__paidsystem_ads WHERE id = $contentid");
    	$db->query();	
    }
	$ret = $db->insertObject('#__paidsystem_ads', $row);
}

function getMaxPaidSystemImages()
{
	$db =JFactory::getDbo();
	
	$conf = getPaidSystemConfig();
	
	$query = "SELECT MAX(num_images) FROM #__paidsystem_categories WHERE 1";
	$db->setQuery($query);
	$max = $db->loadResult();
	
	if ($conf->num_images > $max)
		$max = $conf->num_images ;
		
	return $max;
}

function displayPaidCat($nbbasiccats)
{
	$db =JFactory::getDbo();
	$conf = getPaidSystemConfig();
	
	if  ($conf->nbcats > 0)
	{
		if ($conf->credits == 0)
			echo sprintf(JText::_('PAIDSYSTEM_CATPRICE1'),$nbbasiccats,getPrice($conf->cat_price),$conf->nbcats+$nbbasiccats);
		else
			echo sprintf(JText::_('PAIDSYSTEM_CATPRICE2'),$nbbasiccats,getPrice($conf->credits),getPrice($conf->cat_price),$conf->nbcats+$nbbasiccats);
	}
	else
	{
		echo sprintf(JText::_('ADSMANAGER_NBCATS_LEGEND'),$nbbasiccats);
	}
}

function getMaxCats($nbbasiccats)
{
	$conf = getPaidSystemConfig();
	
	return $nbbasiccats + $conf->nbcats;
}

function checkPaidField($field)	
{
	$db =JFactory::getDbo();
	$db->setQuery( "SELECT f.*,p.id,p.price FROM #__adsmanager_fields AS f  ".
						 "LEFT JOIN #__paidsystem_fields as p ON p.id = f.fieldid ".
						 "WHERE 1" );
	$fieldprices = $db->loadObjectList("id");
	if (isset($fieldprices[$field->fieldid])) {
		$price = $fieldprices[$field->fieldid]->price;
		if ($price > 0)
		{
			if (($field->type == "multicheckbox" )||($field->type == "radio"))
			{
				return "<tr><td>".getPrice($price)."</td></tr>";
			}
			else
				return getPrice($price);
		} else {
			return "";
		}
	}
}

function loadEditFormCheck($mode = "front")
{
}

function updatePaidSystemConf(&$conf,$catid)
{
	$db =JFactory::getDbo();
	
	$db->setQuery( "SELECT * FROM #__paidsystem_categories WHERE id = ".(int)$catid );
	$cat = $db->loadObject();
	
	if (isset($cat)&&($cat->specific))
	{
		$conf->credits = $cat->price;	
		$conf->num_images = $cat->num_images;
		$conf->image_price = $cat->image_price;
	}
}

function showPaidDuration($content) {
	$app = JFactory::getApplication();
	
	$date = $content->expiration_date;
	
	if (strtotime($date) < time())
		$date = date('Y-m-d');
	
	$db =JFactory::getDbo();
	$user = JFactory::getUser();
	
	$mode = getPaidSystemMode();
	
	if ($user->id == 0) {	
		TTools::redirectToLogin("index.php?option=com_adsmanager&view=expiration&id=".$content->id);
	}
	
	$catid = $content->catid;

	$db->setQuery( "SELECT * FROM #__paidsystem_duration WHERE published = 1 AND (type = 'both' OR type='renew') AND ( catsid LIKE '%,$catid,%' OR catsid LIKE '%,-1,%') " );
	$durations = $db->loadObjectList("id");
	
	$balance = getBalance($user->id);
	
	// get configuration
	$query = "SELECT * FROM #__adsmanager_config WHERE 1";
	$db->setQuery($query);
	$conf = $db->loadObject();
	
	$config = getPaidSystemConfig();

	$templateDir = JPATH_ROOT . '/templates/' . $app->getTemplate();
	if (is_file($templateDir.'/html/com_paidsystem/expiration/default.php')) {
		require($templateDir.'/html/com_paidsystem/expiration/default.php');
	} else {
		require(JPATH_ROOT.'/components/com_paidsystem/views/expiration/tmpl/default.php');
	}
}

function renewPaidAd($adid)
{
	$app = JFactory::getApplication();
	$db =JFactory::getDbo();
	$user = JFactory::getUser();
	
	if ($user->id == 0) {
		TTools::redirectToLogin("index.php?option=com_adsmanager&view=expiration&id=$adid");
	}
	
	$db->setQuery( "SELECT * FROM #__paidsystem_duration WHERE published = 1 AND (type = 'both' OR type='renew')" );
	$durations = $db->loadObjectList("id");
	
	$db->setQuery( "SELECT expiration_date FROM #__adsmanager_ads WHERE id = ".(int)$adid);
	$expiration_date = $db->loadResult();
	$time = strtotime($expiration_date);
	if ($time < time())
	{
		$time = time();
	}
	$current_time = $time;
	
	// get configuration
	$query = "SELECT * FROM #__adsmanager_config WHERE 1";
	$db->setQuery($query);
	$conf = $db->loadObject();
	
	if (count($durations) == 0)
	{
		$time = $time + ( $conf->ad_duration * 3600 *24);
		$newdate = date("Y-m-d",$time);
		
		//Check if needed
		if (time() < strtotime($expiration_date) - ($conf->recall_time * 3600 *24)) {
			$app->redirect(TRoute::_("index.php?option=com_adsmanager"),JText::_('ADSMANAGER_CONTENT_CANNOT_RESUBMIT'),"message");
		}
		
		//echo "UPDATE #__adsmanager_ads SET expiration_date = '$newdate', date_created = CURDATE(),recall_mail_sent=0,published=1 WHERE id=".(int)$adid;
		//exit();
		$db->setQuery( "UPDATE #__adsmanager_ads SET expiration_date = '$newdate', date_created = CURDATE(),date_modified = CURDATE(),recall_mail_sent=0,published=1 WHERE id=".(int)$adid);
		$db->query();
		if ($db -> getErrorNum()) {
			echo $db -> stderr();
			return false;
		}
	}
	else
	{
		$mode =getPaidSystemMode();
		
		if ($mode == "credits") {
			$config = getPaidSystemConfig();
			
			$balance = getBalance($user->id);
		
			$durationid = JRequest::getInt("ad_duration",-1);
		
			if (!isset($durations[$durationid])) {
				return false;
			} 
			
			if (ADSMANAGER_SPECIAL == "DAN") {
				$db->setQuery( "SELECT images FROM #__adsmanager_ads WHERE id=".(int)$adid );
				$images = $db->loadResult();
				$images = @json_decode($images);
				if (!is_array($images))
					$images = array();
				$nbimages = count($images);
				$nbpaidimages = $nbimages - $conf->nb_images;
				if ($nbpaidimages < 0)
					$nbpaidimages = 0;
			
				$cost = $durations[$durationid]->credits + $config->image_price * $nbpaidimages * ceil($durations[$durationid]->duration/7);
				//var_dump($nbpaidimages);exit();
			} else {
				$cost = $durations[$durationid]->credits;
			}
			
			if ($balance >= $cost) {
				removeCredits($user->id,$cost,"Id = $adid, duration price");	
			
				if ($durations[$durationid]->duration === 0) {
					$newdate = "NULL";
				} else {
					$time = $time + ( $durations[$durationid]->duration * 3600 *24); 
					$newdate = "'".date("Y-m-d",$time)."'";
				}
		
				$db->setQuery( "UPDATE #__adsmanager_ads SET expiration_date = $newdate, date_created = CURDATE(),date_modified = CURDATE(),recall_mail_sent=0,published=1 WHERE id=".(int)$adid);
				$db->query();
				$cache = JFactory::getCache( 'com_adsmanager');
				$cache->clean();
				if ($db -> getErrorNum()) {
					echo $db -> stderr();
					return false;
				}
				return true;
			}
			else {
				return false;
			}
		} else {
			$config = getPaidSystemConfig();
		
			$durationid = JRequest::getInt("ad_duration",-1);
			
			if (!isset($durations[$durationid]))
				return false;
			
			if (ADSMANAGER_SPECIAL == "DAN") {
				$db->setQuery( "SELECT images FROM #__adsmanager_ads WHERE id=".(int)$adid );
				$images = $db->loadResult();
				$images = @json_decode($images);
				if (!is_array($images))
					$images = array();
				$nbimages = count($images);
				$nbpaidimages = $nbimages - $conf->nb_images;
				if ($nbpaidimages < 0)
					$nbpaidimages = 0;
				
				$cost = $durations[$durationid]->credits + $config->image_price * $nbpaidimages * ceil($durations[$durationid]->duration/7);
				
			} else {
				$cost = $durations[$durationid]->credits;
			}
			
			if ($cost == 0) {
				if ($durations[$durationid]->duration === 0) {
					$newdate = "NULL";
				} else {
					$time = $time + ( $durations[$durationid]->duration * 3600 *24); 
					$newdate = "'".date("Y-m-d",$time)."'";
				}
				
				$db->setQuery( "UPDATE #__adsmanager_ads SET expiration_date = $newdate, date_created = CURDATE(),date_modified = CURDATE(),recall_mail_sent=0,published=1 WHERE id=".(int)$adid);
				$db->query();
				if ($db -> getErrorNum()) {
					echo $db -> stderr();
					return false;
				}
				return true;
			} else {	
				$query = "DELETE FROM #__adsmanager_pending_ads WHERE contentid = ".(int)$adid;
				$db->setQuery($query);
				$db->query();
				
				$row = new JObject();
				$row->contentid = $adid;
				$row->content = json_encode(array('renew_duration' => (int)$durations[$durationid]->duration));
				$row->date = date("Y-m-d H:i:s");
				$row->userid = $user->id;
				$db->insertObject('#__adsmanager_pending_ads', $row);
				$pending_id = (int)$db->insertid();
				
				include_once(JPATH_ROOT.'/components/com_invoicing/lib/core.php');
				
				$items = array();
				if ($durations[$durationid]->duration === 0) {
					$text = JText::_('PAIDSYSTEM_ORDER_RENEW_UNLIMITED');
				} else {
					$text = sprintf(JText::_('PAIDSYSTEM_ORDER_RENEW'),(int)$durations[$durationid]->duration);
				}
				$items[] = array('quantity'=>1,'tax'=>$config->tax,'description'=>$text,'gross_unit_price'=>$cost,
								 'source'=>'adsmanager-renew');
				
				$invoice_id = Invoicing::createInvoice($user->id, $items, "adsmanager",$adid,
										 $config->currency_id);
				Invoicing::redirectToPayment($invoice_id);
			}
		}
	}
}

function getCategoryOption($cat,&$result) {
	static $catprices = null;
	
	$conf = getPaidSystemConfig();
	
	if ($conf->nbcats == 0)
	{
		if ($catprices == null) {
			$db = JFactory::getDbo();
			$db->setQuery("SELECT * FROM #__paidsystem_categories WHERE 1");
			$catprices = $db->loadObjectList("id");
			foreach($catprices as $key => $notused)
			{
				if ($catprices[$key]->specific == 0)
				{
					$catprices[$key]->price = $conf->credits;
				}
			}
		}
		
		if (!isset($catprices[$cat->id])) {
			$price = 0;
		} else {
			$price = $catprices[$cat->id]->price ;
		}
		$result['attribs']= "price='$price'";
		$result['label'] .= getPrice($price," - ");
	} 
}

function getPaidSystemConfig() {
	static $conf = null;
	if ($conf == null) {
		$db = JFactory::getDbo();
		$query = "SELECT * FROM #__paidsystem_config WHERE 1";
		$db->setQuery($query);
		$conf = $db->loadObject();
		$params = json_decode($conf->params);
		if ($params != null) {
			foreach($params as $name => $value) {
				$conf->$name = $value;
			}
		}
	}
	return $conf;
}

function editPaidAd($row,$isUpdateMode,$adsmanager_conf,$mode = "front")
{
	$db = JFactory::getDbo();
	$user = JFactory::getUser();
	$baseurl = JURI::root();
	
	$conf = getPaidSystemConfig();
	
	if (isset($row->userid)&&($row->userid != 0))
		$userid = $row->userid;
	else
		$userid = $user->id;

	if ($conf->mode == "credits" )
		$balance = getBalance($userid);
	
	if (isset($row->id)) {
		$db->setQuery( "SELECT * FROM #__paidsystem_ads WHERE id=".(int)$row->id );
		$adext = $db->loadObject();
		$ad_id =  $row->id;
	}
	else {
		$adext = null;
		$ad_id = 0;
		$row = new stdClass();
		$row->id = 0;
	}

	
	$default = 0;
	if (($row->id != 0)||($row->id != ""))
		$default = $row->cats[0]->catid; //TODO it was selectedcats ???
	$catid = JRequest::getInt("catid",$default);
	
	if ($adsmanager_conf->nbcats + $conf->nbcats == 1)
	{
		updatePaidSystemConf($conf,$catid);
	}

	$db->setQuery( "SELECT f.*,p.id,p.price FROM #__adsmanager_fields AS f  ".
					 "LEFT JOIN #__paidsystem_fields as p ON p.id = f.fieldid ".
					 "WHERE f.published = 1 ORDER by f.ordering" );
	$fieldprices = $db->loadObjectList("id");
	
	$db->setQuery( "SELECT * FROM #__paidsystem_duration WHERE published = 1 AND (type = 'both' OR type='new')  AND ( catsid LIKE '%,$catid,%' OR catsid LIKE '%,-1,%') ORDER BY ordering ASC" );
	$durations = $db->loadObjectList();

	$db->setQuery( "SELECT DATEDIFF(expiration_date,date_created) FROM #__adsmanager_ads WHERE id=".(int)$row->id );
	$days = $db->loadResult();
	
	if($conf->featured_active == 1){
		$db->setQuery( "SELECT * FROM #__paidsystem_featured ORDER BY ordering ASC " );
		$featureddurations = $db->loadObjectList();
	}
	
	if($conf->highlight_active == 1){
		$db->setQuery( "SELECT * FROM #__paidsystem_highlight ORDER BY ordering ASC" );
		$highlightdurations = $db->loadObjectList();
	}
	
	if($conf->top_active == 1){
		$db->setQuery( "SELECT * FROM #__paidsystem_top ORDER BY ordering ASC" );
		$topdurations = $db->loadObjectList();
		if ($row->id == 0) {
			foreach($topdurations as $k => $t) {
				if ($t->duration == 1) {
					unset($topdurations[$k]);
				}
			}
		}
	}
	
	$app = JFactory::getApplication();
	$templateDir = JPATH_ROOT . '/templates/' . $app->getTemplate();
	if (is_file($templateDir.'/html/com_paidsystem/edit/default.php')) {
		require($templateDir.'/html/com_paidsystem/edit/default.php');
	} else {
		require(JPATH_ROOT.'/components/com_paidsystem/views/edit/tmpl/default.php');
	}
	
	if (is_file($templateDir.'/html/com_paidsystem/edit/javascript.php')) {
		require($templateDir.'/html/com_paidsystem/edit/javascript.php');
	} else {
		require(JPATH_ROOT.'/components/com_paidsystem/views/edit/tmpl/javascript.php');
	}
	?>
	<?php
}

function editAdminPaidAd($row,$isUpdateMode,$adsmanager_conf)
{
	$db = JFactory::getDbo();
	$user = JFactory::getUser();
	$baseurl = JURI::root();
	
	$conf = getPaidSystemConfig();
	
	if (isset($row->userid)&&($row->userid != 0))
		$userid = $row->userid;
	else
		$userid = $user->id;
		
	if (isset($row->id)) {
		$db->setQuery( "SELECT * FROM #__paidsystem_ads WHERE id=".(int)$row->id );
		$adext = $db->loadObject();
		$ad_id =  $row->id;
	}
	else {
		$adext = null;
		$ad_id = 0;
		$row = new stdClass();
		$row->id = 0;
	}

	if ($adsmanager_conf->nbcats + $conf->nbcats == 1)
	{
		$default = 0;
		if (($row->id != 0)||($row->id != ""))
			$default = $row->cats[0]->catid; //TODO it was selectedcats ???
		$catid = JRequest::getInt("catid",$default);
		updatePaidSystemConf($conf,$catid);
	}
	
	if($conf->featured_active == 1){
		$db->setQuery( "SELECT * FROM #__paidsystem_featured WHERE 1" );
		$featureddurations = $db->loadObjectList();
	}
	
	if($conf->highlight_active == 1){
		$db->setQuery( "SELECT * FROM #__paidsystem_highlight WHERE 1" );
		$highlightdurations = $db->loadObjectList();
	}
	
	if($conf->top_active == 1){
		$db->setQuery( "SELECT * FROM #__paidsystem_top WHERE 1" );
		$topdurations = $db->loadObjectList();
	}
	
	$app = JFactory::getApplication();
	$templateDir = JPATH_ROOT . '/administrator/templates/' . $app->getTemplate();
	if (is_file($templateDir.'/html/com_paidsystem/admin/editcontent.php')) {
		require($templateDir.'/html/com_paidsystem/admin/editcontent.php');
	} else {
		require(JPATH_ROOT.'/administrator/components/com_paidsystem/views/admin/tmpl/editcontent.php');
	}
	?>
	<?php
}

function deletePaidAd($id)
{
	$db =JFactory::getDbo();
	$db->setQuery( "DELETE FROM #__paidsystem_ads WHERE id = ".(int)$id );
	$db->query();
}

function getContentClass($row,$prefix)
{
	$class = "";
	if ($row->highlight == 1)
		$class .= " {$prefix}_highlight";
	if ($row->featured == 1)
			$class .= " {$prefix}_featured";
	if ($row->top == 1)
		$class .= " {$prefix}_top";
	return $class;
}


function updateQuery(&$query)
{
	$query= str_replace("SELECT ","SELECT adext.*, ",$query); 
	$query= str_replace("SELECT adext.*, DISTINCT","SELECT DISTINCT",$query); 

	$query= str_replace("FROM #__adsmanager_ads as a ",
				 "FROM #__adsmanager_ads as a LEFT JOIN #__paidsystem_ads as adext ON a.id = adext.id ",
				 $query); 
}

function updateQueryWithReorder(&$query)
{
	$db =JFactory::getDbo();
	$conf = getPaidSystemConfig();
	
	$query= str_replace("SELECT ","SELECT adext.*, ",$query); 
	$query= str_replace("SELECT adext.*, DISTINCT","SELECT DISTINCT",$query); 
	
	/*
	 * "1"=> The ad is brought to the top of the list once daily
	 * "0" = >The ad sticks to the top of the list
	 */
	if ($conf->top_type == 0) {
		$query= str_replace("ORDER BY","ORDER BY adext.top DESC, ",$query); 
	}
	
	$query= str_replace("FROM #__adsmanager_ads as a ",
				 "FROM #__adsmanager_ads as a LEFT JOIN #__paidsystem_ads as adext ON a.id = adext.id ",
				 $query); 
}

function sendOptionExpirationMail($type,$contentid) {
	require_once JPATH_ROOT."/administrator/components/com_adsmanager/models/content.php";
	$confpaidsystem = getPaidSystemConfig();
	
	$subject = $confpaidsystem->mail_expiration_subject;
	$body = $confpaidsystem->mail_expiration_body;
	
	// get configuration
	$db = JFactory::getDbo();
	$query = "SELECT * FROM #__adsmanager_config WHERE 1";
	$db->setQuery($query);
	$conf = $db->loadObject();
	
	$model = AdsmanagerModelContent::getInstance('content','AdsmanagerModel');
	$content = $model->getContent($contentid,false);
	$user = JFactory::getUser($content->userid);
	
	switch($type) {
		case "highlight": $typename = JText::_('PAIDSYSTEM_HIGHLIGHT');break;
		case "featured": $typename = JText::_('PAIDSYSTEM_FEATURED');break;
		case "top": $typename = JText::_('PAIDSYSTEM_TOP');break;
	}
	
	//TODO add tag in the help context of paidsystem configuration
	$subject = str_replace("{option}",$typename,$subject);
	$body = str_replace("{option}",$typename,$body);
	
	/*$uri	= JURI::getInstance();
	$root	= $uri->toString( array('scheme', 'host', 'port'));
	$link = $root.TRoute::_("index.php?option=com_adsmanager&view=details&catid=".$content->catid."&id=".$content->id,false);
	$link = str_replace("administrator/","",$link);
	$body = str_replace('{link}',$link,$body);*/
	
	
	$model->sendMailToUser($subject,$body,$user,$content,$conf,"option_expiration");
}

function managePaidOption() {
	$db =JFactory::getDbo();
	$conf = getPaidSystemConfig();
	//Todo JDate
	$date = date("Y-m-d H:i:s",time());
	
	if ($conf->highlight_active==1) {
		$query = "SELECT id FROM #__paidsystem_ads WHERE highlight=1 AND highlight_date < '$date' AND highlight_date IS NOT NULL";
		$db->setQuery($query);
		$ads = $db->loadObjectList();
		foreach($ads as $ad) {
			sendOptionExpirationMail("highlight",$ad->id);
			$db->setQuery("UPDATE #__paidsystem_ads SET highlight = 0 WHERE id = ".$ad->id);
			$db->query();
		}
	}
	
	if ($conf->featured_active==1) {
		$query = "SELECT id FROM #__paidsystem_ads WHERE featured=1 AND featured_date < '$date' AND featured_date IS NOT NULL";
		$db->setQuery($query);
		//echo $query;
		$ads = $db->loadObjectList();
		foreach($ads as $ad) {
			sendOptionExpirationMail("featured",$ad->id);
			$db->setQuery("UPDATE #__paidsystem_ads SET featured = 0 WHERE id = ".$ad->id);
			$db->query();
		}
	}
	
	if ($conf->top_active==1) {
		if ($conf->top_type != 0) {
			$nbdays = 1;
			$query = "SELECT p.id,a.date_created FROM #__paidsystem_ads as p INNER JOIN #__adsmanager_ads AS a ON a.id = p.id WHERE top=1";
			$db->setQuery($query);
			$ads = $db->loadObjectList();
			
			foreach($ads as $ad) {
				$ad_time = strtotime($ad->date_created);
				
				if ((time()-$ad_time) >= ($nbdays*3600*24)) {
					$db->setQuery("UPDATE #__adsmanager_ads SET date_created = NOW(),date_modified = NOW() WHERE id = ".$ad->id);
					$db->query();
					//echo "UPDATE #__adsmanager_ads SET date_created = NOW() WHERE id = ".$ad->id;
				}
			}
		}
		$query = "SELECT id FROM #__paidsystem_ads WHERE top=1 AND top_date < '$date' AND top_date IS NOT NULL";
		$db->setQuery($query);
		$ads = $db->loadObjectList();
		foreach($ads as $ad) {
			sendOptionExpirationMail("top",$ad->id);
			$db->setQuery("UPDATE #__paidsystem_ads SET top = 0 WHERE id = ".$ad->id);
			$db->query();
		}
	}
}


function getPaidSystemMode() {
	$conf = getPaidSystemConfig();
	return $conf->mode;
}

function _save_log($output) {
	$filename = "components/com_paidsystem/log.txt";
	$fd = fopen($filename,"a");
	$output .= "\r\n";
	fwrite($fd, date("Ymd G:i:s")." -> ".$output);
	fclose ($fd);
}

/**
 * generate Bill
 * @param ad $content
 * @param array $items
 * @param int $pending_id the ad id, not the pending_ad_id
 * @return number
 */
function generateBill($content,$items,$pending_id=0) {

	$config = getPaidSystemConfig();

	$db = JFactory::getDbo();	
	$query = "SELECT * FROM #__users WHERE id=".$content->userid;
	$db->setQuery($query);
	$user = $db->loadObject();
	
	include_once(JPATH_ROOT.'/components/com_invoicing/lib/core.php');
	
	$invoice_id = Invoicing::createInvoice($user->id, $items, "adsmanager",$pending_id,$config->currency_id);
	return $invoice_id;
}
	
function computeCost(&$total,&$items,$content,$adsmanager_conf,$isUpdateMode) {
	$db = &JFactory::getDbo();
	
	$total = 0;
	$items = array();
	
	$data = $content->getData();
	
	$conf = getPaidSystemConfig();
	
    $user = JFactory::getUser();
    
    if(version_compare(JVERSION, '1.6', 'ge')) {
        $authorisedUserGroups = JHTMLAdsmanagerUserGroups::getUserGroup($user->id);

        foreach($authorisedUserGroups as $authorisedUserGroup){
            if(array_search($authorisedUserGroup, $conf->usergroups_freeads) !== false){
                if($conf->categories_freeads == 1)
                    return;
            }
        }
    }
    
	if ($adsmanager_conf->nbcats + $conf->nbcats == 1)
	{
		$catid = $data['categories'][0];
		updatePaidSystemConf($conf,$catid);
	}
	
	$percenttax = ((100+$conf->tax)/100);
	
	if ($adsmanager_conf->nbcats + $conf->nbcats == 1)
	{
		if (ADSMANAGER_SPECIAL == "OXY") {
			if ($isUpdateMode == 0)
			{
				$ad_ownertype = JRequest::getVar('ad_ownertype','');
				if ($ad_ownertype == "professionnel") {
					$total += $conf->credits;
					$items[] = array('quantity'=>1,'tax'=>$conf->tax,'description' =>JText::_('PAIDSYSTEM_ORDER_CATEGORY'),'gross_unit_price' => $conf->credits,'source'=>'adsmanager-categories');
				}
			} else {
				$ad_ownertype = JRequest::getVar('ad_ownertype','');
				//echo $content->current->ad_ownertype."<br/>";
				//echo $ad_ownertype;exit();
				if ($ad_ownertype == "professionnel") {
					if ($content->current->ad_ownertype == "particulier") {
						$total += $conf->credits;
						$items[] = array('quantity'=>1,'tax'=>$conf->tax,'description' =>JText::_('PAIDSYSTEM_ORDER_CATEGORY'),'gross_unit_price' => $conf->credits,'source'=>'adsmanager-categories');
					}
				}
			}
		}			
		else {	
			if ($isUpdateMode == 0)
			{
				$total += $conf->credits;
				if ($conf->credits > 0) {
					$items[] = array('quantity'=>1,'tax'=>$conf->tax,'description' =>JText::_('PAIDSYSTEM_ORDER_CATEGORY'),'gross_unit_price' => $conf->credits,'source'=>'adsmanager-categories');
				}
			}
		}
	}
	else if ($conf->nbcats > 0)
	{
		$newcats = $data['categories'];
		if ($isUpdateMode == 0)
			$prevcats = array();
		else {
			$query = "SELECT catid FROM #__adsmanager_adcat WHERE adid = ".$content->id;
			$db->setQuery($query);
			$cats = $db->loadObjectList();
			$prevcats = array();
			foreach($cats as $cat) {
				$prevcats[] = $cat->catid;	
			}
		}
		
		$prevnbcats = count($prevcats);
		$newnbcats = count($newcats);
		
		if ($newnbcats > $prevnbcats)
		{
			if ($newnbcats < $adsmanager_conf->nbcats)
			{
				$nbbasiccat = $newnbcats - $prevnbcats;
				$nbaddcat = 0;
			}
			else if ($prevnbcats < $adsmanager_conf->nbcats)
			{
				$nbaddcat = $newnbcats - $adsmanager_conf->nbcats;
				$nbbasiccat = $adsmanager_conf->nbcats - $prevnbcats;
			}
			else
			{
				$nbaddcat = $newnbcats - $prevnbcats;
				$nbbasiccat = 0;
			}
		
			$total += $nbbasiccat * $conf->credits + $nbaddcat * $conf->cat_price;
			
			$text = JText::_('PAIDSYSTEM_ORDER_FIRST_CATEGORIES');
			$items[] = array('quantity'=>$nbbasiccat,'tax'=>$conf->tax,'description' => $text,'gross_unit_price' => $conf->credits,'source'=>'adsmanager-categories');
			if ($nbaddcat > 0) {
				$text = JText::_('PAIDSYSTEM_ORDER_NEXT_CATEGORIES');
				$items[] = array('quantity'=>$nbaddcat,'tax'=>$conf->tax,'description' => $text,'gross_unit_price' => $conf->cat_price,'source'=>'adsmanager-categories');	
			}
		}
	}
	else
	{
		$newcats = $data['categories'];
		if ($isUpdateMode == 0)
			$prevcats = array();
		else {
			$query = "SELECT catid FROM #__adsmanager_adcat WHERE adid = ".$content->id;
			$db->setQuery($query);
			$cats = $db->loadObjectList();
			$prevcats = array();
			foreach($cats as $cat) {
				$prevcats[] = $cat->catid;	
			}
		}
		
		$prevtotal = 0;
		if (count($prevcats) > 0)
		{
			$listcats = implode(',', $prevcats);
			$db->setQuery( "SELECT `specific`,`price` FROM #__paidsystem_categories WHERE id IN ($listcats)");
			$cats = $db->loadObjectList();
			if (isset($cats))
				foreach($cats as $cat)
				{
					if ($cat->specific == 1)
						$prevtotal += $cat->price;
					else
						$prevtotal += $conf->credits;
				}
		}
		
		$listcats = implode(',', $newcats);
		$db->setQuery(  " SELECT `specific`,`price` FROM #__adsmanager_categories as a"
					   ." LEFT JOIN #__paidsystem_categories as p ON p.id = a.id WHERE a.id IN ($listcats)");
		$cats = $db->loadObjectList();
		$newtotal = 0;
		if (isset($cats))
			foreach($cats as $cat)
			{
				if ($cat->specific == 1)
					$newtotal += $cat->price;
				else
					$newtotal += $conf->credits;
			}
		
		$cost = $newtotal - $prevtotal;
		if ($cost > 0)
		{
			$total += $cost;
			$text = JText::_('PAIDSYSTEM_ORDER_CATEGORIES');
			$items[] = array('quantity'=>1,'tax'=>$conf->tax,'description' => $text,'gross_unit_price' => $cost,'source'=>'adsmanager-categories');
		}
	}
	
	$duration_days = 0;
	if (($isUpdateMode == 0)||(JRequest::getInt('pending',0)==1))
	{
		$db->setQuery( "SELECT * FROM #__paidsystem_duration WHERE published = 1 AND (type='both' OR type='new')");
		$durations = $db->loadObjectList("id");
		if (isset($durations)&&count($durations) > 0)
		{
			$ad_duration = JRequest::getInt("ad_duration" ,0);
			if ($ad_duration != 0) {
				$duration = $durations[$ad_duration];
				$delta = $duration->duration; 
				$duration_days = $delta;
				//Replace === by == because string '0'
				if ($delta == 0) {
					$expiration_date = null;
					$text = JText::_('PAIDSYSTEM_ORDER_EXPIRATION_UNLIMITED');
				
				} else {
					$expiration_date = date("Y-m-d",time()+($delta*24*3600)); 
					$text = sprintf(JText::_('PAIDSYSTEM_ORDER_EXPIRATION'),$expiration_date,$duration->duration);	
				}
				$total += $duration->credits;
				$items[] = array('quantity'=>1,'tax'=>$conf->tax,'description' => $text,'gross_unit_price' => $duration->credits,'source'=>'adsmanager-duration');
			}
		}
	}
	
	if ($conf->featured_active == 1)
	{
		if ($data['paid']['featured'] != 0)
		{
			$db->setQuery( "SELECT * FROM #__paidsystem_featured WHERE id=".(int)$data['paid']['featured'] );
			$featuredduration = $db->loadObject();
			
			if (isset($id)) {
				$db->setQuery("SELECT * FROM #__paidsystem_ads WHERE id=".(int)$id." and featured = 1");
				$adext= $db->loadObject();
			}
			
			if (isset($adext)) {
				//Nothing to do
			} else {
				$total += $featuredduration->credits;
				$items[] = array('quantity'=>1,'tax'=>$conf->tax,'description' => sprintf(JText::_('PAIDSYSTEM_ORDER_ITEM_OPTION'),JText::_('PAIDSYSTEM_FEATURED'), $featuredduration->duration),'gross_unit_price' => $featuredduration->credits,'source'=>'adsmanager-featured');
			}
		}
	}
	if ($conf->highlight_active == 1)
	{
		if ($data['paid']['highlight'] != 0)
		{
			$db->setQuery( "SELECT * FROM #__paidsystem_highlight WHERE id=".(int)$data['paid']['highlight'] );
			$highlightduration = $db->loadObject();
			
			if (isset($id)) {
				$db->setQuery("SELECT * FROM #__paidsystem_ads WHERE id=".(int)$id." and highlight = 1");
				$adext= $db->loadObject();
			}
			
			if (isset($adext)) {
				//Nothing to do
			} else {
				$total += $highlightduration->credits;
				$items[] = array('quantity'=>1,'tax'=>$conf->tax,'description' => sprintf(JText::_('PAIDSYSTEM_ORDER_ITEM_OPTION'),JText::_('PAIDSYSTEM_HIGHLIGHT'), $highlightduration->duration),'gross_unit_price' => $highlightduration->credits,'source'=>'adsmanager-highlight');
			}
		}
	}
	if ($conf->top_active == 1)
	{
		if ($data['paid']['top'] != 0)
		{
			$db->setQuery( "SELECT * FROM #__paidsystem_top WHERE id=".(int)$data['paid']['top'] );
			$topduration = $db->loadObject();
			
			if (isset($id)) {	
				$db->setQuery("SELECT * FROM #__paidsystem_ads WHERE id=".(int)$id." and top = 1");
				$adext= $db->loadObject();
			}
			
			if (isset($adext)) {
				//Nothing to do
			} else {
				$total += $topduration->credits;
				$items[] = array('quantity'=>1,'tax'=>$conf->tax,'description' => sprintf(JText::_('PAIDSYSTEM_ORDER_ITEM_OPTION'),JText::_('PAIDSYSTEM_TOP'), $topduration->duration),'gross_unit_price' => $topduration->credits,'source'=>'adsmanager-top');
			}
		}
	}
	
	$nbnewimages = count(@$data['paid']['images']);

	if (ADSMANAGER_SPECIAL == "DAN") {
		if ($nbnewimages > 0) {
			$imageprice = $conf->image_price * ceil($duration_days/7);
			$price = $nbnewimages * $imageprice;
			$total += $price;
			$text = JText::_('PAIDSYSTEM_ORDER_IMAGES');
			$items[] = array('quantity'=>$nbnewimages,'tax'=>$conf->tax,'description' => $text,'gross_unit_price' => $imageprice,'source'=>'adsmanager-images');
		}
	} else {
		if ($nbnewimages > 0) {
			$price = $nbnewimages * $conf->image_price;
			$total += $price;
			$text = JText::_('PAIDSYSTEM_ORDER_IMAGES');
			$items[] = array('quantity'=>$nbnewimages,'tax'=>$conf->tax,'description' => $text,'gross_unit_price' => $conf->image_price,'source'=>'adsmanager-images');
		}
	}
		
	$db->setQuery( "SELECT f.*,p.id,p.price FROM #__adsmanager_fields AS f  ".
						"LEFT JOIN #__paidsystem_fields as p ON p.id = f.fieldid ".
						"WHERE f.published = 1 and p.price > 0 ORDER by f.ordering" );
	$fields = $db->loadObjectList("id");
	
	if ($isUpdateMode == 1)
	{
		$db->setQuery( "SELECT * FROM #__adsmanager_ads WHERE id = ".(int)$content->id );
		$current = $db->loadObject();
	}
	
	if(isset($fields))
	{
		foreach($fields as $field)
		{ 	
			if ($content->id != 0)
			{
				$current = $content->current;
				$fieldtitle = $field->name;
				$testvalue = $current->$fieldtitle;
			}	
			else
				$testvalue = "";
				
			if (($testvalue == "")||($testvalue == ",,"))
			{
				if (($field->type == "multiselect")||
					($field->type == "multicheckbox")||
					($field->type == "multicheckboximage"))
				{	
					$value = $data['fields'][$field->name];
					if (count($value) > 0)
					{
						$total += $field->price;
						$text = sprint(JText::_('PAIDSYSTEM_ORDER_FIELD'),$field->name);
						$items[] = array('quantity'=>1,'tax'=>$conf->tax,'description' => $text,'gross_unit_price' => $field->price,'source'=>'adsmanager-fields');
					}
				}
				else
				{
					$value = $data['fields'][$field->name];
					if ($value != "")
					{
						$total += $field->price;
						$text = sprintf(JText::_('PAIDSYSTEM_ORDER_FIELD'),$field->name);
						$items[] = array('quantity'=>1,'tax'=>$conf->tax,'description' => $text,'gross_unit_price' => $field->price,'source'=>'adsmanager-fields');
					}	
				}
			}
		}
	}
}

function bindPaidSystemContent(&$content,$post,$files,$adsmanager_conf,$model) {
	$db = &JFactory::getDbo();
	
	$conf = getPaidSystemConfig();
	
	$content->data['paid'] = array();
	$featured= JRequest::getInt("featured",0 );
	$highlight= JRequest::getInt("highlight",0 );
	$top= JRequest::getInt("top",0 );
	$content->data['paid']['featured'] = $featured;
	$content->data['paid']['highlight'] = $highlight;
	$content->data['paid']['top'] = $top;
	
	$app = JFactory::getApplication();
	if ($app->isAdmin() == true) {	
		$featured= JRequest::getString("featured_date",0 );
		$highlight= JRequest::getString("highlight_date",0 );
		$top= JRequest::getString("top_date",0 );
		$content->data['paid']['featured_date'] = $featured;
		$content->data['paid']['highlight_date'] = $highlight;
		$content->data['paid']['top_date'] = $top;	
	}
	
	//if ($content->id == 0) {
		$ad_duration = JRequest::getInt("ad_duration" ,0);
		$db->setQuery( "SELECT * FROM #__paidsystem_duration WHERE published = 1 AND (type='both' OR type='new')");
		$durations = $db->loadObjectList("id");
		
		if (($ad_duration != 0)&&isset($durations)&&count($durations) > 0)
		{
			$duration = $durations[$ad_duration];
			$delta = $duration->duration; 
			//Replace === by == because string '0'
			if ($delta == 0)
				$expiration_date = null;
            else
                $expiration_date = date("Y-m-d H:i:s",strtotime($content->publication_date)+($delta*24*3600)); 
            
			$content->expiration_date = $expiration_date;
			$content->data['duration'] = $ad_duration;
		}
	//}
	
	$current_images = json_decode($content->images);
	if ($current_images == null)
		$current_images = array();
	
	$nb_images = $content->nb_images;
	$image_index = $content->image_index;
	
	$nbMaxImages = $adsmanager_conf->nb_images + $conf->num_images;
	
	$uploader_count = JRequest::getInt('uploader_count',0);
		
	$targetDir = JPATH_ROOT.'/tmp/plupload';
	$dir = JPATH_ROOT."/images/com_adsmanager/ads/tmp/";

	$orderlist = $content->data['orderimages'];
		
	for($i = $content->last_upload_index +1 ; $i < $uploader_count && $nb_images <  $nbMaxImages ; $i++) {
		
		$uploader_id = JRequest::getString('uploader_'.$i.'_id',0);
		$uploader_tmpname = JRequest::getString('uploader_'.$i.'_tmpname',0);
		$uploader_name = JRequest::getString('uploader_'.$i.'_name',0);
		$uploader_status = JRequest::getString('uploader_'.$i.'_status',0);

		$tmpfile = date("Ymd")."-".uniqid();
		$thumb_tmpfile = date("Ymd")."-".uniqid();
		$medium_tmpfile = date("Ymd")."-".uniqid();
                
        if ($uploader_status == "done") {
	            	
        	try {
				$error = $model->createImageAndThumb($targetDir."/".$uploader_tmpname,
				   							$tmpfile,$thumb_tmpfile,
											$adsmanager_conf->max_width,
											$adsmanager_conf->max_height,
											$adsmanager_conf->max_width_t,
											$adsmanager_conf->max_height_t,
											$adsmanager_conf->tag,
											$dir,
											$uploader_name,
											$adsmanager_conf->max_width_t,
											$adsmanager_conf->max_height_t,
											$medium_tmpfile);
				JFile::delete($targetDir."/".$uploader_tmpname);
				if ($error != null) {
					$content->errors[] = $error;
				} else {
					$image_index++;
					$nb_images++;
					$newimg = new stdClass();
					$newimg->index = $image_index;
					$newimg->image = $tmpfile;
					$newimg->thumbnail = $thumb_tmpfile;
					$newimg->medium = $medium_tmpfile;
					$content->data['paid']['images'][] = $newimg;
					foreach($orderlist as &$val) {
						if ($val == $uploader_id) {
							$val = $image_index;
						}
					}
				}
			} catch (Exception $e) {
				$content->errors[] = $e->getMessage();
			}
        } else {
          	break;
        }
  	}	
  	$content->data['orderimages'] = $orderlist;
}

function checkAuthorisedNumberAds($contentModel, $category)
{
    include_once(JPATH_ADMINISTRATOR.'/components/com_adsmanager/models/category.php');
    
    if($category == 0)
        return false;
        
    $conf = getPaidSystemConfig();
    $user = JFactory::getUser();
    
    if(version_compare(JVERSION, '1.6', 'ge')) {
        $authorisedUserGroups = JHTMLAdsmanagerUserGroups::getUserGroup($user->id);

        foreach($authorisedUserGroups as $authorisedUserGroup){
            if(array_search($authorisedUserGroup, $conf->usergroups_nolimit) !== false){
                if($conf->categories_nolimit == 1)
                    return true;
            }
        }
    }
    
    $nb = $contentModel->getNbContentsOfUser($user->id, $category);
    
    //TODO : check authorised number for multi-categories
    $categoriesModel = new AdsmanagerModelCategory();
    
    $category = $categoriesModel->getCategory($category);
    
    if($category->limitads == '-1')
        return true;
        
    if($nb >= $category->limitads){
        return $category->limitads;
    }
    
    return true;
}

// Merge the language overrides
$paths = array(JPATH_ADMINISTRATOR, JPATH_ROOT);
$jlang = JFactory::getLanguage();
$jlang->load("com_paidsystem", $paths[0], 'en-GB', true);
$jlang->load("com_paidsystem", $paths[0], null, true);
$jlang->load("com_paidsystem", $paths[1], 'en-GB', true);
$jlang->load("com_paidsystem", $paths[1], null, true);