<?php
/**
 * @package AkeebaSubs
 * @copyright Copyright (c)2010-2012 Nicholas K. Dionysopoulos
 * @license GNU General Public License version 3, or later
 */

// Protect from unauthorized access
defined('_JEXEC') or die();

class VirtualmoneyDispatcher extends FOFDispatcher
{
	private $allowedViews = array(
			'pack','account','transactions','exchanges','exchange'
	);
	
	public function __construct($config = array()) {
		parent::__construct($config);
	
		$this->defaultView = 'account';
	}
	
	public function onBeforeDispatch() {	
		
		if ($result = parent::onBeforeDispatch()) {
			/*Jquery non conflict mode*/
			$document = JFactory::getDocument();
            if(version_compare(JVERSION, '3.0', 'lt')) {
                $document->addStyleSheet(JURI::root().'media/com_virtualmoney/css/frontend.css');
            }
			// Default to the "levels" view
			$view = FOFInput::getCmd('view',$this->defaultView, $this->input);
			if(empty($view) || ($view == 'cpanel')) {
				$view = 'account';
			}
            
			// Set the view, if it's allowed
			FOFInput::setVar('view',$view,$this->input);
			if(!in_array($view, $this->allowedViews)) $result = false;
		}
        
		return $result;
	}
}