<?php
/**
 *  @package Virtualmoney
 *  @copyright Copyright (c)2013 JoomPROD
 *  @license GNU General Public License version 3, or later
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

/**
 * 
 * @package		Joomla
 * @subpackage	Contacts
 */
class VirtualmoneyViewAccount extends FOFViewHtml
{
	public function onAdd($tpl = NULL) {
        $user = JFactory::getUser();
        
        $model = $this->getModel();
        $transactions = FOFModel::getTmpInstance('Transactions','VirtualmoneyModel')
                        ->user_id($user->id)
                        ->filter_order('created_on')
                        ->filter_order_Dir('DESC')
                        ->limit('5')
                        ->limitStart('0')
                        ->getItemList();
        
        if(!empty($transactions)){
            //Foreach transation
            foreach($transactions as $transaction) {
                //We define if the transaction is a debit or a credit and with
                //assign the correct variable
                $transaction->description = nl2br($transaction->description);
                if($transaction->credits < 0) {
                    $transaction->debit = VirtualmoneyHelperFormat::formatPrice(-$transaction->credits);
                    $transaction->credit = '';
                }else{
                    $transaction->credit = VirtualmoneyHelperFormat::formatPrice($transaction->credits);
                    $transaction->debit = '';
                }
            }
        }
        
        $credits = FOFModel::getTmpInstance('Credits', 'VirtualmoneyModel')
                   ->user_id($user->id)
                   ->getItemList();
        if(empty($credits))
            $credits = 0;
        else
            $credits = $credits[0]->credits;
        
        $this->assign('transactions',$transactions);
        $this->assign('credits', $credits);
	}
}