<?php
/**
 *  @package	PaidSystem
 *  @copyright	Copyright (C) 2010-2013 JoomPROD.com. All rights reserved.
 *  @license    GNU General Public License version 3, or later
 */
// no direct access
defined('_JEXEC') or die( 'Restricted access' );
	
require_once(JPATH_ROOT."/components/com_adsmanager/lib/core.php");

require_once(JPATH_BASE.'/administrator/components/com_adsmanager/models/configuration.php');
require_once(JPATH_BASE.'/administrator/components/com_adsmanager/models/content.php');
require_once(JPATH_BASE.'/administrator/components/com_adsmanager/models/field.php');
require_once(JPATH_BASE."/components/com_adsmanager/helpers/field.php");

$uri = JFactory::getURI();
$baseurl = JURI::base();
$catid = JRequest::getInt('catid',0);
$document = JFactory::getDocument();
$app = JFactory::getApplication();
if (!defined( '_ADSMANAGER_CSS' )) {
	/** ensure that functions are declared only once */
	define( '_ADSMANAGER_CSS', 1 );
    
	$templateDir = JPATH_ROOT . '/templates/' . $app->getTemplate();
	if (is_file($templateDir.'/html/com_adsmanager/css/adsmanager.css')) {
		$templateDir = JURI::base() . 'templates/' . $app->getTemplate();
		$document->addStyleSheet($templateDir.'/html/com_adsmanager/css/adsmanager.css');
	} else {
		$document->addStyleSheet($baseurl.'components/com_adsmanager/css/adsmanager.css');
	}
}

$document = JFactory::getDocument();
$document->addScript(JURI::root().'components/com_adsmanager/js/jquery.cookie.js');

$confmodel  = new AdsmanagerModelConfiguration();
$conf = $confmodel->getConfiguration();

$limitstart = JRequest::getInt("limitstart",0);
$limit = $conf->ads_per_page;

$order = $app->getUserStateFromRequest('com_adsmanager.front_content.order','order',0,'int');
$orderdir = $app->getUserStateFromRequest('com_adsmanager.front_content.orderdir','orderdir','DESC');
$orderdir = strtoupper($orderdir);
if (($orderdir != "DESC") && ($orderdir != "ASC")) {
	$orderdir = "DESC";
}

$contentmodel  = new AdsmanagerModelContent();
$filter_order = $contentmodel->getFilterOrder($order);
$filter_order_dir = $orderdir;

$filters = array();
$currentSession = JSession::getInstance('none',array());
$filters['fields'] = $currentSession->get("searchfieldssql"," 1 ");
$catid = $app->getUserStateFromRequest( 'searchfieldscatid','catid',0,'integer' );
if ($catid != 0)
	$filters['category'] = $catid;

$total = $contentmodel->getNbContents($filters);

$db = JFactory::getDbo();

$query = "SELECT * FROM #__adsmanager_fields WHERE type = 'gmap'";
$db->setQuery($query);
$result = $db->loadObject();

if($result != null){

	/*if (isset($filters['fields']) && ($filters['fields'] != ""))
    	$filters['fields'] .= " AND (a.ad_gmap_lat != '' ";*/

    $contents = $contentmodel->getContents($filters,$limitstart, $limit,$filter_order,$filter_order_dir);
    
} else {
    $contents = array();
}

$fieldmodel  = new AdsmanagerModelField();
$field_values = $fieldmodel->getFieldValues();
$field = new JHTMLAdsmanagerField($conf,$field_values,"4",$fieldmodel->getPlugins());

$fieldsArray = array('ad_price');
/*$fieldsArray[] = $params->get( 'field1', "") ;
$fieldsArray[] = $params->get( 'field2', "") ;
$fieldsArray[] = $params->get( 'field3', "") ;
$fieldsArray[] = $params->get( 'field4', "") ;
$fieldsArray[] = $params->get( 'field5', "") ;*/
$listfields="";
foreach($fieldsArray as $field)
{
	if (($listfields == "")&&($field != ""))
		$listfields .= "'$field'";
	if ($field != "")
		$listfields .= ",'$field'";
}

$field_values = array();
$adfields = array();
if ($listfields != "")
{
	$adfields = $fieldmodel->getFieldsByName($listfields);
	$field_values = $fieldmodel->getFieldValues();

	foreach($adfields as $field)
	{
		if ($field->cbfieldvalues != "-1")
		{
			/*get CB value fields */
			$cbfieldvalues = $fieldmodel->getCBFieldValues($field->cbfieldvalues);
			$field_values[$field->fieldid] = $cbfieldvalues;
		}
	}
}

$fieldPrice = $adfields['ad_price'];

$markers = array();
foreach($contents as $content) {
    $link = TRoute::_("index.php?option=com_adsmanager&view=details&id=".$content->id."&catid=".$content->catid);		
    $title = $content->ad_headline;
    $price = $content->ad_price;
    if ($price != "") {	
        if($fieldPrice->options == null || $fieldPrice->options->currency_symbol == '')
            $price = sprintf(JText::_('ADSMANAGER_CURRENCY'),number_format(floatval($price), 2, '.', ' '));
        else
            $price = JHTMLAdsmanagerField::formatPrice($price, $fieldPrice->options);
        //for Right to Left language
        $price = str_replace(" ","&nbsp;",$price);
    }
    $description = JString::substr($content->ad_text, 0, 140)."[...]";
    if ((count($content->images) > 0)&&(@$content->images[0]->thumbnail)) {
        $image = $baseurl."/images/com_adsmanager/ads/".$content->images[0]->thumbnail;
    } else {
        $image = ADSMANAGER_NOPIC_IMG;
	}
    
    $markers[] = array('image' => $image,
                       'description'=>$description,
                       'lat'=>$content->ad_gmap_lat,
                       'lon'=>$content->ad_gmap_lng,
                       'title'=>$title,
                       'link'=>$link,
                       'price'=>$price
                       );
    
}

$db->setQuery("SELECT * FROM #__adsmanager_fieldgmap_conf LIMIT 0, 1");
$confGmap = $db->loadObject();

if(!empty($contents))
    $googleKey = $confGmap->google_key;

require(JModuleHelper::getLayoutPath('mod_adsmanager_adsmap','default'));

$content="";
$path = JPATH_ADMINISTRATOR.'/../libraries/joomla/database/table';
JTable::addIncludePath($path);

?>