<?php
/**
 *  @package	PaidSystem
 *  @copyright	Copyright (C) 2010-2013 JoomPROD.com. All rights reserved.
 *  @license    GNU General Public License version 3, or later
 */
// no direct access
defined('_JEXEC') or die( 'Restricted access' );
	
require_once(JPATH_ROOT."/components/com_adsmanager/lib/core.php");


require_once(JPATH_BASE.'/administrator/components/com_adsmanager/models/configuration.php');
require_once(JPATH_BASE.'/administrator/components/com_adsmanager/models/content.php');
require_once(JPATH_BASE.'/administrator/components/com_adsmanager/models/field.php');
require_once(JPATH_BASE."/components/com_adsmanager/helpers/field.php");


$uri = JFactory::getURI();
$baseurl = JURI::base();
$app = JFactory::getApplication();
$document = JFactory::getDocument();
	
if (!defined( '_ADSMANAGER_CSS' )) {
	/** ensure that functions are declared only once */
	$templateDir = JPATH_ROOT . '/templates/' . $app->getTemplate();
	if (is_file($templateDir.'/html/com_adsmanager/css/adsmanager.css')) {
		$templateDir = JURI::base() . 'templates/' . $app->getTemplate();
		$document->addStyleSheet($templateDir.'/html/com_adsmanager/css/adsmanager.css');
	} else {
		$document->addStyleSheet($baseurl.'components/com_adsmanager/css/adsmanager.css');
	}
}

if (!defined('_ADSMANAGER_MODULE_ADS')) {
	define( '_ADSMANAGER_MODULE_ADS', 1 );
	function isNewContent($date,$nbdays) {
		$time = strtotime($date);
		if ($time >= (time()-($nbdays*24*3600)))
			return true;
		else
			return false;
	}
	
	function reorderDate( $date ){
		$format = JText::_('ADSMANAGER_DATE_FORMAT_LC');
		
		if ($date && (preg_match("/([0-9]{4})-([0-9]{2})-([0-9]{2})/",$date,$regs))) {
			$date = mktime( 0, 0, 0, $regs[2], $regs[3], $regs[1] );
			$date = $date > -1 ? strftime( $format, $date) : '-';
		}
		return $date;
	}
	
	function recurseSearch($rows,&$list,$catid){
		if(isset($rows))
		{
			foreach($rows as $row) {
				if ($row->parent == $catid)
				{
					$list[]= $row->id;
					recurseSearch($rows,$list,$row->id);
				} 
			}
		}
	}
}

$nb_ads = intval($params->get( 'nb_ads', 3 )) ;
$image = intval($params->get( 'image', 1 )) ;
$imagesize = $params->get( 'imagesize', "small" ) ;
switch($imagesize) {
	case "large":
		$imagetype = "image";break;
	case "medium":
		$imagetype = "medium";break;
	default:
	case "small":
		$imagetype = "thumbnail";break;
}
$itemid = intval($params->get( 'default_itemid', JRequest::getInt('Itemid', 0 ) )) ;
$sort_sql = intval($params->get( 'random',0));
$type = intval($params->get( 'type',0));

$effect = $params->get( 'effect','carousel');

$delay = intval($params->get( 'delay',3));

$auto = intval($params->get( 'auto',0));

$container_width = intval($params->get( 'container_width',450));
$container_height = intval($params->get( 'container_height',150));

$item_width = intval($params->get( 'item_width',140));
$item_height = intval($params->get( 'item_height',150));

$arrows = intval($params->get( 'arrow',1));
$style =  $params->get( 'align_feat', 'hor' );

$catselect = $params->get('catselect',"no");
$displaycategory = intval($params->get( 'displaycategory',1));
$displaydate = intval($params->get( 'displaydate',1));

$confmodel  = new AdsmanagerModelConfiguration();
$conf = $confmodel->getConfiguration();
$nb_images = $conf->nb_images;

if (function_exists("getMaxPaidSystemImages"))
{
	$nb_images += getMaxPaidSystemImages();
}

$db = JFactory::getDBO();
switch($sort_sql)
{
	/* Popular */
	case 2:
		$order_sql = "ORDER BY a.views DESC,a.date_created DESC ,a.id DESC ";
		break;
		
	/* Random */
	case 1:
		$order_sql = "ORDER BY RAND() ";
		break;
		
	/* Latest */
	case 0: 
	default:
		$order_sql = "ORDER BY a.date_created DESC ,a.id DESC ";
		break;
}
$type_query = "";
switch($type)
{
	/* Featured */
	case 0:
		$type_query = " AND s.featured = 1 ";
		break;
		
	/* Highlighted */
	case 1:
		$type_query = " AND s.highlight = 1 ";
		break;

	/* TOP */
	case 3: 
		$type_query = " AND s.top = 1 ";
		break;
	
    /* NEW */
    case 5:
        $limitDate =  strtotime("-".$conf->nbdays_new." days");
        $type_query = " AND date_created >= ".$db->Quote(date('Y-m-d H:i:s', $limitDate))." ";
        break;
        
    /* HOT */
    case 6:
        $numberHot =  $conf->nbhits;
        $type_query = " AND views >= ".$db->Quote($numberHot)." ";
        break;
        
	/* Both */
	case 2: 
	case 4:
	default:
		$type_query = " ";
		break;
}

$cat_query = "";
switch($catselect)
{
	case "no";
		break;
	
	case "-1":
		$catid = JRequest::getInt('catid', 0 );
		if (($catid != 0)&&($catid != -1))
		{
			$db->setQuery( "SELECT c.id, c.name,c.parent ".
					" FROM #__adsmanager_categories as c ".
					" WHERE c.published = 1 ORDER BY c.parent,c.ordering");
			$listcats = $db->loadObjectList();
			//List
			$list = array();
			$list[] = $catid;
			recurseSearch($listcats,$list,$catid);
			$listids = implode(',', $list);
			
			$cat_query = "AND adcat.catid IN ($listids) ";
		}
		break;
	default:
		$db->setQuery( "SELECT c.id, c.name,c.parent ".
				" FROM #__adsmanager_categories as c ".
				" WHERE c.published = 1 ORDER BY c.parent,c.ordering");
		$listcats = $db->loadObjectList();
		//List
		$list = array();
		$list[] = $catselect;
		recurseSearch($listcats,$list,$catselect);
		$listids = implode(',', $list);
		$cat_query = "AND adcat.catid IN ($listids) ";
		break;
}

if(isset($conf->publication_date) && $conf->publication_date == 1) {
    $publication_date = " AND a.publication_date <= NOW() ";
} else {
    $publication_date = "";
}

$query = "SELECT a.*, adcat.catid as category, p.id as parentid,p.name as parent,c.id as catid, c.name as cat ".
					"FROM #__adsmanager_ads as a ".
					"LEFT JOIN #__adsmanager_adcat as adcat ON adcat.adid = a.id ".
					"LEFT JOIN #__users as u ON a.userid = u.id ".
					"LEFT JOIN #__adsmanager_categories as c ON adcat.catid = c.id ".
					"LEFT JOIN #__adsmanager_categories as p ON c.parent = p.id ".
					"LEFT JOIN #__paidsystem_ads as s ON a.id = s.id ".
					"WHERE c.published = 1 AND a.published = 1 $cat_query $type_query $publication_date";
if ($type != 4) {
					$query  .= " AND a.id = s.id ";
}

$query  .= " GROUP BY a.id $order_sql LIMIT 0, $nb_ads";

$db->setQuery($query);				

$contents = $db->loadObjectList();

if (count($contents) > 0) {

	foreach($contents as &$c) {
		$c->images = @json_decode($c->images);
		if (!is_array($c->images))
			$c->images = array();
	}
	
	$fields = array();
	$fields[] = $params->get( 'field1', "") ;
	$fields[] = $params->get( 'field2', "") ;
	$fields[] = $params->get( 'field3', "") ;
	$fields[] = $params->get( 'field4', "") ;
	$fields[] = $params->get( 'field5', "") ;
	$listfields="";
	foreach($fields as $field)
	{
		if (($listfields == "")&&($field != ""))
			$listfields .= "'$field'";
		if ($field != "")
			$listfields .= ",'$field'";
	}
	
	$fieldmodel  = new AdsmanagerModelField();
	$field_values = array();
	$adfields = array();
	if ($listfields != "")
	{
		$adfields = $fieldmodel->getFieldsByName($listfields);
		$field_values = $fieldmodel->getFieldValues();
	
		foreach($adfields as $field)
		{
			if ($field->cbfieldvalues != "-1")
			{
				/*get CB value fields */
				$cbfieldvalues = $fieldmodel->getCBFieldValues($field->cbfieldvalues);
				$field_values[$field->fieldid] = $cbfieldvalues;
			}
		}
	}
	
	$field = new JHTMLAdsmanagerField($conf,$field_values,"4",$fieldmodel->getPlugins());
	
	$style = $params->get( 'align_feat', 'hor' );
	
	if ($effect != 'none') {
		if ($effect == 'carousel')
			$document->addScript($baseurl."modules/mod_paidsystem_feat/mod_paidsystem_feat/jquery.jcarousel.min.js");
		else
			$document->addScript($baseurl."modules/mod_paidsystem_feat/mod_paidsystem_feat/jquery.cycle.js");
		
        $document = JFactory::getDocument();
        $app = JFactory::getApplication();
        $templateDir = JPATH_ROOT . '/templates/' . $app->getTemplate();
        if (is_file($templateDir.'/html/mod_paidsystem_feat/css/skin.css')) {
            $templateDir = JURI::base() . 'templates/' . $app->getTemplate();
            $document->addStyleSheet($templateDir.'/html/mod_paidsystem_feat/css/skin.css');
        } else {
            $document->addStyleSheet($baseurl."modules/mod_paidsystem_feat/mod_paidsystem_feat/skin.css");
        }
		require(JModuleHelper::getLayoutPath('mod_paidsystem_feat','effect'));	
	}
	
	require(JModuleHelper::getLayoutPath('mod_paidsystem_feat','default'));
}

$path = JPATH_ADMINISTRATOR.'/../libraries/joomla/database/table';
JTable::addIncludePath($path);