<?php
/**
 *  @package	PaidSystem
 *  @copyright	Copyright (C) 2010-2013 JoomPROD.com. All rights reserved.
 *  @license    GNU General Public License version 3, or later
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );
?>
<?php
/**
 * @package		Invoicing
 * @copyright	Copyright (C) 2010-2011 JoomPROD.com. All rights reserved.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

require_once(JPATH_ADMINISTRATOR.'/components/com_invoicing/assets/generatorplugin.php');

class plgInvoicinggeneratorAdsmanager extends InvoicingAbstractGeneratorPlugin
{
	function getItemTypes()
	{
		$types = array( "adsmanager-renew"=> JText::_('ADSMANAGER_ITEMTYPE_RENEW'),
				        "adsmanager-fields"=> JText::_('ADSMANAGER_ITEMTYPE_FIELDS'),
				        "adsmanager-categories"=> JText::_('ADSMANAGER_ITEMTYPE_CATEGORIES'),
						"adsmanager-images"=> JText::_('ADSMANAGER_ITEMTYPE_IMAGES'),
						"adsmanager-duration"=> JText::_('ADSMANAGER_ITEMTYPE_DURATION'),
						"adsmanager-featured"=> JText::_('ADSMANAGER_ITEMTYPE_FEATURED'),
						"adsmanager-highlight"=> JText::_('ADSMANAGER_ITEMTYPE_HIGHLIGHT'),
						"adsmanager-top" => JText::_('ADSMANAGER_ITEMTYPE_TOP'));
		return $types;
	}
	
	function onInvoicingPaymentValidation($invoice)
	{	
        $generator_key = $invoice->generator_key;
        $generator = $invoice->generator;
		if($generator != "adsmanager") return false;
		
		require_once(JPATH_ROOT."/components/com_adsmanager/lib/core.php");

		$pendingid = $generator_key;
		
		$query = " SELECT * ".
				" FROM #__adsmanager_pending_ads".
				" WHERE contentid = ".intval($pendingid);
		$db = JFactory::getDbo();
		$db->setQuery($query);
		$pending = $db->loadObject();
		
		$pending->data = json_decode($pending->content);
		//echo $query;
		$row = new JObject();
		$row->id = $pendingid;
		
		//var_dump($pendingid,$pending);exit();
		
		if (isset($pending->data->renew_duration))
		{
			$adid = $pending->contentid;
		
			if ($pending->data->renew_duration == 0) {
				$newdate = "NULL";
			} else {
				$db->setQuery( "SELECT expiration_date FROM #__adsmanager_ads WHERE id = ".(int)$adid);
				$expiration_date = $db->loadResult();
				$time = strtotime($expiration_date);
				if ($time < time())
				{
					$time = time();
				}
				$time = $time + ( $pending->data->renew_duration * 3600 *24);
				$newdate = "'".date("Y-m-d",$time)."'";
			}
		
		
			$db->setQuery( "UPDATE #__adsmanager_ads SET expiration_date = $newdate, date_created = CURDATE(),recall_mail_sent=0,published=1 WHERE id=".(int)$adid);
			$db->query();
			return $adid;
		} else {
		
			if (isset($pending->data->published)) {
				$row->published = $pending->data->published;
			} else {
				$row->published = 1;
			}
			$row->userid = $pending->userid;
		
			foreach($pending->data->fields as $name => $value) {
				if (is_array($value))
					$v = ','.implode(',',$value).',';
				else
					$v = $value;
				$row->$name = $v;
			}

			if ((isset($pending->data->duration))) {
				$ad_duration = $pending->data->duration;
				$db->setQuery( "SELECT * FROM #__paidsystem_duration WHERE published = 1 AND (type='both' OR type='new')");
				$durations = $db->loadObjectList("id");
				if (($ad_duration != 0)&&isset($durations)&&count($durations) > 0)
				{
					$duration = $durations[$ad_duration];
					$delta = $duration->duration;
                    if(strtotime($pending->data->publication_date) < time()){
                        $pending->data->publication_date = date("Y-m-d H:i:s");
                    }
					if ($delta === 0)
						$expiration_date = null;
					else
						$expiration_date = date("Y-m-d H:i:s", strtotime($pending->data->publication_date)+($delta*24*3600));
					$row->expiration_date = $expiration_date;
				}
			}
				
			$row->date_modified = date('Y-m-d H:i:s');
			$row->metadata_description = @$pending->data->metadata_description;
			$row->metadata_keywords = @$pending->data->metadata_keywords;
		
			$adid = $pending->contentid;
				
			// Category
			$query = "DELETE FROM #__adsmanager_adcat WHERE adid = ".(int)$adid;
			$db->setQuery($query);
			$db->query();
			
			
				
			//	$gateway->_save_log(print_r($pending,true));
			foreach($pending->data->categories as $cat) {
				$query = "INSERT INTO #__adsmanager_adcat(adid,catid) VALUES (".(int)$adid.",".(int)$cat.")";
				//$gateway->_save_log($query);
				$db->setQuery($query);
				$db->query();
			}
		
			//Images
			$dir = JPATH_ROOT."/images/com_adsmanager/ads/tmp/";
			$dirfinal = JPATH_ROOT."/images/com_adsmanager/ads/";
		
			$query = "SELECT images FROM #__adsmanager_ads WHERE id = ".(int)$adid;
			$db->setQuery($query);
			$current_images = $db->loadResult($query);
		
			$current_images = @json_decode($current_images);
			if ($current_images == null)
				$current_images = array();
			if (!is_array($current_images))
				$current_images = get_object_vars($current_images);
				
			foreach($pending->data->delimages as $image) {
				JFile::delete($image->image);
				JFile::delete($image->thumbnail);
				@JFile::delete($image->medium);
				foreach($current_images as $key => $img) {
					if ($img->index == $image->index) {
						unset($current_images[$key]);
						break;
					}
				}
			}
				
			if (!is_array($current_images))
				$current_images = get_object_vars($current_images);
			sort($current_images);

			if (ADSMANAGER_SPECIAL == "abrivac") {
				$imgtitle = JFilterOutput::stringURLSafe(getMultiLangText($row->ad_headline));
			} else {
				$imgtitle = JFilterOutput::stringURLSafe($row->ad_headline);
			}
				
			foreach($pending->data->images as $image) {
				$src  =$dir.$image->image;
				$dest =$dirfinal.$imgtitle."_".$adid."_".$image->index.".jpg";
				if (is_file($src)) {
					JFile::move($src,$dest);
					$image->image = $imgtitle."_".$adid."_".$image->index.".jpg";
				} else {
					continue;
				}
					
				$src  =$dir.$image->thumbnail;
				$dest =$dirfinal.$imgtitle."_".$adid."_".$image->index."_t.jpg";
				if (is_file($src)) {
					JFile::move($src,$dest);
					$image->thumbnail = $imgtitle."_".$adid."_".$image->index."_t.jpg";
				} else {
					continue;
				}
		
				$src  =$dir.$image->medium;
				$dest =$dirfinal.$imgtitle."_".$adid."_".$image->index."_m.jpg";
				if (is_file($src)) {
					JFile::move($src,$dest);
					$image->medium = $imgtitle."_".$adid."_".$image->index."_m.jpg";
				} else {
					$image->medium = $imgtitle."_".$adid."_".$image->index."_t.jpg";	
				}
				$current_images[]= $image;
			}
				
			if (@$pending->data->paid->images) {
				foreach($pending->data->paid->images as $image) {
					$src  =$dir.$image->image;
					$dest =$dirfinal.$imgtitle."_".$adid."_".$image->index.".jpg";
					if (is_file($src)) {
						JFile::move($src,$dest);
						$image->image = $imgtitle."_".$adid."_".$image->index.".jpg";
					} else {
						continue;
					}
						
					$src  =$dir.$image->thumbnail;
					$dest =$dirfinal.$imgtitle."_".$adid."_".$image->index."_t.jpg";
					if (is_file($src)) {
						JFile::move($src,$dest);
						$image->thumbnail = $imgtitle."_".$adid."_".$image->index."_t.jpg";
					} else {
						continue;
					}
										
					$src  =$dir.$image->medium;
					$dest =$dirfinal.$imgtitle."_".$adid."_".$image->index."_m.jpg";
					if (is_file($src)) {
						JFile::move($src,$dest);
						$image->medium = $imgtitle."_".$adid."_".$image->index."_m.jpg";
					} else {
						$image->medium = $imgtitle."_".$adid."_".$image->index."_t.jpg";
					}
						
					$current_images[]= $image;
				}
			}
				
			$orderlist = $pending->data->orderimages;
			$newlistimages = array();
			foreach($orderlist as $o) {
				foreach($current_images as $image) {
					if ($image->index == $o)
						$newlistimages[] = $image;
				}
			}
		
			$row->images = json_encode($newlistimages);
			$db->updateObject('#__adsmanager_ads', $row,'id');
				
			//Update Paidsystem Ads Table
				
			$db->setQuery("SELECT * FROM #__paidsystem_ads WHERE id = ".(int)$adid);
			$row = $db->loadObject();
			if ($row == null) {
				$row = new JObject();
				$row->id = $adid;
				$row->highlight = 0;
				$row->featured = 0;
				$row->top = 0;
			}
				
			$highlight = $pending->data->paid->highlight;
			if ($highlight != 0) {
				$db->setQuery( "SELECT * FROM #__paidsystem_highlight WHERE id=".(int)$highlight );
				$highlightduration = $db->loadObject();
				if ($highlightduration->duration == 0)
					$date = null;
				else
					$date = date("Y-m-d H:i:s",time()+$highlightduration->duration*3600*24);
				$row->highlight = 1;
				$row->highlight_date = $date;
			}
				
			$featured = $pending->data->paid->featured;
			if ($featured != 0) {
				$db->setQuery( "SELECT * FROM #__paidsystem_featured WHERE id=".(int)$featured );
				$featuredduration = $db->loadObject();
				if ($featuredduration->duration == 0)
					$date = null;
				else
					$date = date("Y-m-d H:i:s",time()+$featuredduration->duration*3600*24);
				$row->featured = 1;
				$row->featured_date = $date;
			}
				
			$top = $pending->data->paid->top;
			if ($top != 0) {
				$db->setQuery( "SELECT * FROM #__paidsystem_top WHERE id=".(int)$top );
				$topduration = $db->loadObject();
				if ($topduration->duration == 0)
					$date = null;
				else
					$date = date("Y-m-d H:i:s",time()+$topduration->duration*3600*24);
				$row->top = 1;
				$row->top_date = $date;
		
				$db->setQuery( "UPDATE #__adsmanager_ads SET date_created = NOW() WHERE id=".(int)$adid);
				$db->query();
			}
		
			if ($adid != 0) {
				$db->setQuery("DELETE FROM #__paidsystem_ads WHERE id = ".(int)$adid);
				$db->query();
			}
			$ret = $db->insertObject('#__paidsystem_ads', $row);
			return $adid;
		}
	}
}
