<?php
/**
 * @package		Invoicing
 * @copyright	Copyright (C) 2010-2011 JoomPROD.com. All rights reserved.
 * @license GNU General Public License version 3, or later
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

require_once(JPATH_ADMINISTRATOR.'/components/com_invoicing/assets/paymentplugin.php');


class plgInvoicingpaymentPaybox extends InvoicingAbstractPaymentPlugin
{
	public function __construct(&$subject, $config = array())
	{
		if(version_compare(JVERSION, '1.6', 'ge')) {
			$defaultimg = JURI::root().'plugins/invoicingpayment/paypal/paypal/paypal.jpg';
		} else {
			$defaultimg = JURI::root().'plugins/invoicingpayment/paypal/paypal.jpg';
		}	
		
		$config = array_merge($config, array(
			'ppName'		=> 'paybox',
			'ppKey'			=> 'PLG_INVOICINGPAYMENT_PAYBOX_TITLE',
			'ppImage'		=> JURI::root().'plugins/invoicingpayment/paypal/paypal/paypal.jpg')
				);
		
		parent::__construct($subject, $config);
	}
	
	function onInvoicingPaymentDisplay($paymentmethod,$data)
	{	
		if($paymentmethod != $this->ppName) return false;
		
		$item =  FOFModel::getTmpInstance('Invoices', 'InvoicingModel')->getItem($data->invoicing_invoice_id);
		$item->save(array("processor"=>'offline'));
		
		$this->config = new stdClass();
		$this->config->langue = $this->params->get('langue','FRA');
		$this->config->site = $this->params->get('site','5135607');
		$this->config->rang = $this->params->get('rang','01');
		$this->config->identifiant = $this->params->get('identifiant','527115338');
		$this->config->sandbox = $this->params->get('sandbox',0);
		$this->config->devise = $this->params->get('devise',978);
		if ($data->buyer->email != '')
			$this->config->porteur = $data->buyer->email;
		else {
			$this->config->porteur = $this->params->get('porteur','cb@e-locations-vacances.fr');	
		}
		
		
		$PBX_MODE ='4'; // appel en ligne de commande
		$PBX_LANGUE =$this->config->langue;
		$PBX_SITE =$this->config->site; // Site Paybox
		$PBX_RANG =$this->config->rang; // Rang Paybox
		$PBX_IDENTIFIANT =$this->config->identifiant; // Identifiant Paybox
		$PBX_TOTAL = $data->gross_amount * 100; // la valeur en centième d'euros, soit 1000 = 10,00 € *
		$PBX_DEVISE =$this->config->devise;
		$PBX_CMD =$data->invoicing_invoice_id; // Le numéro de la commande *
		$PBX_PORTEUR = $this->config->porteur;
		$PBX_RETOUR = 'amount:M;order:R;trans:T;tran:S;dat:D;error:E;sign:K';
		$PBX_EFFECTUE = JURI::base().'index.php?option=com_invoicing&task=message&msg=complete';
		$PBX_REFUSE = JURI::base().'index.php?option=com_invoicing&task=message&msg=cancel';
		$PBX_ANNULE = JURI::base().'index.php?option=com_invoicing&task=message&msg=cancel';
		$PBX_REPONDRE_A = JURI::base().'index.php?option=com_invoicing&task=process&type=paybox';
		
		// Attention il faut donner le bon chemin vers votre module : modulev2.cgi
		$MOD = dirname(__FILE__).'/modulev2.cgi';
		//echo $MOD;
		
		if ($this->config->sandbox == 1) {
			$url = 'https://preprod-tpeweb.paybox.com/cgi/MYchoix_pagepaiement.cgi';
			$test = 'PBX_PAYBOX='.$url;
		} else {
			$test = '';
		}
		
		//$PBX = ' '.$test.' "PBX_EFFECTUE='.$PBX_EFFECTUE.'" "PBX_REFUSE='.$PBX_REFUSE.'" "PBX_REPONDRE_A='.$PBX_REPONDRE_A.'" "PBX_ANNULE='.$PBX_ANNULE.'" PBX_MODE='.$PBX_MODE.' PBX_LANGUE='.$PBX_LANGUE.' PBX_SITE='.$PBX_SITE.' PBX_RANG='.$PBX_RANG.' PBX_IDENTIFIANT='.$PBX_IDENTIFIANT.' PBX_TOTAL='.$PBX_TOTAL.' PBX_DEVISE='.$PBX_DEVISE.' PBX_CMD='.$PBX_CMD.' PBX_PORTEUR='.$PBX_PORTEUR.' "PBX_RETOUR='.$PBX_RETOUR.'"'; // tout ce texte est sur une seule ligne
		//echo "toto";
		//echo $MOD.$PBX;exit();
		//echo shell_exec($MOD.$PBX);
		$PBX = ' '.$test.' "PBX_EFFECTUE='.$PBX_EFFECTUE.'" "PBX_REFUSE='.$PBX_REFUSE.'" "PBX_REPONDRE_A='.$PBX_REPONDRE_A.'" "PBX_ANNULE='.$PBX_ANNULE.'" PBX_MODE='.$PBX_MODE.' PBX_LANGUE='.$PBX_LANGUE.' PBX_SITE='.$PBX_SITE.' PBX_RANG='.$PBX_RANG.' PBX_IDENTIFIANT='.$PBX_IDENTIFIANT.' PBX_TOTAL='.$PBX_TOTAL.' PBX_DEVISE='.$PBX_DEVISE.' PBX_CMD='.$PBX_CMD.' PBX_PORTEUR='.$PBX_PORTEUR.' "PBX_RETOUR='.$PBX_RETOUR.'"'; // tout ce texte est sur une seule ligne
		//echo $MOD.$PBX;exit();
		
		ob_start();
		echo "<div style='display:none'>";
		echo shell_exec($MOD.$PBX);
		echo "</div>";
		?>
        <div class="chargement_paybox">
        	<span><?php echo JText::_('PAIDSYSTEM_PAYBOX_TITLE')?></span><br>
            <em><?php echo JText::_('PAIDSYSTEM_PAYBOX_WAITING')?></em>
        </div>
        <?php		
        $result = ob_get_clean ();
        return $result;
	}
	
	public function onInvoicingPaymentNotification($paymentmethod, $data) {
		// Check if we're supposed to handle this
		if($paymentmethod != $this->ppName) return false;
		
		$isValid = true;
		
		$query_string = $_SERVER['QUERY_STRING'];
		$query_string = str_replace('option=com_invoicing&task=process&type=paybox&','',$query_string);
		//$data = 'amount=1000&order=9&trans=2524598&tran=1359880&dat=1206&error=00000&sign=ScVcoRkL3cLujOuYLdFW9J2E/lSRE9oLkzcoFmsP0j/XfTNpx6cFn47v/KAZOZz5WbpRPy+MgHsPzI3y5sMZ017fm0FVQnTK+F65tmOu5pZvi8d1HfPgj9d8OXVFs092I1vWR5dsxY/0tSAtVc00W/oCDxqOnYFGMAZSwt06jjU=';
		$signtest = $this->PbxVerSign($query_string, dirname(__FILE__)."/paybox/pubkey.pem", 1 );
		$logData[] = "Signature OK=".$signtest;
	
		$error = JRequest::getVar('error','');
		$order_id = JRequest::getInt('order',0);
		$payment_amount = JRequest::getInt('amount',0) / 100;
		if (($signtest == 1)&&($error == '00000')) {
			$isNetAmount = true;
			if ($this->checkValidity($order_id,$payment_amount,$isNetAmount,$currency) == true) {
				$this->validPayment($order_id,$paymentmethod);
			} else {
				$isValid = false;
			}
		} else {
			$isValid = false;
		}
		
		// Fraud attempt? Do nothing more!
		if(!$isValid) return false;
	}

	protected function LoadKey( $keyfile, $pub=true, $pass='' ) {         // chargement de la clé (publique par défaut)
	    $fp = $filedata = $key = FALSE;                         // initialisation variables
	    $fsize =  filesize( $keyfile );                         // taille du fichier
	    if( !$fsize ) return FALSE;                             // si erreur on quitte de suite
	    $fp = fopen( $keyfile, 'r' );                           // ouverture fichier
	    if( !$fp ) return FALSE;                                // si erreur ouverture on quitte
	    $filedata = fread( $fp, $fsize );                       // lecture contenu fichier
	    fclose( $fp );                                          // fermeture fichier
	    if( !$filedata ) return FALSE;                          // si erreur lecture, on quitte
	    if( $pub )
		$key = openssl_pkey_get_public( $filedata );        // recuperation de la cle publique
	    else                                                    // ou recuperation de la cle privee
		$key = openssl_pkey_get_private( array( $filedata, $pass ));
	    return $key;                                            // renvoi cle ( ou erreur )
	}

	// comme precise la documentation Paybox, la signature doit être
	// obligatoirement en dernière position pour que cela fonctionne
	protected function GetSignedData( $qrystr, &$data, &$sig, $url ) {    // renvoi les donnes signees et la signature

	    $pos = strrpos( $qrystr, '&' );                         // cherche dernier separateur
	    $data = substr( $qrystr, 0, $pos );                     // et voila les donnees signees
	    $pos= strpos( $qrystr, '=', $pos ) + 1;                 // cherche debut valeur signature
	    $sig = substr( $qrystr, $pos );                         // et voila la signature

	    if( $url ) $sig = urldecode( $sig );                    // decodage signature url
	    $sig = base64_decode( $sig );                           // decodage signature base 64
//echo $sig;
	}

	// $querystring = chaine entière retournée par Paybox lors du retour au site (méthode GET)
	// $keyfile = chemin d'accès complet au fichier de la clé publique Paybox

	protected function PbxVerSign( $qrystr, $keyfile, $url ) {            // verification signature Paybox

	    $key = $this->LoadKey( $keyfile );                             // chargement de la cle
	    if( !$key ) return -1;                                  // si erreur chargement cle
	//  penser à openssl_error_string() pour diagnostic openssl si erreur
	    $this->GetSignedData( $qrystr, $data, $sig, $url );            // separation et recuperation signature et donnees
//echo "ti=".$sig;
	    return openssl_verify( $data, $sig, $key );             // verification : 1 si valide, 0 si invalide, -1 si erreur
	}
}
